<?php
define('_ARI_INSTALL_DEF_VERSION', '1.0.0');
define('_ARI_INSTALL_VERSION', '1.9.0');
define('_ARI_INSTALL_VERSION_KEY', 'Version');

$adminPath = dirname(__FILE__) . '/';
require_once ($adminPath . 'kernel/class.AriKernel.php');

AriKernel::import('Utils.Utils');
AriKernel::import('Constants.ClassConstants');
AriKernel::import('Constants.ConstantsManager');
AriKernel::import('GlobalPrefs.GlobalPrefs');
AriKernel::import('Components.AriSmartContent.AriSmartContent');
AriKernel::import('Web.Utils.WebHelper');
AriKernel::import('I18N.I18N');
AriKernel::import('Install.Installer');
AriKernel::import('Controllers.AriSmartContent.PluginController');
AriKernel::import('Controllers.AriSmartContent.PluginInstallerController');
AriKernel::import('Controllers.AriSmartContent.CssController');

$scComp =& AriSmartContentComponent::instance();
$scComp->init(false);

function com_install() 
{
	$option = AriSmartContentComponent::getCodeName();	
	$installer = new AriSmartContentInstall(array('option' => $option));

	$res = $installer->install();

	return nl2br(trim($res));
}

class AriSmartContentInstall extends AriInstallerBase
{
	function installSteps()
	{
		if (!J1_6)
			$this->updateMenuIcons(
				array(
					array('link' => 'option=' . $this->option, 'image' => '../administrator/components/' . $this->option . '/images/arisoft_icon.png'),
					array('link' => 'option=' . $this->option . '&task=plugins', 'image' => '../includes/js/ThemeOffice/categories.png'),
					array('link' => 'option=' . $this->option . '&task=css_list', 'image' => '../includes/js/ThemeOffice/template.png'),
					array('link' => 'option=' . $this->option . '&task=lang_backend', 'image' => '../includes/js/ThemeOffice/language.png'),
					array('link' => 'option=' . $this->option . '&task=lang_frontend', 'image' => '../includes/js/ThemeOffice/language.png'),
					array('link' => 'option=' . $this->option . '&task=diagnostics', 'image' => '../includes/js/ThemeOffice/config.png'),
					array('link' => 'option=' . $this->option . '&task=help', 'image' => '../includes/js/ThemeOffice/help.png'),
					array('link' => 'option=' . $this->option . '&task=faq', 'image' => '../includes/js/ThemeOffice/help.png'),
					array('link' => 'option=' . $this->option . '&task=license', 'image' => '../includes/js/ThemeOffice/license.png'),
				)
			);

		$this->setPermissions(
			array(
				$this->basePath . 'cache/files/css' => 0777,
				$this->adminPath . 'cache/files' => 0777,
				$this->adminPath . 'cache/files/lbackend' => 0777,
				$this->adminPath . 'cache/files/i18n/lbackend' => 0777,
				$this->adminPath . 'cache/files/thumb' => 0777,
				$this->adminPath . 'cache/files/css' => 0777,
				$this->adminPath . 'cache/files/plugins' => 0777
			)
		);

		$modPath = dirname(__FILE__) . '/modules/';
		$plgPath = dirname(__FILE__) . '/plugins/';
		$this->installModule($plgPath . 'arismartcontent');
		
		$database =& JFactory::getDBO();
		if (J1_6)
		{
			$database->setQuery('UPDATE #__extensions SET enabled = 1 WHERE `type` = "plugin" AND `element` = "arismartcontent"');
			$database->query();
		}
		else
		{
			$database->setQuery('UPDATE #__plugins SET enabled = 1 WHERE `type` = "plugin" AND `element` = "arismartcontent"');
			$database->query();
		}		
		
		$this->installModule($modPath . 'mod_arismartcontent');

		$this->_applyUpdates();
		$this->doInstallFile($this->adminPath . 'install/description.xml');
		$this->createSystemDirs();
		$this->installPlugins();
		$this->updateOrdering();
		$this->syncronize();
		
		return true;
	}
	
	function createSystemDirs()
	{
		$pluginDir = AriSmartContentComponent::getPluginRootDir();
		$relPluginDir = $pluginDir;
		$lcPluginDir = strtolower($pluginDir);
		$lcAbsPath = strtolower(JPATH_ROOT);
		$pos = strpos($lcPluginDir, $lcAbsPath);
		if ($pos !== false)
		{
			$relPluginDir = substr($pluginDir, $pos + strlen(JPATH_ROOT)); 
		}
		$relPluginDir = AriFileManager::ensureEndWithSlash($relPluginDir) . 'fake.txt';

		AriFileManager::ensureDirExists($relPluginDir, JPATH_ROOT);
		$typeList = AriConstantsManager::getVar('Type', AriSmartContentPluginControllerConstants::getClassName());
		foreach ($typeList as $key => $value)
		{
			if (!file_exists($pluginDir . $value) || !is_dir($pluginDir . $value))
			{
				AriFileManager::createFolder($pluginDir . $value, 0777);
			}
		}
	}
	
	function installPlugins()
	{
		$my =& JFactory::getUser();

		$userId = $my->get('id');
		$destDir = AriSmartContentComponent::getPluginRootDir();
		$installDir = dirname(__FILE__) . '/install/plugins/';
		$typeList = AriConstantsManager::getVar('Type', AriSmartContentPluginControllerConstants::getClassName());
		$pluginInstaller = new AriSmartContentPluginInstaller();
		foreach ($typeList as $key => $value)
		{
			if (!file_exists($installDir . $value) || !is_dir($installDir . $value)) continue;
			
			$specDir = $installDir . $value . '/';
			$folders = AriFileManager::getFolderList($specDir);
			foreach ($folders as $folder)
			{
				$pluginInstaller->call('installFromDir', $specDir . $folder, $destDir, $userId, true, false);
			}
		}
	}
	
	function syncronize()
	{
		$cssController = new AriSmartContentCssController();
		$pluginController = new AriSmartContentPluginController();
		
		$cssController->call('syncCssFiles');
		$pluginController->call('syncPlugins');
	}
	
	function updateOrdering()
	{
		$database =& JFactory::getDBO();
		
		$query = 'UPDATE #__arisc_plugins SET Ordering = -1 WHERE ClassName IN ("AriSQLTablePlugin","AriCSVTablePlugin")';
		$database->setQuery($query);
		$database->query();
		if ($database->getErrorNum())
		{
			return false;
		}
		
		$query = 'UPDATE #__arisc_plugins SET Ordering = 1 WHERE ClassName IN ("AriJDataTablePlugin", "AriJFlexGridPlugin", "AriJTableSorterPlugin", "AriMooTablePlugin")';
		$database->setQuery($query);
		$database->query();
		if ($database->getErrorNum())
		{
			return false;
		}
		
		$query = 'UPDATE #__arisc_plugins SET Ordering = 2 WHERE ClassName IN ("AriCssTemplatesLoaderPlugin")';
		$database->setQuery($query);
		$database->query();
		if ($database->getErrorNum())
		{
			return false;
		}
		
		return true;
	}
	
	function _applyUpdates()
	{
		$this->_updateTo_1_7_2();
	}
	
	function _updateTo_1_7_2()
	{
		$database =& JFactory::getDBO();
		
		$query = 'ALTER TABLE #__arisc_plugin_params_def CHANGE `ParamType` `ParamType` enum("longtext","text","list","int","float","folder") default NULL';
		$database->setQuery($query);
		$database->query();
	}
}
?>