CREATE TABLE IF NOT EXISTS `#__arisc_plugins` (
  `PluginId` int(11) unsigned NOT NULL auto_increment,
  `PluginName` varchar(100) NOT NULL default '',
  `Type` enum('content','system') NOT NULL,
  `Folder` varchar(255) NOT NULL default '',
  `FileName` varchar(255) NOT NULL,
  `ClassName` varchar(255) NOT NULL,
  `Ordering` int(11) NOT NULL default '0',
  `Status` tinyint(3) unsigned NOT NULL default '1',
  `Author` varchar(255) default NULL,
  `Version` varchar(50) default NULL,
  `Description` text,
  `AuthorUrl` varchar(255) default NULL,
  `AuthorEmail` varchar(255) default NULL,
  `License` varchar(255) default NULL,
  `Copyright` varchar(255) default NULL,
  `CreationDate` varchar(255) default NULL,
  `Created` datetime NOT NULL,
  `CreatedBy` int(11) unsigned NOT NULL default '0',
  `Modified` datetime default NULL,
  `ModifiedBy` int(11) unsigned default NULL,
  `Revision` bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`PluginId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__arisc_plugin_params_def` (
  `ParamId` int(10) unsigned NOT NULL auto_increment,
  `PluginId` int(10) unsigned default NULL,
  `ParamName` varchar(255) NOT NULL,
  `DisplayName` varchar(255) default NULL,
  `Description` text,
  `ParamType` enum('longtext','text','list','int','float','folder') default NULL,
  `Revision` bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ParamId`),
  UNIQUE KEY `ARISC_UPARAMDEF` (`ParamName`,`PluginId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__arisc_plugin_params_def_attrs` (
  `ParamId` int(10) unsigned NOT NULL,
  `AttrName` varchar(255) NOT NULL,
  `AttrValue` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__arisc_plugin_params_def_values` (
  `ParamId` int(10) unsigned NOT NULL,
  `ParamValue` text default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__arisc_plugin_params` (
  `ParamId` int(11) unsigned NOT NULL,
  `ParamValue` text NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__arisc_config` (
  `ParamName` varchar(100) NOT NULL,
  `ParamValue` varchar(255) NOT NULL,
  PRIMARY KEY  (`ParamName`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__arisc_file` (
  `FileId` int(11) unsigned NOT NULL auto_increment,
  `Content` longblob NOT NULL,
  `FileName` varchar(255) NOT NULL,
  `Group` varchar(255) NOT NULL,
  `Size` int(11) unsigned NOT NULL,
  `Description` varchar(255) default NULL,
  `ShortDescription` varchar(255) default NULL,
  `Created` datetime NOT NULL,
  `CreatedBy` int(11) unsigned NOT NULL default '0',
  `Modified` datetime default NULL,
  `ModifiedBy` int(11) unsigned default NULL,
  `Extension` varchar(255) NOT NULL,
  `Height` int(11) unsigned NOT NULL default '0',
  `Width` int(11) unsigned NOT NULL default '0',
  `Flags` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`FileId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__arisc_persistance` (
  `OwnerKey` varchar(80) NOT NULL,
  `UserId` int(11) default NULL,
  `Key` varchar(80) NOT NULL,
  `Name` varchar(80) NOT NULL,
  `Value` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__arisc_css` (
  `CssId` int(11) unsigned NOT NULL auto_increment,
  `FileId` int(11) unsigned NOT NULL,
  `Status` int(11) unsigned NOT NULL default '0',
  `Ordering` int(11) NOT NULL default '0',
  PRIMARY KEY (`CssId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;