<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');

class AriJCSV2TablePlugin extends AriSmartContentPluginBase
{
	var $_idList = array();
	var $_defaultConfig = array(
		'url' => '',
		'sortable' => true,
		'nowloadingMsg' => 'now loading...',
		'removeDoubleQuote' => true,
		'select' => '*',
		'use' => '');
	
	function __construct()
	{
		parent::__construct('arijcsv2table');
	}
	
	function processContent($published, &$row, &$params, $page = 0)
	{
		parent::processContent($published, $row, $params, $page);
		
		$this->runtimeJsDeclaration();
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$output = '';
		
		$config = $this->getConfig($attrs);
		if (empty($config['url'])) return $output;

		$id = uniqid('jc2t_', false);
		if (!empty($config['use']))
		{ 
			$canvasId = $id . '_cv';
			$this->loadJQChart();
			$output .= sprintf('<canvas id="%s" style="height: 200px;"></canvas>', $canvasId);
			$config['use'] .= '#' . $canvasId; 
		}
		
		$this->_idList[$id] = $config;

		return $output . sprintf('<div id="%1$s"></div>', $id);
	}
	
	function getConfig($attrs)
	{
		$config = array();
		
		foreach ($this->_defaultConfig as $key => $defValue)
		{
			$val = $this->getValueByDefSample($key, $attrs, $defValue);
			if ($val != $defValue)
			{
				if ($key == 'select') $val = explode(',', $val);
				$config[$key] = $val;
			}
		}
		
		return $config;
	}
	
	function loadJQChart()
	{
		static $loaded = false;
		
		if ($loaded) return ;
		$loaded = true;
		
		$canvasLoader = new AriIECanvasLoaderPlugin();
		$canvasLoader->load();

		$rootPath = $this->getRootPath();
		$urlPath = AriUtils::absPath2Url($rootPath);

		AriDocumentHelper::includeJsFile($urlPath . 'jquery.jqchart.js');
	}
	
	function jsDeclaration()
	{
		$jqueryLoader = new AriJQueryLoaderPlugin();
		$jqueryLoader->load();

		$rootPath = $this->getRootPath();
		$urlPath = AriUtils::absPath2Url($rootPath);
		
		AriDocumentHelper::includeJsFile($urlPath . 'jquery.csv2table.js');
		
		$script = sprintf('<script type="text/javascript">if (typeof(jQuery) != "undefined" && typeof(jQuery.csv2table) != "undefined") { jQuery.csv2table.loadImg = "%s";jQuery.csv2table.sortDImg = "%s";jQuery.csv2table.sortAImg = "%s"; }</script>',
			$urlPath . 'img/icon-loadinfo.gif',
			$urlPath . 'img/icon-d.gif',
			$urlPath . 'img/icon-a.gif');
		AriDocumentHelper::includeCustomHeadTag($script);
	}
	
	function runtimeJsDeclaration()
	{
		$idList = $this->_idList;
		if (empty($idList)) return ;
		
		$script = '<script type="text/javascript">';
		foreach ($idList as $id => $config)
		{
			$url = $config['url'];
			unset($config['url']); 
			$script .= sprintf('jQuery(document).ready(function($) { $("#%1$s").csv2table("%2$s"%3$s); });', 
				$id,
				$url,
				!empty($config) ? ',' . AriJSONHelper::encode($config) : '');
		}
		$script .= '</script>';
		
		AriDocumentHelper::includeCustomHeadTag($script);
	}
	
	function getRootPath()
	{
		return dirname(__FILE__) . '/js/';
	}
}
?>