<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');

class AriJTruncatePlugin extends AriSmartContentPluginBase
{
	var $_idList = array();
	var $_defaultConfig = array(
		'length' => 300,
		'minTrail' => 20,
		'moreText' => 'more',
		'lessText' => 'less',
		'ellipsisText' => '...',
		'moreAni' => 0,
		'lessAni' => 0);
	
	function __construct()
	{
		parent::__construct('arijtruncate');
	}
	
	function processContent($published, &$row, &$params, $page = 0)
	{
		parent::processContent($published, $row, $params, $page);
		
		$this->runtimeJsDeclaration();
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$id = uniqid('jtrun_', false);
		$config = $this->getConfig($attrs, $this->_defaultConfig);
		
		$wtagAttrs = array('id' => $id);
		$wrapTag = $this->getValueByDefSample('wrapTag', $attrs, 'div');
		$this->_idList[$id] = $config;
		
		return sprintf('<%1$s%3$s>%2$s</%1$s>',
			$wrapTag,
			$content,
			AriHtmlHelper::getAttrStr($wtagAttrs));
	}
	
	function getConfig($attrs, $defConfig)
	{
		$config = array();
		
		foreach ($defConfig as $key => $defValue)
		{
			$val = $this->getValueByDefSample($key, $attrs, $defValue);
			if ($val != $defValue)
			{
				$config[$key] = $val;
			}
		}

		return $config;
	}
	
	function jsDeclaration()
	{
		$jqueryLoader = new AriJQueryLoaderPlugin();
		$jqueryLoader->load();

		AriDocumentHelper::includeJsFile(AriUtils::absPath2Url($this->getRootPath() . 'jquery.jtruncate.pack.js'));
	}

	function runtimeJsDeclaration()
	{
		$idList = $this->_idList;
		if (empty($idList)) return ;
		
		$script = '<script type="text/javascript">';
		foreach ($idList as $id => $config)
		{
			$script .= sprintf('jQuery(document).ready(function($) { $("#%1$s").jTruncate(%2$s); });', 
				$id,
				!empty($config) ? AriJSONHelper::encode($config) : '');
		}
		$script .= '</script>';

		AriDocumentHelper::includeCustomHeadTag($script);
	}

	function getRootPath()
	{
		return dirname(__FILE__) . '/js/';
	}
}
?>