<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');

class AriLinkifierPlugin extends AriSmartContentPluginBase
{
	var $_defaultConfig = array(
		'target' => '_blank');
	
	function __construct()
	{
		parent::__construct('arilinkifier');
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$config = $this->getConfig($attrs, $this->_defaultConfig);
		$content = $this->linkifyContent($content, $config['target']);
		
		return $content;
	}
	
	function linkifyContent($content, $target = '_blank')
	{
		return preg_replace_callback(
			'~(?:([^\s@]+@[^\s]+)|(?:(https?|ftp)://)?([^\s\./]+(?:\.[^\s\./]+)+(?:/[^\s]*)?))(?<![\.,])~i',
	//		'~([^\s@]+@[^\s]+)|(?:(https?|ftp)://)?([^\s\./]+(?:\.[^\s\./]+)+(?:/[^\s]*)?)~i', 
			create_function(
				'$matches',
				'$scheme = !empty($matches[2]) ? $matches[2] : "http";' . 
				'$url = isset($matches[3]) ? ("${scheme}://" . $matches[3]) : ("mailto:" . $matches[1]);' .
				'$clearUrl = isset($matches[3]) ? $matches[3] : $matches[1];' .
				'$url_escaped = htmlentities($url);' .
				'return "<a href=\"$url_escaped\" target=\"' . $target . '\">$clearUrl</a>";'),
				$content);
	}
	
	function getConfig($attrs, $defConfig)
	{
		$config = array();
		
		foreach ($defConfig as $key => $defValue)
		{
			$val = $this->getValueByDefSample($key, $attrs, $defValue);
			$config[$key] = $val;
		}

		return $config;
	}
}
?>