<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');

class AriMooTablePlugin extends AriSmartContentPluginBase
{
	var $_idList = array();
	var $_defaultConfig = array(
		'height' => '90%',
		'resizable' => false,
		'sortable' => false,
		'useloading' => true,
		'position' => 'inside',
		'section' => 20,
		'delay' => 10,
		'fade' => false,
		'footer' => false,
		'minColWidth' => 50,
		'decimal' => '.',
		'protected' => '',
		'filter' => false
	);

	function __construct()
	{
		parent::__construct('arimootable');
	}
	
	function processContent($published, &$row, &$params, $page = 0)
	{
		parent::processContent($published, $row, $params, $page);
		
		$this->runtimeJsDeclaration();
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$config = $this->getConfig($attrs, $this->_defaultConfig);
		
		$id = uniqid('amt_', false);
		$this->_idList[$id] = $config;

		return sprintf('<div id="%2$s">%1$s</div>',
			$content,
			$id);
	}
	
	function getConfig($attrs, $defConfig)
	{
		$config = array();
		
		foreach ($defConfig as $key => $defValue)
		{
			$val = $this->getValueByDefSample($key, $attrs, $defValue);
			if ($val != $defValue) $config[$key] = $val;
		}
		
		return $config;
	}
	
	function runtimeJsDeclaration()
	{
		$idList = $this->_idList;
		if (empty($idList)) return ;
		
		$script = '<script type="text/javascript">';
		foreach ($idList as $id => $config)
		{
			$script .= sprintf('window.addEvent("domready", function() { var tbl = $$("#%1$s table"); if (!tbl) return ; for (var i = 0; i < tbl.length;i++) { if (!tbl[i].id) tbl[i].id = "%1$s_t_" + i; new MooTable(tbl[i]%2$s);}; });', 
				$id,
				!empty($config) ? ',' . AriJSONHelper::encode($config) : '');
		}
		$script .= '</script>';
		
		echo $script;
	}
	
	function jsDeclaration()
	{
		$mootoolsLoader = new AriMootoolsLoaderPlugin();
		$mootoolsLoader->load();

		$rootPath = $this->getRootPath();
		
		AriDocumentHelper::includeCssFile(AriUtils::absPath2Url($rootPath . 'mootable.css'));
		AriDocumentHelper::includeJsFile(AriUtils::absPath2Url($rootPath . 'mootable.js'));
	}

	function getRootPath()
	{
		return dirname(__FILE__) . '/js/';
	}
}
?>