<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');
AriKernel::import('Components.AriSmartContent.Plugins.HtmlTablePlugin');
AriKernel::import('Components.AriSmartContent.Plugins.ConnectionStringPlugin');

class AriSQLTablePlugin extends AriSmartContentPluginBase
{
	var $_defaultConfig = array(
		'saveTags' => false);
	
	function __construct()
	{
		parent::__construct('arisqltable');
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$queryPlugin = new AriSQLTableQueryPlugin();
		$queryPlugin->processContent($this->_published, $content, $this->_processParams, $this->_page);
		$results = $queryPlugin->getResults();

		if (empty($results) || empty($results[0])) return '';
		
		$htmlTablePlugin = new AriSmartHtmlTablePlugin(
			$this->_tag, 
			'arisqltablecolumns', 
			'arisqltablecolumn', 
			'arisqltablecolumnspan',
			$this->getParametersKey());
		$table = $htmlTablePlugin->replaceCallback($results[0], $attrs, $content);

		return $table;
	}
	
	function getConfig($attrs)
	{
		$config = array();
		
		foreach ($this->_defaultConfig as $key => $defValue)
		{
			$config[$key] = $this->getValueByDefSample($key, $attrs, $defValue);
		}

		return $config;
	}
}

class AriSQLTableQueryPlugin extends AriSmartContentPluginBase
{
	var $_results = array();
	var $_conn;
	
	function __construct()
	{
		$this->setParametersKey('AriSQLTablePlugin');

		parent::__construct('arisqltablequery');
	}

	function getResults()
	{
		return $this->_results;
	}

	function processContent($published, &$row, &$params, $page = 0)
	{
		$connStringPlugin = new AriSmartConnectionStringPlugin(null, 'AriSQLTablePlugin');
		$connStringPlugin->processContent($published, $row, $params, $page);
		$this->_conn =& $connStringPlugin->getConnection();

		$retVal = parent::processContent($published, $row, $params, $page);
		if ($this->_conn && $this->_conn->IsConnected()) $this->_conn->Close();
		
		return $retVal;
	}
	
	function replaceCallback($attrs, $content = '')
	{
		global $ADODB_FETCH_MODE;

		$saveTags = $this->getValueByDefSample('saveTags', $attrs, false);
		$query = $content;
		if (!$saveTags)
		{
			$query = trim(strip_tags($query));
		}
		else
		{
			$query = trim($query);
		}

		$query = str_replace(array('&gt;', '&lt;', '&#039;'), array('>', '<', '\''), $query);

		$result = null;
		if ($this->_conn)
		{
			$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
			$result = $this->_conn->GetArray($query);
			if ($this->_conn->ErrorNo())
			{
				$result = null;
			}
		}
		else if (is_null($this->_conn))
		{
			$database =& JFactory::getDBO();
			$database->setQuery($query);
			$result = $database->loadAssocList();
			if ($database->getErrorNum())
			{
				$result = null;
			}
		}

		if (!empty($result)) $this->_results[] = $result;
		return '';
	}
}
?>