<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Controllers.AriSmartContent.PluginController');
AriKernel::import('Components.AriSmartContent.Plugins.LoaderPluginBase');
AriKernel::import('File.FileManager');

class AriJQueryUILoaderPlugin extends AriLoaderPluginBase
{
	var $LINK_ID = 'lnk_arijuitheme';
	var $_systemName = 'arijquiloader';
	
	function getLinkId($version = null)
	{
		$linkId = $this->LINK_ID;
		$version = $this->getVersion($version);
		if (empty($version)) return $linkId;
		
		return $linkId . '_' . substr(md5($version), 0, 12);
	}

	function getVersion($version)
	{
		if (is_null($version)) 
		{
			$params = $this->getParameters();
			$version = $params->get('jQueryUIVersion', null);
		}
		
		return $version;
	}
	
	function load($module = 'ui.core', $theme = null, $version = null)
	{
		static $loadedModule = array();

		$params = $this->getParameters();
		$needLoad = AriUtils::parseValueBySample($params->get('needLoad', true), true);
		if (!$needLoad) return true;
		
		$version = $this->getVersion($version);
		
		$jqueryLoader = new AriJQueryLoaderPlugin();
		$jqueryLoader->load(); 
		if ($module != 'ui.core') $this->load('ui.core', $theme, $version);
		
		$this->loadTheme($theme, $version);

		return parent::load($module, $version);
	}
	
	function loadTheme($theme = null, $version = null)
	{
		static $loadedTheme = array();
		
		$version = $this->getVersion($version);
		if (is_null($theme))
		{
			$theme = $this->getDefaultTheme($version);
		}
		
		$jsPath = $this->getRootPath();

		if (isset($loadedTheme[$version]) && in_array($theme, $loadedTheme[$version])) return true;
				
		$themePath = $jsPath . $version . '/themes/' . $theme . '/';
		$filePath = $themePath . $theme . '.all.css';

		if (!@file_exists($filePath)) return false;

		AriDocumentHelper::includeCssFile(AriUtils::absPath2Url($filePath), 'text/css', null, array('id' => $this->getLinkId($version)));

		if (!isset($loadedTheme[$version])) $loadedTheme[$version] = array();
		$loadedTheme[$version][] = $theme;
		
		return true;
	}

	function getThemeList($version = null)
	{
		static $themes = array();
		
		$version = $this->getVersion($version);
		if (!isset($themes[$version]))
		{
			$themes[$version] = array();
			$version = $this->getVersion($version);
			$jsPath = $this->getRootPath();
			
			$themesPath = $jsPath . $version . '/themes/';
			$themeFolders = AriFileManager::getFolderList($themesPath);
			
			if (empty($themeFolders)) return $themes[$version];
			
			foreach ($themeFolders as $themeFolder)
			{
				$themes[$version][$themeFolder] = ucfirst($themeFolder);
			}
			/*
			$systemType = AriConstantsManager::getVar('Type.System', AriSmartContentPluginControllerConstants::getClassName());
			$pc = new AriSmartContentPluginController();
			$attrs = $pc->getClientPluginAttrs(get_class($this), $systemType);
			
			if (isset($attrs['theme']))
			{
				$i = 0;
				$themeAttr = $attrs['theme'];
				$value = AriUtils::getParam($themeAttr, 'value_' . $i, null);
				$text = AriUtils::getParam($themeAttr, 'option_' . $i, null);
				while (!is_null($value) || !is_null($text))
				{
					if (is_null($value)) $value = $text;
					else if (is_null($text)) $text = $value;
			
					$themes[$value] = $text;
			
					++$i;
					$value = AriUtils::getParam($themeAttr, 'value_' . $i, null);
					$text = AriUtils::getParam($themeAttr, 'option_' . $i, null);
				}
			}*/
		}
		
		return $themes[$version];
	}
	
	function getDefaultTheme($version)
	{
		$version = $this->getVersion($version); 
		$params = $this->getParameters();

		return $params->get('theme' . str_replace('.', '', $version), 'flora');
	}
	
	function getThemeUrl($theme, $version = null)
	{
		$version = $this->getVersion($version);

		$jsPath = $this->getRootPath();
		$themePath = $jsPath . $version . '/themes/' . $theme . '/' . $theme . '.all.css';

		return AriUtils::absPath2Url($themePath);
	}
	
	function getRootPath()
	{
		return dirname(__FILE__) . '/js/';
	}
	
	function getFileModuleName($module)
	{
		return $module . '.packed.js';
	}
}
?>