<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Controllers.FileController');

class AriFileCache 
{
	function recacheFile($cacheDir, $fileGroup, $fileId, $binary = true, $fileTable = null)
	{
		AriFileCache::cacheFile($cacheDir, $fileGroup, $fileId, null, $binary, true, $fileTable);
	}
	
	function recacheFileWithName($cacheDir, $fileGroup, $fileId, $binary = true, $fileTable = null)
	{
		AriFileCache::cacheFileWithName($cacheDir, $fileGroup, $fileId, null, $binary, true, $fileTable);
	}
	
	function cacheFile($cacheDir, $fileGroup, $fileId, $ext, $binary = true, $recache = false, $fileTable = null)
	{
		AriFileCache::_cacheFile($cacheDir, $fileGroup, $fileId, $ext, null, false, $binary, $recache, $fileTable);
	}
	
	function cacheFileWithName($cacheDir, $fileGroup, $fileId, $fileName = null, $binary = true, $recache = false, $fileTable = null)
	{
		AriFileCache::_cacheFile($cacheDir, $fileGroup, $fileId, $fileName, true, $binary, $recache, $fileTable);
	}
	
	function _cacheFile($cacheDir, $fileGroup, $fileId, $ext = null, $fileName = null, $useFileName = false, $binary = true, $recache = false, $fileTable = null)
	{
		$cacheDir .= $fileGroup . '/';
		if (!$recache)
		{
			if (!is_null($fileName) && file_exists($cacheDir . $fileName)) return ;
			if (!is_null($ext) && file_exists($cacheDir . $fileId . '.' . $ext)) return ;
		}

		$fileTable = AriFileCache::_getFileTable($fileTable);
		$fileController = new AriFileController($fileTable);
		$file = $fileController->call('getFile', $fileId, $fileGroup);
		if (!empty($file))
		{
			$content = $file->Content;
			$fileName = $cacheDir;
			$fileName .= ($useFileName && $file->FileName)
				? $file->FileName
				: $fileId . ($file->Extension ? '.' . $file->Extension : '');
			if ($binary)
			{
				AriFileCache::saveBinaryFile($content, $fileName);
			}
			else 
			{
				AriFileCache::saveTextFile($content, $fileName);
			}
		}
	}
	
	function _getFileTable($fileTable)
	{
		if (empty($fileTable)) $fileTable = AriGlobalPrefs::getFileTable();
		
		return $fileTable;
	}
	
	function saveBinaryFile($content, $fileName)
	{
		return AriFileCache::_saveFile($content, $fileName, 'b');
	}
	
	function saveTextFile($content, $fileName)
	{
		return AriFileCache::_saveFile($content, $fileName);
	}
	
	function _saveFile($content, $fileName, $mode = 't')
	{
		$ret = true;
		
		$handle = fopen($fileName, 'w+' . $mode);
		if (!$handle)
		{
			$ret = false;
		}
		else
		{
			if (fwrite($handle, $content) === false)
			{
				$ret = false;
			}
			fclose($handle);
		}

		return $ret;
	}
}
?>
