<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Mambot.GenericMambotBase');
AriKernel::import('Mambot.MambotProcessHelper');
AriKernel::import('Controllers.AriSmartContent.PluginController');
AriKernel::import('Web.HtmlHelper');

class AriSmartContentMambot extends AriGenericMambotBase
{
	var $_pluginController;
	
	function __construct()
	{		
		$this->_pluginController = new AriSmartContentPluginController();
		
		parent::__construct();
	}
	
	function modifyContent($content, &$params)
	{
		$this->_includeSystemPlugins();
		$content = $this->_processContentByPlugins($content, $params);
		
		return $content;
	}
	
	function _loadPlugins()
	{
		static $plugins = null;
		
		if (is_null($plugins))
		{
			$plugins = $this->_pluginController->call('getClientPluginList');
			if (empty($plugins)) $plugins = array();
		}
		
		return $plugins;
	}
	
	function _includeSystemPlugins()
	{
		static $loaded = false;
		
		if ($loaded) return;
		
		$loaded = true;
		
		$systemType = AriConstantsManager::getVar('Type.System', AriSmartContentPluginControllerConstants::getClassName());
		$plugins = $this->_loadPlugins();
		if (empty($plugins[$systemType])) return ;
		
		$systemPlugins = $plugins[$systemType];
		$pluginRootDir = AriSmartContentComponent::getPluginRootDir() . 'system/';
		foreach ($systemPlugins as $systemPlugin)
		{
			$pluginPath = $pluginRootDir . $systemPlugin->Folder . '/' . ($systemPlugin->FileName);
			if (!@file_exists($pluginPath)) continue;
			
			require_once $pluginPath; 
		}
	}
	
	function _processContentByPlugins($content, &$params, $plugins = null)
	{		
		$statusList = AriConstantsManager::getVar('Status', AriSmartContentPluginControllerConstants::getClassName());
		$typeList = AriConstantsManager::getVar('Type', AriSmartContentPluginControllerConstants::getClassName());
		
		if (is_null($plugins))
		{ 
			$plugins = $this->_loadPlugins();
			$plugins = isset($plugins[$typeList['Content']]) ? $plugins[$typeList['Content']] : null;
		}

		if (empty($plugins)) return $content;
		
		$pluginRootDir = AriSmartContentComponent::getPluginRootDir() . 'content/';
		$existingPlugins = array();
		foreach ($plugins as $plugin)
		{
			$pluginPath = $pluginRootDir . $plugin->Folder . '/' . ($plugin->FileName);
			if (!@file_exists($pluginPath)) continue;
			
			require_once $pluginPath; 

			$existingPlugins[] = $plugin;
		}
		
		foreach ($existingPlugins as $plugin)
		{
			$published = ($plugin->Status == $statusList['Active']);
			$className = $plugin->ClassName;
			$pluginInstant = new $className();
			$pluginInstant->processContent($published, $content, $params, 0);
		}
		
		return $content;
	}
}
?>