<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginHandlerBase');
AriKernel::import('File.FileManager');
AriKernel::import('Image.Asido.AsidoHelper');

class AriImagePluginHandler extends AriSmartContentPluginHandlerBase
{
	function showThumbnailHttpHandler()
	{
		$src = AriRequest::getParam('src');
		
		$data = '';
		$imgPath = AriUtils::resolvePath($src); 
		if (@is_readable($imgPath))
		{
			AriAsidoHelper::init();

			$width = intval(AriRequest::getParam('w', 0));
			$height = intval(AriRequest::getParam('h', 0));
			$ts = intval(AriRequest::getParam('ts', 0));
			$path_parts = pathinfo($imgPath);
			
			$newName = sprintf('%s_%s_%s.%s',
				md5($imgPath),
				$width,
				$height,
				$path_parts['extension']); 
			
			$cacheDir = AriGlobalPrefs::getCacheDir();
			$cacheGroup =  AriConstantsManager::getVar('FileGroup.Thumb', AriSmartContentComponent::getCodeName());
			$newFilePath = $cacheDir . $cacheGroup . '/' . $newName;
			
			if (!@file_exists($newFilePath) ||
				filemtime($newFilePath) < $ts ||
				filemtime($newFilePath) < filemtime($imgPath))
			{
				$img = asido::image($imgPath, $newFilePath);
				
				if (!$width)
				{
					Asido::height($img, $height);
				}
				else if (!$height)
				{
					Asido::width($img, $width);
				}
				else
				{
					Asido::resize($img, $width, $height, ASIDO_RESIZE_STRETCH);
				}
	
				$img->save(ASIDO_OVERWRITE_ENABLED);
			}

			$oldMQR = get_magic_quotes_runtime();
			set_magic_quotes_runtime(0);
			
			$data = file_get_contents($newFilePath);

			set_magic_quotes_runtime($oldMQR);
		}

		$type = 'image/xyz';
		if (function_exists('getimagesize'))
		{
			$info = @getimagesize($newFilePath);
			if (!empty($info['mime'])) $type = $info['mime']; 
		}

		AriResponse::sendBinaryRespose($data, $type);
	}	
}

$handlers = new AriImagePluginHandler();
$handlers->registerHandlers();
?>