<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');
AriKernel::import('Articles.ArticleSearchStruct');
AriKernel::import('Articles.ArticleController');

class AriSmartContentArticleProviderPlugin extends AriSmartContentPluginBase
{
	var $_articleList;

	function __construct($tag = 'ariarticleprovider', $paramKey = null)
	{
		if (!is_null($paramKey)) $this->setParametersKey($paramKey);
		if (is_null($tag)) $tag = 'ariarticleprovider';
		
		parent::__construct($tag);
	}
	
	function getArticleList()
	{
		return $this->_articleList;
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$searchParams = $this->getSearchParams($attrs);
		$parseTag = $this->getValueByDefSample('articleParseTag', $attrs, '');
		
		$ac = new AriJoomlaArticleController();
		$articleList = $ac->getArticleList($searchParams, $parseTag);
		
		$this->_articleList = $articleList;
		
		return '';
	}
	
	function getSearchParams($attrs)
	{
		$searchParams = new AriJoomlaArticleSearchStruct();

		$sectionId = $this->getValueByDefSample('articleSecId', $attrs, '');
		$sectionId = explode(',', $sectionId);

		$categoryId = $this->getValueByDefSample('articleCatId', $attrs, '');
		$categoryId = explode(',', $categoryId);

		$creatorId = $this->getValueByDefSample('articleCreatorId', $attrs, '');
		$creatorId = explode(',', $creatorId);
		
		$includedArticles = $this->getValueByDefSample('includedArticle', $attrs, '');
		$includedArticles = explode(',', $includedArticles);
		
		$excludedArticles = $this->getValueByDefSample('excludedArticle', $attrs, '');
		$excludedArticles = explode(',', $excludedArticles);

		$excludeSection = $this->getValueByDefSample('articleExcludeSection', $attrs, $searchParams->getExcludeSection());			
		$excludeCategory = $this->getValueByDefSample('articleExcludeCategory', $attrs, $searchParams->getExcludeCategory()); 
		$excludeCreator = $this->getValueByDefSample('articleExcludeCreator', $attrs, $searchParams->getExcludeCategory());
		$includeSubCategory = $this->getValueByDefSample('articleIncludeSubCategory', $attrs, $searchParams->getExcludeCategory());

		$randomize = $this->getValueByDefSample('articleRandomize', $attrs, $searchParams->getIsRandom()); 
		$itemCount = $this->getValueByDefSample('articleItemCount', $attrs, $searchParams->getItemCount());
		$sortField = $this->getValueByDefSample('articleSortField', $attrs, $searchParams->getSortField());		
		$sortDir = $this->getValueByDefSample('articleSortDir', $attrs, $searchParams->getSortDir());

		$searchParams->setSectionIdList($sectionId);
		$searchParams->setExcludeSection($excludeSection);
		
		$searchParams->setCategoryIdList($categoryId);
		$searchParams->setExcludeCategory($excludeCategory);
		
		$searchParams->setCreatorIdList($creatorId);
		$searchParams->setExcludeCreator($excludeCreator);
		
		$searchParams->setIncludeArticleIdList($includedArticles);
		$searchParams->setExcludeArticleIdList($excludedArticles);
		
		$searchParams->setIncludeSubCategory($includeSubCategory);
		$searchParams->setIsRandom($randomize);
		$searchParams->setItemCount($itemCount);
		$searchParams->setSortField($sortField);
		$searchParams->setSortDir($sortDir);
		
		return $searchParams;
	}
}
?>