<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');
AriKernel::import('DB.ADODBLite');

class AriSmartConnectionStringPlugin extends AriSmartContentPluginBase
{
	var $_conn = null;
	
	function __construct($tag = 'ariconnectionstring', $paramKey = null)
	{
		if (!is_null($paramKey)) $this->setParametersKey($paramKey);
		if (is_null($tag)) $tag = 'ariconnectionstring';
		
		parent::__construct($tag);
	}
	
	function &getConnection()
	{
		return $this->_conn;
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$dbHost = $this->getValueByDefSample('dbHost', $attrs, 'localhost');
		$dbName = $this->getValueByDefSample('dbName', $attrs, '');
		$dbUser = $this->getValueByDefSample('dbUser', $attrs, 'root');
		$dbPass = $this->getValueByDefSample('dbPass', $attrs, '');
		$dbType = $this->getValueByDefSample('dbType', $attrs, 'mysql');
		$persistent = $this->getValueByDefSample('persistent', $attrs, false);
		$charsetName = $this->getValueByDefSample('charsetName', $attrs, '');

		$db = false;
		if (AriADODBLite::isAllowedDbType($dbType) && !empty($dbHost) && !empty($dbName))
		{
			$db = $persistent
				? AriADODBLite::createPConnection($dbHost, $dbUser, $dbPass, $dbName, null, $dbType)
				: AriADODBLite::createNConnect($dbHost, $dbUser, $dbPass, $dbName, null, $dbType);
			if (!$db || !$db->IsConnected()) $db = false;
		}

		if ($db && $charsetName)
		{
			$db->Execute('SET NAMES "' . $charsetName . '"');
		}

		$this->_conn =& $db;
		
		return '';
	}
}
?>