<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

class AriSmartContentPluginHandlerRegister extends AriObject
{
	function &getHandlerStore()
	{
		static $store = null;
		
		if ($store == null)
		{
			$store = new AriSmartContentPluginHandlerStore();
		}
		
		return $store;
	}
	
	function addHandler(&$handler, $handlerName)
	{
		$store =& AriSmartContentPluginHandlerRegister::getHandlerStore();
		$store->addHandler($handler, $handlerName);
	}
	
	function &getHandler($hash)
	{
		$store =& AriSmartContentPluginHandlerRegister::getHandlerStore();
		$handler =& $store->getHandler($hash);
		
		return $handler;
	}
	
	function getHandlerUrl(&$handler, $handlerName, $params = null)
	{
		if (!is_array($params)) $params = array();
		
		$params['option'] = AriSmartContentComponent::getCodeName();
		$params['task'] = 'plugin_handler';
		$params['handler'] = $handler->getHandlerCode($handlerName);

		$url = JURI::root(true) . '/index.php?';
		
		$uParams = array();
		foreach ($params as $key => $value)
		{
			$uParams[] = $key . '=' . urlencode($value);
		}
		$url .= join('&', $uParams);
		
		return $url;
	}
	
	function runHandler($hash)
	{
		$handler =& AriSmartContentPluginHandlerRegister::getHandler($hash);

		$result = '';
		if (!is_null($handler))
		{
			$result = call_user_func($handler);
		}
		
		return $result;
	}
}

class AriSmartContentPluginHandlerStore extends AriObject
{
	var $_register;
	
	function addHandler(&$handler, $handlerName)
	{
		$hash = $handler->getHandlerCode($handlerName); 
		$h = array(&$handler, $handlerName);

		$this->_register[$hash] =& $h;
	}
	
	function &getHandler($hash)
	{
		$handler = null;
		if (isset($this->_register[$hash]))
		{
			$handler =& $this->_register[$hash];
		}
		
		return $handler;
	}
}
?>