<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');
AriKernel::import('VirtueMart.VirtueMartController');

class AriSmartContentVirtueMartProductProviderPlugin extends AriSmartContentPluginBase
{
	var $_productList;

	function __construct($tag = 'ariproductprovider', $paramKey = null)
	{
		if (!is_null($paramKey)) $this->setParametersKey($paramKey);
		if (is_null($tag)) $tag = 'ariproductprovider';
		
		parent::__construct($tag);
	}
	
	function getProductList()
	{
		return $this->_productList;
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$searchParams = $this->getSearchParams($attrs);
		$parseTag = $this->getValueByDefSample('productParseTag', $attrs, '');
		
		$ac = new AriVirtueMartController();
		$productList = $ac->getProductList($searchParams, $parseTag);
		
		$this->_productList = $productList;
		
		return '';
	}
	
	function getSearchParams($attrs)
	{
		$searchParams = new AriProductSearchStruct();

		$categoryId = $this->getValueByDefSample('productCategoryId', $attrs, $searchParams->getCategoryIdList());
		$categoryId = explode(',', $categoryId);

		$randomize = $this->getValueByDefSample('productRandomize', $attrs, $searchParams->getIsRandom()); 
		$itemCount = $this->getValueByDefSample('productItemCount', $attrs, $searchParams->getItemCount());
		$sortField = $this->getValueByDefSample('productSortField', $attrs, $searchParams->getSortField());		
		$sortDir = $this->getValueByDefSample('productSortDir', $attrs, $searchParams->getSortDir());
		$isPublished = $this->getValueByDefSample('isPublished', $attrs, $searchParams->getIsPublished());

		$searchParams->setCategoryIdList($categoryId);
		$searchParams->setIsRandom($randomize);
		$searchParams->setItemCount($itemCount);
		$searchParams->setSortField($sortField);
		$searchParams->setSortDir($sortDir);
		$searchParams->setIsPublished($isPublished);
		
		return $searchParams;
	}
}
?>