<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Controllers.AriSmartContent.PluginController');
AriKernel::import('Components.AriSmartContent.Web.PluginParamControls.FloatParamWebControl');
AriKernel::import('Components.AriSmartContent.Web.PluginParamControls.IntParamWebControl');
AriKernel::import('Components.AriSmartContent.Web.PluginParamControls.ListParamWebControl');
AriKernel::import('Components.AriSmartContent.Web.PluginParamControls.LongTextParamWebControl');
AriKernel::import('Components.AriSmartContent.Web.PluginParamControls.TextParamWebControl');
AriKernel::import('Components.AriSmartContent.Web.PluginParamControls.FolderParamWebControl');

$paramTypeList = AriConstantsManager::getVar('ParamType', AriSmartContentPluginControllerConstants::getClassName());

$GLOBALS['_ARI_SMART_CONTENT_PPARAM_MAPPING'] = array(
	$paramTypeList['Text'] => 'AriSmartContentTextPluginParamWebControl',
	$paramTypeList['LongText'] => 'AriSmartContentLongTextPluginParamWebControl',
	$paramTypeList['Integer'] => 'AriSmartContentIntPluginParamWebControl',
	$paramTypeList['Float'] => 'AriSmartContentFloatPluginParamWebControl',
	$paramTypeList['List'] => 'AriSmartContentListPluginParamWebControl',
	$paramTypeList['Folder'] => 'AriSmartContentFolderPluginParamWebControl',
);

class AriSmartContentPluginParamWebFactory extends AriObject
{	
	function createControls($plugin, $bindDefValue = true)
	{
		global $_ARI_SMART_CONTENT_PPARAM_MAPPING;
		
		$params = $plugin->Params;
		$controls = array();
		
		if (empty($params)) return $controls;
		
		$mapping = $_ARI_SMART_CONTENT_PPARAM_MAPPING;
		foreach ($params as $name => $param)
		{
			$type = $param->Type;
			if (!isset($mapping[$type])) continue;
			
			$ctrlClassName = $mapping[$type];
			$control = new $ctrlClassName($plugin, $param, $bindDefValue);
			
			$controls[$param->Name] = $control;
		}
		
		return $controls;
	}
}
?>