<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Web.Controls.Toolbar.Toolbar');

class AriSmartContentToolbar extends AriToolbar
{
	function diagnosticsToolbar()
	{
		$this->_toolbar->resourceTitle('Label.Diagnostics');
		$this->_toolbar->startToolbar();
		
			
			$this->_toolbar->spacer();
		
		$this->_toolbar->endToolbar();
	}
	
	function css_updateToolbar()
	{
		$this->_toolbar->title(sprintf('%s : %s',
			AriWebHelper::translateResValue('Label.CSSTemplate'),
			AriWebHelper::translateResValue('Label.UpdateItem')));
		
		$this->_toolbar->startToolbar();
			
		    $this->_toolbar->save('css_update$save', AriWebHelper::translateResValue('Toolbar.Save'));
		    $this->_toolbar->spacer();
		    $this->_toolbar->apply('css_update$apply', AriWebHelper::translateResValue('Toolbar.Apply'));
		    $this->_toolbar->spacer();
		    $this->_toolbar->cancel('css_update$cancel', AriWebHelper::translateResValue('Toolbar.Cancel'));
		    $this->_toolbar->spacer();

	    $this->_toolbar->endToolbar();
	}
	
	function css_addToolbar()
	{
		$this->_toolbar->title(sprintf('%s : %s',
			AriWebHelper::translateResValue('Label.CSSTemplate'),
			AriWebHelper::translateResValue('Label.AddItem')));
		
		$this->_toolbar->startToolbar();
			
		    $this->_toolbar->save('css_add$save', AriWebHelper::translateResValue('Toolbar.Save'));
		    $this->_toolbar->spacer();
		    $this->_toolbar->apply('css_add$apply', AriWebHelper::translateResValue('Toolbar.Apply'));
		    $this->_toolbar->spacer();
		    $this->_toolbar->cancel('css_add$cancel', AriWebHelper::translateResValue('Toolbar.Cancel'));
		    $this->_toolbar->spacer();

	    $this->_toolbar->endToolbar();
	}
	
	function css_listToolbar()
	{
		$this->_toolbar->resourceTitle('Title.CSSList');
		$this->_toolbar->startToolbar();
		
		$this->_toolbar->apply('css_list$ajax|sync', AriWebHelper::translateResValue('Toolbar.Sync'));
		
		$this->_toolbar->spacer();
		$this->_toolbar->divider();
		$this->_toolbar->spacer();
		
		$this->_toolbar->publishList('css_list$ajax|activate', AriWebHelper::translateResValue('Button.Activate'));
		$this->_toolbar->spacer();
		$this->_toolbar->unpublishList('css_list$ajax|deactivate', AriWebHelper::translateResValue('Button.Deactivate'));
		
		$this->_toolbar->spacer();
		$this->_toolbar->addNewX('css_add', AriWebHelper::translateResValue('Button.Add'));

		$this->_toolbar->spacer();
		$this->_toolbar->divider();
		$this->_toolbar->spacer();

		$this->_toolbar->deleteList(
				AriWebHelper::translateResValue('Warning.PluginsRemove'), 
				'css_list$ajax|delete', 
				AriWebHelper::translateResValue('Button.Remove'));
		
		$this->_toolbar->endToolbar();
	}
	
	function plugin_updateToolbar()
	{
		$task = 'plugin_update';
		$this->_toolbar->title(sprintf('%s : %s',
			AriWebHelper::translateResValue('Title.Plugin'),
			AriWebHelper::translateResValue('Label.UpdateItem')));
		
		$this->_toolbar->startToolbar();
		
		$this->_toolbar->save($task . '$save', AriWebHelper::translateResValue('Toolbar.Save'));
		$this->_toolbar->spacer();
		$this->_toolbar->apply($task . '$apply', AriWebHelper::translateResValue('Toolbar.Apply'));
		$this->_toolbar->spacer();
		$this->_toolbar->cancel($task . '$cancel', AriWebHelper::translateResValue('Toolbar.Cancel'));

		$this->_toolbar->endToolbar();
	}
	
	function pluginsToolbar()
	{
		$this->_toolbar->resourceTitle('Title.PluginList');
		$this->_toolbar->startToolbar();
		
		$this->_toolbar->apply('plugins$ajax|sync', AriWebHelper::translateResValue('Toolbar.Sync'));
		
		$this->_toolbar->spacer();
		$this->_toolbar->divider();
		$this->_toolbar->spacer();
		
		$this->_toolbar->publishList('plugins$ajax|activatePlugins', AriWebHelper::translateResValue('Button.Activate'));
		$this->_toolbar->spacer();
		$this->_toolbar->unpublishList('plugins$ajax|deactivatePlugins', AriWebHelper::translateResValue('Button.Deactivate'));

		$this->_toolbar->spacer();
		$this->_toolbar->divider();
		$this->_toolbar->spacer();

		$this->_toolbar->deleteList(
				AriWebHelper::translateResValue('Warning.PluginsRemove'), 
				'plugins$ajax|deletePlugins', 
				AriWebHelper::translateResValue('Button.Remove'));
		
		$this->_toolbar->endToolbar();
	}
	
	function lang_backendToolbar()
	{
		$this->_lang_list('lang_backend', 'blang_add');
	}

	function lang_frontendToolbar()
	{
		$this->_lang_list('lang_frontend', 'flang_add');
	}
	
	function _lang_list($task, $addTask)
	{
		$this->_toolbar->resourceTitle('Title.LangList');
		$this->_toolbar->startToolbar();

		$this->_toolbar->custom($task . '$export', 'restore.png', 'restore.png', AriWebHelper::translateResValue('Toolbar.Export'), true);
		$this->_toolbar->spacer();
		$this->_toolbar->custom('import', 'upload.png', 'upload.png', AriWebHelper::translateResValue('Toolbar.Import'), false);
		
		$this->_toolbar->spacer();
		$this->_toolbar->divider();
		$this->_toolbar->spacer();
			
		$this->_toolbar->apply($task . '$default', AriWebHelper::translateResValue('Toolbar.Default'));
		$this->_toolbar->spacer();
		$this->_toolbar->addNewX($addTask, AriWebHelper::translateResValue('Button.Add'));
		$this->_toolbar->spacer();
		$this->_toolbar->deleteList(
				AriWebHelper::translateResValue('Warning.QTemplateRemove'), 
				$task . '$ajax|delete', 
				AriWebHelper::translateResValue('Button.Remove'));
		
		$this->_toolbar->endToolbar();
	}
	
	function blang_addToolbar()
	{
		$this->_lang_add('blang_add');
	}
	
	function flang_addToolbar()
	{
		$this->_lang_add('flang_add');
	}
	
	function _lang_add($task)
	{
		$fileId = intval(AriRequest::getParam('fileId', 0));
		$this->_toolbar->title(sprintf('%s : %s',
			AriWebHelper::translateResValue('Title.BLangResource'),
			AriWebHelper::translateResValue($fileId ? 'Label.UpdateItem' : 'Label.AddItem')));
		
		$this->_toolbar->startToolbar();
		
		$this->_toolbar->save($task . '$save', AriWebHelper::translateResValue('Toolbar.Save'));
		$this->_toolbar->spacer();
		$this->_toolbar->apply($task . '$apply', AriWebHelper::translateResValue('Toolbar.Apply'));
		$this->_toolbar->spacer();
		$this->_toolbar->cancel($task . '$cancel', AriWebHelper::translateResValue('Toolbar.Cancel'));

		$this->_toolbar->endToolbar();
	}
	
	function helpToolbar()
	{
		global $option;
		
		$this->_toolbar->resourceTitle('Title.Help');
	}
	
	function faqToolbar()
	{
		global $option;
		
		$this->_toolbar->resourceTitle('Title.FAQ');
	}
	
	function licenseToolbar()
	{
		global $option;
		
		$this->_toolbar->resourceTitle('Title.License');
	}
	
	function debugToolbar()
	{
		global $option;
		//$this->_toolbar->resourceTitle($resKey);
		
		$this->_toolbar->startToolbar();
		
		$this->_toolbar->back(AriWebHelper::translateResValue('Toolbar.Back'), sprintf('index.php?option=%s&task=%s',
			$option,
			''));
			
		$this->_toolbar->endToolbar();
	}
	
	function _back($resKey = '', $backResKey = 'Button.Back')
	{
		global $option;
		
		$this->_toolbar->resourceTitle($resKey);
		
		$this->_toolbar->startToolbar();
		
		$this->_toolbar->back(AriWebHelper::translateResValue($backResKey), sprintf('index.php?option=%s&task=%s',
			$option,
			''));
		    
		$this->_toolbar->endToolbar();
	}
	
	function addSubmenu($vName)
	{
		if (!class_exists('JSubMenuHelper'))
			return ;

		JSubMenuHelper::addEntry(
			JText::_('COM_ARISMARTCONTENT_MENU_PLUGINS'),
			'index.php?option=com_arismartcontent&task=plugins',
			$vName == 'plugins'
		);

		JSubMenuHelper::addEntry(
			JText::_('COM_ARISMARTCONTENT_MENU_CSSLIST'),
			'index.php?option=com_arismartcontent&task=css_list',
			$vName == 'css_list'
		);

		JSubMenuHelper::addEntry(
			JText::_('COM_ARISMARTCONTENT_MENU_LANG'),
			'index.php?option=com_arismartcontent&task=lang_backend',
			$vName == 'lang_backend'
		);

		JSubMenuHelper::addEntry(
			JText::_('COM_ARISMARTCONTENT_MENU_DIAGNOSTICS'),
			'index.php?option=com_arismartcontent&task=diagnostics',
			$vName == 'diagnostics'
		);

		JSubMenuHelper::addEntry(
			JText::_('COM_ARISMARTCONTENT_MENU_HELP'),
			'index.php?option=com_arismartcontent&task=help',
			$vName == 'help'
		);

		JSubMenuHelper::addEntry(
			JText::_('COM_ARISMARTCONTENT_MENU_FAQ'),
			'index.php?option=com_arismartcontent&task=faq',
			$vName == 'faq'
		);
	}
}
?>