<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

class AriProductSearchStruct extends AriObject
{
	var $_categoryIdList = array();
	var $_isRandom = false;
	var $_itemCount = 0;
	var $_sortField = 'cdate';
	var $_sortDir = 'ASC';
	var $_isPublished = true;
	
	function _getIntList($list)
	{
		$intList = array();
		
		if (!is_array($list)) $list = array($list);
		
		foreach ($list as $item)
		{
			$intItem = @intval($item, 10);
			if ($intItem > 0) $intList[] = $intItem;
			else if ($intItem == 0 && ($item === 0 || $item === '0')) $intList[] = 0;
		}
		
		$intList = array_unique($intList);
		if (count($intList) == 0) $intList = null;
		
		return $intList;
	}
	
	function setCategoryIdList($idList)
	{
		$this->_categoryIdList = $this->_getIntList($idList);
	}
	
	function getCategoryIdList()
	{
		return $this->_categoryIdList;
	}
	
	function setIsRandom($isRandom)
	{
		$this->_isRandom = $isRandom;
	}
	
	function getIsRandom()
	{
		return $this->_isRandom; 
	}
	
	function setIsPublished($isPublished)
	{
		$this->_isPublished = $isPublished;
	}
	
	function getIsPublished()
	{
		return $this->_isPublished; 
	}
	
	function setItemCount($itemCount)
	{
		$itemCount = @intval($itemCount, 10);
		$this->_itemCount = $itemCount > -1 ? $itemCount : 0;
	}
	
	function getItemCount()
	{
		return $this->_itemCount;
	}
	
	function setSortDir($sortDir)
	{
		$this->_sortDir = ((strtoupper($sortDir) == 'ASC') ? 'ASC' : 'DESC');
	}
	
	function getSortDir()
	{
		return $this->_sortDir;
	}
	
	function setSortField($sortField)
	{
		$availSortFields = array('product_name', 'product_s_desc', 'product_desc', 'product_weight', 'product_weight_uom', 'product_length', 'product_width', 'product_height', 'product_url', 'product_in_stock', 'product_available_date', 'product_special', 'cdate', 'product_id', 'vendor_id');
		if (@in_array($sortField, $availSortFields)) $sortField = 'cdate';
		
		$this->_sortField = $sortField;
	}

	function getSortField()
	{
		return $this->_sortField;
	}
}
?>