<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Controllers.ControllerBase');
AriKernel::import('VirtueMart.ProductSearchStruct');

class AriVirtueMartController extends AriControllerBase
{
	function getProductList($searchStruct)
	{
		$database =& JFactory::getDBO();
		
		$my =& JFactory::getUser();
    	$categoryIdList = $searchStruct->getCategoryIdList();
    	$sortField = $searchStruct->getSortField();
    	$sortDir = $searchStruct->getSortDir();
		
		$query = 'SELECT P.*' .
			' FROM #__vm_product P';
		
		$query .= ' JOIN #__vm_product_category_xref PC ON P.product_id = PC.product_id';
		
		if ($searchStruct->getIsPublished()) {
			$query .= sprintf(" WHERE P.product_publish = 'Y'");
		}

		if ($searchStruct->getCategoryIdList())
		{
			$query .= sprintf(' AND (PC.category_id IN (%s))',
				join(',', $this->_quoteValues($categoryIdList)));
		}
		
		if ($searchStruct->getIsRandom())
		{
			$query .= ' ORDER BY RAND()';
		}
		else
		{
			$sortField = $searchStruct->getSortField();
			$sortDir = $searchStruct->getSortDir();
			
			$query .= sprintf(' ORDER BY P.`%s` %s', $sortField, $sortDir);
		}
		
		$itemCount = $searchStruct->getItemCount();
		if ($itemCount > 0)
		{
			$query .= ' LIMIT 0,' . $itemCount;
		}

		$database->setQuery($query);
		$productList = $database->loadObjectList();
		if ($database->getErrorNum())
		{
			echo $database->getErrorMsg();
			return null;
		}

		return $productList;
	}
}
?>