<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Web.Controls.WebControl');

class AriEditorWebControl extends AriWebControl
{
	var $_text;
	
	function __construct($id, $config = null)
	{
		$this->extendConfig(
			array(
				'translateText' => true,
				'trimValue' => true,
				'maxLength' => null));
		parent::__construct($id, $config);

		//if ($this->getStoreState()) $this->setText(AriRequest::getParam($this->getName()));
	}
	
	function setValue($value)
	{
		$this->setText($value);
	}
	
	function setText($text)
	{
		$this->_text = $text;
	}

	function getText()
	{
		$text = $this->isTrimValue() ? trim($this->_text) : $this->_text;
		$maxLength = $this->getMaxLength();
		if (!is_null($maxLength)) $text = substr($text, 0, $maxLength);
		
		return $text;
	}

	function getMaxLength()
	{
		return $this->getConfigValue('maxLength');
	}

	function setMaxLength($maxLength)
	{
		$this->setConfigValue('maxLength', $maxLength);
	}

	function isTrimValue()
	{
		return $this->getConfigValue('trimValue');
	}
	
	function setIsTrimValue($isTrimValue)
	{
		$this->setConfigValue('trimValue', $isTrimValue ? true : false);
	}
	
	function getValidateValue()
	{
		return $this->getText();
	}

	function getContent()
	{
		$editor =& JFactory::getEditor();
		$content = $editor->getContent($this->getName());
			
		$content = str_replace('tinyMCE.getContent()', sprintf('tinyMCE.getContent("%s")', $this->getName()), $content);
			
		return $content;
	}
	
	function render($attrs = null)
	{
		$width = AriUtils::getParam($attrs, 'width', '100%;');
		$height = AriUtils::getParam($attrs, 'height', '250');
		$rows = AriUtils::getParam($attrs, 'rows', '20');
		$cols = AriUtils::getParam($attrs, 'cols', '60');
		
		$editor =& JFactory::getEditor();
		echo $editor->display(
			$this->getName(), 
			$this->getText(),
			$width,
			$height,
			$cols,
			$rows);
	}
}
?>