<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Web.Page.Specific.AdminPageBase');
AriKernel::import('Controllers.AriSmartContent.CssController');
AriKernel::import('Web.Controls.TextBox');
AriKernel::import('Web.Controls.CheckBox');
AriKernel::import('Web.Controls.Validators.RequiredValidator');
AriKernel::import('Web.Controls.Validators.CustomValidator');

class cssAriPage extends AriAdminPageBase
{
	var $_tbxFileName;
	var $_tbxFileContent;
	var $_chkEnabled;
	
	var $_css;
	var $_cssController;
	
	function _init()
	{
		$this->_cssController = new AriSmartContentCssController();
		
		parent::_init();
	}
	
	function execute()
	{
		$css = $this->getCss();
		
		$this->addVar('css', $css);
		
		$this->_bindControls($css);
		
		parent::execute();
	}
	
	function _createControls()
	{
		$this->_tbxFileName =& new AriTextBoxWebControl('tbxFileName',
			array('name' => 'zFile[ShortDescription]', 'maxLength' => 85));
		$this->_tbxFileContent =& new AriTextBoxWebControl('tbxFileContent',
			array('name' => 'zFile[Content]', 'type' => AriConstantsManager::getVar('Type.Multi', AriTextBoxWebControlConstants::getClassName())));
		$this->_chkEnabled =& new AriCheckBoxWebControl('chkEnabled',
			array('name' => 'zCss[Status]'));
	}
	
	function _createValidators()
	{
		new AriRequiredValidatorWebControl('rvFileName',
			array('errorMessageResourceKey' => 'Validator.NameRequired',
				'controlToValidate' => $this->_tbxFileName->getId()));
				
		$validate = array(&$this, 'acvCss');
		new AriCustomValidatorWebControl('acvCss', $validate, 
			array(
				'emptyValidate' => true,
				'controlToValidate' => $this->_tbxFileContent->getId(),
				'clientValidateFunc' => 'YAHOO.ARISoft.page.cvCssValidate',
				'errorMessageResourceKey' => 'Validator.ContentRequired'));
	}

	function acvCss()
	{
		return true;
	}
	
	function _bindControls($css)
	{
		$this->_tbxFileName->setText(AriWebHelper::translateDbValue($css->File->ShortDescription));
		$this->_tbxFileContent->setText(AriWebHelper::translateDbValue($css->File->Content));
		$this->_chkEnabled->setChecked(!!($css->Status));
	}
	
	function _registerEventHandlers()
	{
		$this->_registerEventHandler('save', 'clickSave');
		$this->_registerEventHandler('apply', 'clickApply');
		$this->_registerEventHandler('cancel', 'clickCancel');
	}
	
	function getCssId()
	{
		return 0;
	}
	
	function getCss()
	{
		if (is_null($this->_css))
		{
			$this->_css = $this->_cssController->call('getCssFile', $this->getCssId());
		}
		
		return $this->_css;
	}
	
	function clickCancel($eventArgs)
	{
		AriWebHelper::cancelAction('css_list');
	}
	
	function clickSave($eventArgs)
	{
		$cssFile = $this->_saveCssFile();
		if (!$this->_isError())
		{
			 AriWebHelper::preCompleteAction('Complete.CssFileSave', array('task' => 'css_list'));
		}				
	}
	
	function clickApply($eventArgs)
	{
		$cssFile = $this->_saveCssFile();
		if (!$this->_isError())
		{
			AriWebHelper::preCompleteAction('Complete.CssFileSave', 
					array('task' => 'css_update', 'cssId' => $cssFile->CssId, 'hidemainmenu' => 1));
		}
	}
	
	function _saveCssFile()
	{
		$my =& JFactory::getUser();
		
		$userId = $my->get('id');
		$cssFields = AriWebHelper::translateRequestValues('zCss');
		$fileFields = AriWebHelper::translateRequestValues('zFile');
		
		$cssFile = $this->_cssController->call('saveCssFile',
			$this->getCssId(),
			$cssFields,
			$fileFields,
			$userId);

		return $cssFile;
	}
}
?>