<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Web.Page.Specific.AdminPageBase');
AriKernel::import('Web.Controls.Data.MultiPageDataTable');
AriKernel::import('Controllers.AriSmartContent.CssController');

class css_listAriPage extends AriAdminPageBase 
{
	var $_cssController;
	
	function _init()
	{
		$this->_cssController = new AriSmartContentCssController();
		
		parent::_init();
	}
	
	function execute()
	{
		$dataTable = $this->_createDataTable();
		$this->addVar('dataTable', $dataTable);

		$this->setResTitle('Title.CSSList');

		parent::execute();
	}
	
	function _getPersistanceKey()
	{
		return 'dtCssList';
	}
	
	function _createDataTable()
	{
		global $option;

		$dsUrl = 'index.php?option=' . $option . '&task=' . $this->executionTask . '$ajax|getFileList';
		$columns = array(
			new AriDataTableControlColumn(array('key' => '', 'label' => AriWebHelper::translateResValue('Label.NumberPos'), 'formatter' => 'YAHOO.ARISoft.widgets.dataTable.formatters.formatPosition', 'className' => 'dtCenter dtColMin')),
			new AriDataTableControlColumn(array('key' => 'CssId', 'label' => '<input type="checkbox" class="adtCtrlCheckbox" />', 'formatter' => 'YAHOO.ARISoft.widgets.dataTable.formatters.formatCheckbox', 'className' => 'dtCenter dtColMin')),
			new AriDataTableControlColumn(array('key' => 'ShortDescription', 'label' => AriWebHelper::translateResValue('Label.Name'), 'sortable' => true, 'formatter' => 'YAHOO.ARISoft.components.SmartContent.formatters.formatCss')),
			//new AriDataTableControlColumn(array('key' => 'Ordering', 'label' => AriWebHelper::translateResValue('Label.Order'), 'sortable' => false, 'headerWidth' => '10%', 'className' => 'dtCenter')),
			new AriDataTableControlColumn(array('key' => 'Status', 'label' => AriWebHelper::translateResValue('Label.Status'), 'sortable' => false, 'formatter' => 'YAHOO.ARISoft.components.SmartContent.formatters.formatCssStatus', 'className' => 'dtCenter dtColMin')),
		);

		$dataTable = new AriMultiPageDataTableControl(
			$this->_getPersistanceKey(),
			$columns, 
			array('dataUrl' => $dsUrl));

		return $dataTable;
	}
	
	function _registerAjaxHandlers()
	{
		$this->_registerAjaxHandler('getFileList', 'ajaxGetFileList');
		$this->_registerAjaxHandler('sync', 'ajaxSyncCss');
		$this->_registerAjaxHandler('delete', 'ajaxDeleteCss');
		$this->_registerAjaxHandler('activate', 'ajaxActivate');
		$this->_registerAjaxHandler('deactivate', 'ajaxDeactivate');
		$this->_registerAjaxHandler('singleActivate', 'ajaxSingleActivate');
		$this->_registerAjaxHandler('singleDeactivate', 'ajaxSingleDeactivate');
	}
	
	function ajaxGetFileList()
	{
		$filter = new AriDataFilter(
			array('startOffset' => 0, 'limit' => 10, 'sortField' => 'ShortDescription', 'dir' => 'asc'), 
			true, 
			$this->_getPersistanceKey());

		$totalCnt = $this->_cssController->call('getCssCount', $filter);
		$filter->fixFilter($totalCnt);

		$files = $this->_cssController->call('getCssList', $filter);	
		$data = AriMultiPageDataTableControl::createDataInfo($files, $filter, $totalCnt);

		AriResponse::sendJsonResponse($data);
	}

	function ajaxDeleteCss()
	{
		$complete = $this->_cssController->call('deleteCssFiles', 
			AriRequest::getParam('CssId', 0));

		AriResponse::sendJsonResponse($complete);
	}
	
	function ajaxActivate()
	{
		$result = $this->_cssController->call('activateCssFile', AriRequest::getParam('CssId', 0));

		AriResponse::sendJsonResponse($result);		
	}
	
	function ajaxDeactivate()
	{
		$result = $this->_cssController->call('deactivateCssFile', AriRequest::getParam('CssId', 0));

		AriResponse::sendJsonResponse($result);		
	}

	function ajaxSingleActivate()
	{
		$result = $this->_cssController->call('activateCssFile', AriRequest::getParam('cssId', 0));

		AriResponse::sendJsonResponse($result);		
	}
	
	function ajaxSingleDeactivate()
	{
		$result = $this->_cssController->call('deactivateCssFile', AriRequest::getParam('cssId', 0));

		AriResponse::sendJsonResponse($result);		
	}
	
	function ajaxSyncCss()
	{
		$result = $this->_cssController->call('syncCssFiles');

		AriResponse::sendJsonResponse($result);		
	}
}
?>