<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Web.Page.Specific.AdminPageBase');
AriKernel::import('Controllers.AriSmartContent.PluginController');
AriKernel::import('Components.AriSmartContent.Web.PluginParamFactory');
AriKernel::import('Web.Controls.TextBox');
AriKernel::import('Web.Controls.ListBox');
AriKernel::import('Web.Controls.CheckBox');

class plugin_updateAriPage extends AriAdminPageBase 
{
	var $_pluginController;
	var $_pluginId;
	var $_plugin;
	
	var $_chkPluginEnabled;
	var $_lbPluginOrder;
	
	function _init()
	{
		$this->_pluginController = new AriSmartContentPluginController();
		
		$plugin = $this->getPlugin();
		if (empty($plugin->PluginId))
		{
			AriResponse::redirect(sprintf('index.php?option=%s&task=plugins&arimsg=Complete.NotFindPlugin',
				AriSmartContentComponent::getCodeName()));
		}
		
		parent::_init();
	}
	
	function _createControls()
	{
		$this->_chkPluginEnabled =& new AriCheckBoxWebControl('chkPluginEnabled',
			array('name' => 'zPlugin[Status]'));
			
		$this->_lbPluginOrder =& new AriListBoxWebControl('lbPluginOrder',
			array('name' => 'zPlugin[Ordering]'));
	}
	
	function _bindControls($plugin)
	{
		$statusList = AriConstantsManager::getVar('Status', AriSmartContentPluginControllerConstants::getClassName());

		$systemType = AriConstantsManager::getVar('Type.System', AriSmartContentPluginControllerConstants::getClassName());
		$this->_chkPluginEnabled->setChecked(($plugin->Status == $statusList['Active']));
		if ($plugin->Type == $systemType) $this->_chkPluginEnabled->addAttribute('disabled', 'disabled'); 
	}
	
	function getPluginId()
	{
		if (is_null($this->_pluginId))
		{
			$this->_pluginId = @intval(AriRequest::getParam('pluginId', 0), 10);
		}
		
		return $this->_pluginId;
	}
	
	function getPlugin()
	{
		if (is_null($this->_plugin))
		{
			$this->_plugin = $this->_pluginController->call('getPlugin', $this->getPluginId());
		}
		
		return $this->_plugin;
	}

	function execute()
	{
		$this->setTitle(sprintf('%s : %s',
			AriWebHelper::translateResValue('Title.Plugin'),
			AriWebHelper::translateResValue('Label.UpdateItem')));
			
		$plugin = $this->getPlugin();
		$this->_bindControls($plugin);

		$paramControls = AriSmartContentPluginParamWebFactory::createControls($plugin);
		
		$this->addVar('paramControls', $paramControls);
		$this->addVar('plugin', $plugin);

		parent::execute();
	}
	
	function _registerEventHandlers()
	{
		$this->_registerEventHandler('save', 'clickSave');
		$this->_registerEventHandler('apply', 'clickApply');
		$this->_registerEventHandler('cancel', 'clickCancel');
	}
	
	function clickCancel($eventArgs)
	{
		AriWebHelper::cancelAction('plugins');
	}
	
	function clickSave($eventArgs)
	{
		$plugin = $this->_savePlugin();
		if (!$this->_isError())
		{
			 AriWebHelper::preCompleteAction('Complete.PluginSave', array('task' => 'plugins'));
		}				
	}
	
	function clickApply($eventArgs)
	{
		$plugin = $this->_savePlugin();
		if (!$this->_isError())
		{
			AriWebHelper::preCompleteAction('Complete.PluginSave', 
					array('task' => 'plugin_update', 'pluginId' => $plugin->PluginId, 'hidemainmenu' => 1));
		}
	}
	
	function _collectParams()
	{
		$params = array();
		
		$plugin = $this->getPlugin();
		$paramControls = AriSmartContentPluginParamWebFactory::createControls($plugin, false);
		if ($paramControls)
		{
			foreach ($paramControls as $name => $ctrl)
			{
				$params[$name] = $ctrl->getValue();
			}
		}
		
		return $params;
	}
	
	function _savePlugin()
	{
		$my =& JFactory::getUser();
		
		$ownerId = $my->get('id');
		$fields = AriWebHelper::translateRequestValues('zPlugin');
		
		$params = $this->_collectParams();

		return $this->_pluginController->call('savePlugin',
			$this->getPluginId(),
			$fields, 
			$params,
			$ownerId);
	}
}
?>