<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Web.Page.Specific.AdminPageBase');
AriKernel::import('Web.Controls.Data.MultiPageDataTable');
AriKernel::import('Controllers.AriSmartContent.PluginController');
AriKernel::import('Controllers.AriSmartContent.PluginInstallerController');
AriKernel::import('Web.Controls.TextBox');
AriKernel::import('Web.Controls.Validators.RequiredValidator');
AriKernel::import('Joomla.JoomlaHelper');

jimport('joomla.client.helper');

class pluginsAriPage extends AriAdminPageBase 
{
	var $_pluginController;
	var $_pluginInstaller;
	var $_tbxInstallFromDir;
	
	function _init()
	{		
		$this->_pluginController = new AriSmartContentPluginController();
		$this->_pluginInstaller = new AriSmartContentPluginInstaller();
		
		if (AriJoomlaHelper::isRequireFtp())
		{
			$ftp =& JClientHelper::setCredentialsFromRequest('ftp');
			$this->addVar('ftp', $ftp);
		}
		
		parent::_init();
	}
	
	function _createControls()
	{
		$this->_tbxInstallFromDir =& new AriTextBoxWebControl('tbxInstallDir');
	}
	
	function _createValidators()
	{
		new AriRequiredValidatorWebControl('rvInstallDir',
			array('errorMessageResourceKey' => 'Validator.InstallDir',
				'controlToValidate' => $this->_tbxInstallFromDir->getId(),
				'groups' => array('installFromDir')));
	}
	
	function _bindControls()
	{
		$pluginDir = '/administrator/components/com_arismartcontent/install/plugins/'; 
		if (strpos(JPATH_ROOT, '\\') !== false) $pluginDir = str_replace('/', '\\', $pluginDir);
		
		$this->_tbxInstallFromDir->setText(JPATH_ROOT . $pluginDir);
	}

	function execute()
	{
		$requireFtp = AriJoomlaHelper::isRequireFtp();
		$dataTable = $this->_createDataTable();
		$foundPluginsDataTable = $this->_createFoundPluginsDataTable();
		
		$this->addVar('dataTable', $dataTable);
		$this->addVar('foundPluginsDataTable', $foundPluginsDataTable);
		$this->addVar('requireFtp', $requireFtp);

		$this->setResTitle('Title.PluginList');
		$this->_bindControls();

		parent::execute();
	}
	
	function _getPersistanceKey()
	{
		return 'dtPlugins';
	}
	
	function _createFoundPluginsDataTable()
	{
		global $option;

		$dsUrl = 'index.php?option=' . $option . '&task=' . $this->executionTask . '$ajax|getFoundPlugins';		
		$columns = array(
			new AriDataTableControlColumn(array('key' => '', 'label' => AriWebHelper::translateResValue('Label.NumberPos'), 'formatter' => 'YAHOO.ARISoft.widgets.dataTable.formatters.formatPosition', 'className' => 'dtCenter ', 'width' => 15)),
			new AriDataTableControlColumn(array('key' => 'Path', 'label' => '<input type="checkbox" class="adtCtrlCheckbox" />', 'formatter' => 'YAHOO.ARISoft.widgets.dataTable.formatters.formatCheckbox', 'className' => 'dtCenter', 'width' => 20)),
			new AriDataTableControlColumn(array('key' => 'Name', 'label' => AriWebHelper::translateResValue('Label.Name'), 'sortable' => true, 'width' => 408)),
			new AriDataTableControlColumn(array('key' => 'Type', 'label' => AriWebHelper::translateResValue('Label.Type'), 'sortable' => true, 'className' => 'dtCenter', 'width' => 60)),
			new AriDataTableControlColumn(array('key' => 'Version', 'label' => AriWebHelper::translateResValue('Label.Version'), 'className' => 'dtCenter', 'width' => 60)),
		);

		$dataTable = new AriMultiPageDataTableControl(
			'dtFoundPlugins',
			$columns, 
			array('dataUrl' => $dsUrl, 'width' => '685px', 'height' => '390px'),
			null,
			true,
			false);

		return $dataTable;
	}
	
	function _createDataTable()
	{
		global $option;

		$dsUrl = 'index.php?option=' . $option . '&task=' . $this->executionTask . '$ajax|getPluginList';
		$columns = array(
			new AriDataTableControlColumn(array('key' => '', 'label' => AriWebHelper::translateResValue('Label.NumberPos'), 'formatter' => 'YAHOO.ARISoft.widgets.dataTable.formatters.formatPosition', 'className' => 'dtCenter dtColMin')),
			new AriDataTableControlColumn(array('key' => 'PluginId', 'label' => '<input type="checkbox" class="adtCtrlCheckbox" />', 'formatter' => 'YAHOO.ARISoft.components.SmartContent.formatters.formatPluginId', 'className' => 'dtCenter dtColMin')),
			new AriDataTableControlColumn(array('key' => 'PluginName', 'label' => AriWebHelper::translateResValue('Label.Name'), 'sortable' => true, 'formatter' => 'YAHOO.ARISoft.components.SmartContent.formatters.formatPlugin')),
			//new AriDataTableControlColumn(array('key' => 'Ordering', 'label' => AriWebHelper::translateResValue('Label.Order'), 'sortable' => false, 'headerWidth' => '10%', 'className' => 'dtCenter')),
			new AriDataTableControlColumn(array('key' => 'Type', 'label' => AriWebHelper::translateResValue('Label.Type'), 'sortable' => true, 'className' => 'dtColMin')),
			new AriDataTableControlColumn(array('key' => 'Version', 'label' => AriWebHelper::translateResValue('Label.Version'), 'className' => 'dtColMin')),
			new AriDataTableControlColumn(array('key' => 'Status', 'label' => AriWebHelper::translateResValue('Label.Status'), 'sortable' => false, 'formatter' => 'YAHOO.ARISoft.components.SmartContent.formatters.formatPluginStatus', 'className' => 'dtCenter dtColMin')),
		);

		$dataTable = new AriMultiPageDataTableControl(
			$this->_getPersistanceKey(),
			$columns, 
			array('dataUrl' => $dsUrl));

		return $dataTable;
	}
	
	function _registerAjaxHandlers()
	{
		$this->_registerAjaxHandler('getPluginList', 'ajaxGetPluginList');
		$this->_registerAjaxHandler('sync', 'ajaxSync');
		$this->_registerAjaxHandler('activatePlugins', 'ajaxActivatePlugins');
		$this->_registerAjaxHandler('deactivatePlugins', 'ajaxDeactivatePlugins');
		$this->_registerAjaxHandler('activatePlugin', 'ajaxActivatePlugin');
		$this->_registerAjaxHandler('deactivatePlugin', 'ajaxDeactivatePlugin');
		$this->_registerAjaxHandler('deletePlugins', 'ajaxDeletePlugins');
		$this->_registerAjaxHandler('install', 'ajaxInstallPluginFromDir');
		$this->_registerAjaxHandler('installFoundPlugins', 'ajaxInstallFoundPlugins');
		$this->_registerAjaxHandler('getFoundPlugins', 'ajaxGetFoundPlugins');
	}
	
	function ajaxActivatePlugin()
	{
		$this->ajaxActivatePlugins(AriRequest::getParam('PlugId', 0));
	}
	
	function ajaxDeactivatePlugin()
	{
		$this->ajaxDeactivatePlugins(AriRequest::getParam('PlugId', 0));
	}
	
	function ajaxActivatePlugins($idList = null)
	{
		if (is_null($idList)) $idList = AriRequest::getParam('PluginId', 0);
		$complete = $this->_pluginController->call('activatePlugins', $idList);
		
		AriResponse::sendJsonResponse($complete);
	}
	
	function ajaxDeactivatePlugins($idList = null)
	{
		if (is_null($idList)) $idList = AriRequest::getParam('PluginId', 0);
		$complete = $this->_pluginController->call('deactivatePlugins', $idList);

		AriResponse::sendJsonResponse($complete);
	}
	
	function ajaxGetPluginList()
	{
		$filter = new AriDataFilter(
			array('startOffset' => 0, 'limit' => 10, 'sortField' => 'PluginName', 'dir' => 'asc'), 
			true, 
			$this->_getPersistanceKey());

		$totalCnt = $this->_pluginController->call('getPluginCount', $filter);
		$filter->fixFilter($totalCnt);

		$plugins = $this->_pluginController->call('getPluginList', $filter);	
		$data = AriMultiPageDataTableControl::createDataInfo($plugins, $filter, $totalCnt);

		AriResponse::sendJsonResponse($data);
	}
	
	function ajaxDeletePlugins()
	{
		$complete = $this->_pluginController->call('deletePlugins', 
			AriRequest::getParam('PluginId', 0),
			AriSmartContentComponent::getPluginRootDir());

		AriResponse::sendJsonResponse($complete);
	}
	
	function ajaxSync()
	{
		$result = $this->_pluginController->call('syncPlugins');

		return AriResponse::sendJsonResponse($result);
	}

	function _registerEventHandlers()
	{
		$this->_registerEventHandler('install', 'installPluginFromDir');
	}
	
	function ajaxGetFoundPlugins()
	{
		$filter = new AriDataFilter(
			array('startOffset' => 0, 'limit' => 25, 'sortField' => 'Name', 'dir' => 'asc'), 
			true);
		
		$installDir = AriRequest::getParam('installDir', null);
		$this->_pluginInstaller->call('findPlugingsInDir', $installDir);

		$plugins = $this->_pluginInstaller->call('findPlugingsInDir', $installDir, true, $filter);
		$totalCnt = $plugins['totalCnt'];
		$plugins = $plugins['plugins'];
		
		$filter->fixFilter($totalCnt);
		$data = AriMultiPageDataTableControl::createDataInfo($plugins, $filter, $totalCnt);
		
		AriResponse::sendJsonResponse($data);
	}
	
	function ajaxInstallFoundPlugins()
	{
		$my =& JFactory::getUser();

		$userId = $my->get('id');
		$destDir = AriSmartContentComponent::getPluginRootDir();
		$folders = AriRequest::getParam('Path', array());
		$result = true;

		foreach ($folders as $folder)
		{
			if (!$this->_pluginInstaller->installFromDir($folder, $destDir, $userId, true, false))
			{
				$result = false;
			}
		}

		$this->_pluginController->call('syncPlugins');
		
		AriResponse::sendJsonResponse($result);
	}
	
	function ajaxInstallPluginFromDir()
	{
		$my =& JFactory::getUser();

		$userId = $my->get('id');
		$installDir = AriRequest::getParam('tbxInstallDir', null);
		$destDir = AriSmartContentComponent::getPluginRootDir();

		$result = $this->_pluginInstaller->installFromDir($installDir, $destDir, $userId, true);
		
		AriResponse::sendJsonResponse($result);
	}
}
?>