<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

$option = $processPage->getVar('option');
$jsPath = JURI::root(true) . '/administrator/components/' . $option . '/js/';
$jsYuiPath = $jsPath . 'yui/';
$folders = $processPage->getVar('folders');
$plugins = $processPage->getVar('plugins');
$isModuleInstalled = $processPage->getVar('isModuleInstalled');
$isPluginInstalled = $processPage->getVar('isPluginInstalled');
$isFoldersCorrect = $processPage->getVar('isFoldersCorrect');
$ftp = $processPage->getVar('ftp');
$requireFtp = $processPage->getVar('requireFtp');
$activeTab = $processPage->getVar('activeTab');

$installed = '<span style="color: green; font-weight: bold;">' . AriWebHelper::translateResValue('Label.Installed') . '</span>';
$notInstalled = '<span style="color: red; font-weight: bold;">' . AriWebHelper::translateResValue('Label.InstalledNotProperly') . '</span>';
$notProperlyInstalled = '<span style="color: red; font-weight: bold;">' . AriWebHelper::translateResValue('Label.NotInstalledOrNotProperly') . '</span>'; 

JHTML::_('behavior.tooltip');
?>

<link rel="stylesheet" type="text/css" href="<?php echo $jsYuiPath;?>build/tabview/assets/tabview-core.css"/>
<link rel="stylesheet" type="text/css" href="<?php echo $jsYuiPath;?>build/tabview/assets/tabview.css"/> 
<link rel="stylesheet" type="text/css" href="<?php echo $jsYuiPath;?>build/tabview/assets/border_tabs.css"/>

<script type="text/javascript" src="<?php echo $jsYuiPath; ?>build/tabview/tabview-min.js"></script>

<?php
	if ($requireFtp):
?>
<fieldset title="<?php AriWebHelper::displayResValue('Label.FTPDetails'); ?>">
	<legend><?php AriWebHelper::displayResValue('Label.FTPDetails'); ?></legend>
	<?php AriWebHelper::displayResValue('Label.FTPDescr'); ?>

	<?php if (JError::isError($ftp)): ?>
		<p><?php echo JText::_($ftp->message); ?></p>
	<?php endif; ?>

	<table class="adminform nospace">
		<tbody>
			<tr>
				<td width="120">
					<label for="username"><?php echo JText::_('Username'); ?>:</label>
				</td>
				<td>
					<input type="text" id="username" name="username" class="input_box" size="70" value="" />
				</td>
			</tr>
			<tr>
				<td width="120">
					<label for="password"><?php echo JText::_('Password'); ?>:</label>
				</td>
				<td>
					<input type="password" id="password" name="password" class="input_box" size="70" value="" />
				</td>
			</tr>
		</tbody>
	</table>
</fieldset>
<?php endif; ?>

<div id="diagTabContainer" class="yui-navset"> 
	<ul class="yui-nav" style="text-align: left;">
		<li<?php if ($activeTab == 0): ?> class="selected"<?php endif; ?> title="active"><a href="#diagDir"><em><?php AriWebHelper::displayResValue('Label.DirPermissions'); ?></em></a></li>
		<li<?php if ($activeTab == 1): ?> class="selected"<?php endif; ?>><a href="#diagPlugins"><em><?php AriWebHelper::displayResValue('Title.PluginList'); ?></em></a></li>
		<li<?php if ($activeTab == 2): ?> class="selected"<?php endif; ?>><a href="#diagSystem"><em><?php AriWebHelper::displayResValue('Label.System'); ?></em></a></li>
	</ul>
	<div class="yui-content">
		<div class="yui-hidden" id="diagDir" style="padding: 4px; text-align: left;">
			<?php if (!$isFoldersCorrect): ?>
			<input type="button" class="button" value="<?php AriWebHelper::displayResValue('Label.TryToFix'); ?>" onclick="<?php echo J1_6 ? 'Joomla.submitbutton' : 'submitbutton'; ?>('diagnostics$fixDirPermissions');" /> 
			<?php echo JHTML::_('tooltip', AriWebHelper::translateResValue('Tooltip.DiagFolders'), AriWebHelper::translateResValue('Label.Suggestion')); ?>
			<br/><br/>
			<?php endif; ?>
			<table cellPadding="4" class="ari-main-liquid-table">
				<tr>
					<th><?php AriWebHelper::displayResValue('Label.Directory'); ?></th>
					<th><?php AriWebHelper::displayResValue('Label.Status'); ?></th>
				</tr>
				<?php
					$writeable = '<span style="color: green; font-weight: bold;">' . AriWebHelper::translateResValue('Label.Writable') . '</span>';
					$unwriteable = '<span style="color: red; font-weight: bold;">' . AriWebHelper::translateResValue('Label.Unwritable') . '</span>';
					$notExists = '<span style="color: red; font-weight: bold;">' . AriWebHelper::translateResValue('Label.NotExists') . '</span>';
					foreach ($folders as $folder)
					{
				?>
				<tr>
					<td><?php echo $folder['shortPath']; ?></td>
					<td><?php echo $folder['exists'] 
						? ($folder['writable'] ?$writeable : $unwriteable)
						: $notExists; ?></td>
				</tr>
				<?php
					}
				?>
			</table>
		</div>
		<div class="yui-hidden" id="diagPlugins" style="padding: 4px; text-align: left;">
			<table cellPadding="4" class="ari-main-liquid-table">
				<tr>
					<th><?php AriWebHelper::displayResValue('Label.Name'); ?></th>
					<th><?php AriWebHelper::displayResValue('Label.Type'); ?></th>
					<th><?php AriWebHelper::displayResValue('Label.Status'); ?></th>
				</tr>
				<?php
					foreach ($plugins as $plugin)
					{
						$pluginPath = AriSmartContentComponent::getPluginFilePath($plugin);
				?>
				<tr>
					<td><?php echo $plugin->PluginName; ?></td>
					<td class="center"><?php echo $plugin->Type; ?></td>
					<td class="center"><?php echo @file_exists($pluginPath) ? $installed : $notInstalled; ?></td>
				</tr>
				<?php
					}
				?>
			</table>
		</div>
		<div class="yui-hidden" id="diagSystem" style="padding: 4px; text-align: left;">
			<table cellPadding="4" class="ari-main-liquid-table">
				<tr>
					<th><?php AriWebHelper::displayResValue('Label.Name'); ?></th>
					<th class="width-3per noWrap"><?php AriWebHelper::displayResValue('Label.Status'); ?></th>
					<th class="width-3per noWrap"><?php AriWebHelper::displayResValue('Label.Action'); ?></th>
					<th class="width-min noWrap">&nbsp;</th>
				</tr>
				<tr>
					<td><?php AriWebHelper::displayResValue('Label.ASCContentPlugin'); ?></td>
					<td class="width-3per noWrap center"><?php echo $isPluginInstalled ? $installed : $notProperlyInstalled; ?></td>
					<td class="width-3per noWrap center">
						<?php if (!$isPluginInstalled): ?>
						<input type="button" class="button" value="<?php AriWebHelper::displayResValue('Label.TryToFix'); ?>" onclick="<?php echo J1_6 ? 'Joomla.submitbutton' : 'submitbutton'; ?>('diagnostics$fixPlugin');" />
						<input type="button" class="button" value="<?php AriWebHelper::displayResValue('Label.Clean'); ?>" onclick="<?php echo J1_6 ? 'Joomla.submitbutton' : 'submitbutton'; ?>('diagnostics$cleanPlugin');" />
						<?php else: ?>
						<?php AriWebHelper::displayResValue('Label.None'); ?>
						<?php endif; ?>
					</td>
					<td class="width-min noWrap center"><?php echo !$isPluginInstalled ? JHTML::_('tooltip', AriWebHelper::translateResValue('Tooltip.DiagPlugin'), AriWebHelper::translateResValue('Label.Suggestion')) : '&nbsp;'; ?></td>
				</tr>
				<tr>
					<td><?php AriWebHelper::displayResValue('Label.ASCModule'); ?></td>
					<td class="width-3per noWrap center"><?php echo $isModuleInstalled ? $installed : $notProperlyInstalled; ?></td>
					<td class="width-3per noWrap center">
						<?php if (!$isModuleInstalled): ?>
						<input type="button" class="button" value="<?php AriWebHelper::displayResValue('Label.TryToFix'); ?>" onclick="<?php echo J1_6 ? 'Joomla.submitbutton' : 'submitbutton'; ?>('diagnostics$fixModule');" />
						<input type="button" class="button" value="<?php AriWebHelper::displayResValue('Label.Clean'); ?>" onclick="<?php echo J1_6 ? 'Joomla.submitbutton' : 'submitbutton'; ?>('diagnostics$cleanModule');" />
						<?php else: ?>
						<?php AriWebHelper::displayResValue('Label.None'); ?>
						<?php endif; ?>
					</td>
					<td class="width-min noWrap center"><?php echo !$isModuleInstalled ? JHTML::_('tooltip', AriWebHelper::translateResValue('Tooltip.DiagModule'), AriWebHelper::translateResValue('Label.Suggestion')) : '&nbsp;'; ?></td>
				</tr>
			</table>
		</div>
	</div>
</div>

<input type="hidden" name="hidDiagActiveTab" id="hidDiagActiveTab" value="<?php echo $activeTab; ?>" />
<script type="text/javascript" language="javascript">
YAHOO.util.Event.onDOMReady(function()
{
	var diagTabs = new YAHOO.widget.TabView('diagTabContainer', {activeIndex: <?php echo $activeTab; ?>});
	diagTabs.on('activeIndexChange', function(e)
	{
		YAHOO.util.Dom.get('hidDiagActiveTab').value = e.newValue;
	});
});
</script>