<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Web.Page.PageBase');
AriKernel::import('Controllers.AriSmartContent.PluginController');
AriKernel::import('Components.AriSmartContent.Plugins.PluginHandlerManager');

class plugin_handlerAriPage extends AriPageBase 
{
	var $_handlerCode;
	
	function _init()
	{
		$handlerCode = AriRequest::getParam('handler');
		if (empty($handlerCode)) $this->sendResponse('');
		
		$this->_handlerCode = $handlerCode;

		parent::_init();
	}
	
	function execute()
	{
		$this->loadPlugins();

		$result =& AriSmartContentPluginHandlerRegister::runHandler($this->_handlerCode);

		$this->sendResponse($result);
	}
	
	function loadPlugins()
	{
		$pc = new AriSmartContentPluginController();
		$plugins = $pc->call('getClientPluginList');
		
		if (!$plugins) return ;
		
		$rootPath = AriSmartContentComponent::getPluginRootDir();
		foreach ($plugins as $pluginType => $specPlugins)
		{
			if (empty($specPlugins)) continue;

			$specRootPath = $rootPath . $pluginType . '/';
			foreach ($specPlugins as $specPlugin)
			{
				$pluginPath = $specRootPath . $specPlugin->Folder . '/' . ($specPlugin->FileName);
				if (!@file_exists($pluginPath)) continue;
			
				require_once $pluginPath; 
			}
		}
	}
}
?>