<?php
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class RFPROController extends JController
{
	function RFPROController()
	{
		//add path to tables classes
		JTable::addIncludePath( RSS_FACTORY_COMPONENT_ADMIN_PATH.DS.'tables' );

		//load the helpers; from now on, we can use any method defined in helpers
		require_once(RSS_FACTORY_COMPONENT_PATH.DS.'helpers'.DS.'helper.php');

		//require the main view - the class in this file is the ancestor for all the other views
		require_once(RSS_FACTORY_COMPONENT_PATH.DS.'views'.DS.'view.php');

		parent::__construct();
	}

	function processXajaxRequest()
	{
		require(RSS_FACTORY_COMPONENT_PATH.DS.'rssfactory_pro.xajax.php');
		$req = new JRfProXajax();
		$xajax =& $req->getXajaxInstance();
		ob_end_clean();
		$xajax->processRequest();
		exit();
	}

	function refreshRSS()
	{
    	global $mainframe;
        $database = &JFactory::getDBO();
        $config =& RFProHelper::getConfig();

		JModel::addIncludePath(RSS_FACTORY_COMPONENT_ADMIN_PATH.DS.'models');

		$model =& $this->getModel('refreshsources','RFProAdminModel');

		//let pseudoCron override the password; it has its own authentication
		$pseudoCron = JRequest::getVar('pseudoCron',0,'default','int');
		if($pseudoCron)
		{
			$model->refreshFeedSources(true);
			return;
		}

		if(!$model->checkPassword())
		{
			$this->setRedirect('index.php','Incorrect password!');
			exit();
		}
		$model->refreshFeedSources();

		$view =& $this->getView('refreshfeedsources');
		$view->setModel($model);
		$view->display();
	}
 
	function showCats()
	{
		$config =& RFProHelper::getConfig();

		if(!$config->showcategory)
		{
			$this->listRSS();
			return;
		}

		$categoryId = JRequest::getVar('id',0,'default','int');

		$model =& $this->getModel('categories');
		$model->loadCategories($categoryId,true,2);

		//if there're no subcategories, show the sources from current category
		if(!$model->getCategories()){
			$this->listRSS();
			return;
		}

		$view =& $this->getView('displayHeader');
		$view->display();

		$view =& $this->getView('displayCategories');
		$view->setModel($model);
		$view->display();

		$view =& $this->getView('displayFooter');
		$view->display();

		$this->PseudoCron();
	}

    function listRSS()
	{
		$config =& RFProHelper::getConfig();

		//if category display is not used, we don't need the categoryId
		$forcecategory = Jrequest::getVar('forcecategory');
		$categoryId = ($config->showcategory || $forcecategory) ? JRequest::getVar('id',0,'default','array') : 0;
		$task = JRequest::getVar('task','','default','string');

		$view =& $this->getView('displayHeader');
		$view->display();
		

		$forceliststyle = JRequest::getVar('forceliststyle',null,'default','string');
		$liststyle = strtolower( $forceliststyle ? $forceliststyle : $config->liststyle );

		$modelName = ('list'==$liststyle) ? 'feedSourcesList' : 'feedSourcesTiles';
		$model =& $this->getModel($modelName);

		$model->setCategories($categoryId);
		$model->loadStories();

		$view =& $this->getView( 'displayStories'.(('list'==$liststyle) ? 'list' : 'tiles') );
		$view->setModel($model,true);

		$modelPrepareOutput =& $this->getModel('prepareStoriesOutput');
		$modelPrepareOutput->setCategoryId($categoryId);
		$modelPrepareOutput->setAds();
		$view->setModel($modelPrepareOutput);

		$view->display($liststyle);

		$view =& $this->getView('displayFooter');
		$view->display();

		$this->PseudoCron();
    }

    function visitLink()
	{
        $config =& RFProHelper::getConfig();

    	$model =& $this->getModel('visitstory');
    	$model->setStoryId( JRequest::getVar('id',0,'default','int') );

		if(!$model->loadStory())
		{
			$view =& $this->getView('visitstory','html');
			$view->setLayout('unknownStory');
			$view->display();

			return;
		}

    	$model->markVisited();

		if(!$model->checkRefererSite())
		{
			$view =& $this->getView('visitstory','badreferer');
			$view->setModel($model);
			$view->setLayout('badreferer');
			$view->display();

			return;
		}

		switch($config->output_iframe)
		{
			case 'popup_original_site':
			case 'modal':
	   			$story = $model->getStory();
				$this->setRedirect($story->item_link);
				return;
			break;
			case 'wrapper':
				$view =& $this->getView('visitstory','html');
				$view->setModel($model);
				$view->setLayout('iframe');
				$view->display();
			break;
			case 'toolbar':
				$view =& $this->getView('visitstory','toolbar');
				$view->setModel($model);
				$view->setLayout('toolbar');
				$view->display();
			break;
		}

		$this->PseudoCron();
    }

    function submitFeeds()
	{
		if(!RFProHelper::userMaySubmitFeeds())
		{
			return;
		}

		$view =& $this->getView('submitfeedsources');
		$view->display();
	}
	
	function saveSubmittedFeed()
	{
		if(!RFProHelper::userMaySubmitFeeds())
		{
			return;
		}
		
		if(!function_exists('recaptcha_get_html'))
		{
			require(JPATH_COMPONENT_SITE.DS.'helpers'.DS.'recaptcha'.DS.'recaptchalib.php');
		}
		
		// Get a key from http://recaptcha.net/api/getkey
		$privatekey = "6LeneAgAAAAAAPWeMV8roQwvARbQeclWv8beoT0K";
		$recaptcha_challenge_field = JRequest::getVar('recaptcha_challenge_field');
		$recaptcha_response_field = JRequest::getVar('recaptcha_response_field');

		$resp = recaptcha_check_answer ($privatekey, $_SERVER["REMOTE_ADDR"], $recaptcha_challenge_field, $recaptcha_response_field);
		if(!$resp->is_valid)
		{
			JError::raiseWarning(1,'CAPTCHA failed!');
			$this->setRedirect('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=submitFeeds');
			return;
		}

		$submittedFeed =& JTable::getInstance('rfprosubmitted');
		$submittedFeed->bind($_REQUEST);
		$submittedFeed->id=null;

		if(!trim($submittedFeed->url))
		{
			JError::raiseWarning(1,'Empty URL!');
			$this->setRedirect('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=submitFeeds');
			return;
		}
		$submittedFeed->userid = $user->id;
		$submittedFeed->date = date('Y-m-d H:i:s');
		
		$submittedFeed->store();
		
		$this->setRedirect('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=submitFeeds', RFPRO_WORD4SUBMITSUCCESSFUL);
		return;
	}

    function getModalStory()
	{
    	$view =& $this->getView('displayModalStory');
    	$view->display();
    }

	function PseudoCron(){
		if(!RFProHelper::ValidPseudoCron())
		{
			return false;
		}

		$session = &JFactory::getSession();

		$url = RSS_FACTORY_COMPONENT_URI.'helpers/pseudorefresh.php?received_key='.$session->get('com_'.RSS_FACTORY_COMPONENT_NAME.'.secretkey');
		$name = 'com_'.RSS_FACTORY_COMPONENT_NAME.'pseudoCronFrame';
		$attribs = 'style="width:0px;height:0px;" frameborder="0" width="0" height="0"';

		echo JHTML::iframe($url,$name,$attribs);
	}
}
?>