<?php
defined('_JEXEC') or die('Restricted access');

class JHTMLDisplayStories
{
	function imgBullet($story)
	{
		$config =& RFProHelper::getConfig();

		if ($config->hideBullet)
		{
			return;
		}
		$bullet = $story->isVisited ? 'exp1.gif' : 'exp0.gif';	  		
		$imgBullet = '<img class="feedbump" name="img'.$story->id.'" alt="feedbump" src="'.RSS_FACTORY_COMPONENT_URI.'/images/'.$bullet.'" />';
		return $imgBullet;
	}

	function icoSite($story)
	{
		$config =& RFProHelper::getConfig();

		if (!$config->use_favicons){
 			return;
 		}

		if (file_exists(RSS_FACTORY_COMPONENT_PATH.DS.'images'.DS.'ico_'.md5($story->rssid).'.png')){
			$img_src= RSS_FACTORY_COMPONENT_URI.'images/ico_'.md5($story->rssid).'.png';
		}
		else{
			$img_src= RSS_FACTORY_COMPONENT_URI.'images/default.png';
		}
		
		return '<img class="siteicon" src="'.$img_src.'" border="0" alt="" />';		
	}

	function storyDate($story)
	{
		$config =& RFProHelper::getConfig();

		if ($config->hideDate)
		{
			return;
		}

		$story->item_date = JHTML::date($story->item_date,'%Y-%m-%d %H:%M:%S');		
		$storyDate = ($story->item_date=='') ? date($config->date_format, strtotime($story->date)) : date($config->date_format, strtotime($story->item_date));

		return $storyDate;
	}

	function linkChannel($story)
	{
		$config =& RFProHelper::getConfig();

		if(!$config->channellink)
		{
			return;
		}

		return JHTML::tooltip($story->channel_description,$story->channel_title,'',$config->channellink,$story->channel_link);
	}

	function linkReadMore($story,$text=RFPRO_READ_MORE)
	{
		$config =& RFProHelper::getConfig();

		$linkHref = JHTML::_('displayStories.hrefReadMore',$story);
		$linkText = ($text==RFPRO_READ_MORE) ? '<span class="readmore">'.$text.'</span></a>' : $text;
		$linkAttribs = 'class="'.(isset($story->prefix) ? $story->prefix : '').'feedtablelink" '.
						//( $config->showfeeddescription=='table' ? ' onclick="swapimg(\'img'.$story->id.'\');" ' : '' ).
						( ' onclick="swapimg(\'img'.$story->id.'\');" ' ).
						(($config->output_iframe=='popup_original_site' ) ? ' target="_blank" ' : '').
						(($config->output_iframe=='modal' ) ? ' rel="{handler:\'iframe\', size:{x:800,y:600}}" ' : '');

		return JHTML::link($linkHref,$linkText,$linkAttribs);
	}

	function hrefReadMore($story)
	{
		$config =& RFProHelper::getConfig();
		$Itemid = JRequest::getVar('Itemid');

		if('original_site' == $config->readmore_options)
		{
			return $story->item_link;
		}

		return JRoute::_('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=visit&id='.$story->id.'&Itemid='.$Itemid);
	}

	function enclosures($story)
	{
		$config =& RFProHelper::getConfig();

		if(!$config->show_enclosures)
		{
			return;
		}

		$es = unserialize(base64_decode($story->item_enclosure));
		if(count($es)){
			$itemEnclosures = '<div class="rfpro_enclosures">';
			$itemEnclosures .= RFPRO_WORD4MEDIAFILES.'<br />';
			$i=1;

			foreach($es as $e)
			{
				$filename = isset($e['link']) ? end(explode( '/', $e['link']) ) : 'File';
				$filename = JString::substr( $filename,0,JString::strpos($filename,'?') );
				$filetype = isset($e['type']) ? $e['type'] : RFPRO_WORD4MEDIAFILE;
				$filesize = isset($e['length'])?(round( $e['length']/1024, 2 ).'KB'):'';

				$itemEnclosures .= '<span>'.$i.'.&nbsp;<a target="_blank" rel="nofollow" href="'.$e['link'].'">'.$filename.'</a>';
				$itemEnclosures .='&nbsp;('.$filetype.', '.$filesize.')';
				$itemEnclosures .='</span><br />';
			}
			$itemEnclosures .= '</div>';

			return $itemEnclosures;
		}
		
	}

	function tableTitleLink($story)
	{
		$title =
		'<span class="feedtablelink" onclick="opendiv(\''.$story->prefix.'ICONT'.$story->id.'\');" style="cursor: pointer">'.
			$story->item_title.
		'</span>';

		return $title;
	}

	function storyTitleLink($story)
	{
		
		return JHTML::_('displaystories.linkReadMore',$story,$story->item_title);

	}

	function storyChannelLink($story)
	{
		$config =& RFProHelper::getConfig();

		return JHTML::link($story->channel_link,$config->channellink);
	}

	function storyDescription($story)
	{
		return $story->item_description;
	}

	function tableContent($story)
	{
		$config =& RFProHelper::getConfig();
		$display = $config->table_view_open ? 'block' : 'none';

		$content =
		'<div style="display:'.$display.';" class="excerpt" id="'.$story->prefix.'ICONT'.$story->id.'">'.
			'<div>'.$story->item_description.'</div>'.
			'<br />'.
			'<div>'.JHTML::_('displayStories.enclosures',$story).'</div>'.
			'<br />'.
     		'<div>'.JHTML::_('displayStories.linkReadMore',$story).'</div>'.
     		'<br />'.
			'<div class="rfpro_voting_container">'.JHTML::_('displayStories.votingCell',$story).'</div>'.
		'</div>';

		return $content;
	}

	function votingThumbs($story)
	{
		$config =& RFProHelper::getConfig();

		if(!$config->enablevoting)
		{
			return;
		}

		$xMethods =& RFProHelper::getXMethods();

   		$img_up = RSS_FACTORY_COMPONENT_URI.'images/thumb-up-grey.gif';
   		$img_up_over = RSS_FACTORY_COMPONENT_URI.'images/thumb-up-blue.gif';
   		$img_down = RSS_FACTORY_COMPONENT_URI.'images/thumb-down-grey.gif';
   		$img_down_over = RSS_FACTORY_COMPONENT_URI.'images/thumb-down-red.gif';

		$xMethods['voterssstory']->setParameter(0,XAJAX_JS_VALUE,$story->id);
   		$xMethods['voterssstory']->setParameter(1,XAJAX_JS_VALUE,1);
   		$xMethods['voterssstory']->setParameter(2,XAJAX_JS_VALUE,'\''.$story->prefix.'\'');
   		$img_vote_up = '<span><img src="'.$img_up.'" style="cursor:pointer;" alt="" onmouseover="this.src=\''.$img_up_over.'\'" onmouseout="this.src=\''.$img_up.'\'" onclick="'.$xMethods['voterssstory']->getScript().'" /></span>';

   		$xMethods['voterssstory']->setParameter(1,XAJAX_JS_VALUE,-1);
   		$img_vote_down = '<span><img src="'.$img_down.'" style="cursor:pointer;" alt="" onmouseover="this.src=\''.$img_down_over.'\'" onmouseout="this.src=\''.$img_down.'\'" onclick="'.$xMethods['voterssstory']->getScript().'" /></span>';

   		return $img_vote_up.$img_vote_down;
	}

	function votingCell($story)
	{
		$config =& RFProHelper::getConfig();

		if(!$config->enablevoting)
		{
			return;
		}

		if(isset($story->rating) && $story->rating!==null)
		{
			$actualRating = $config->negativerating ? $story->rating : max($story->rating,0);
			$wordVote = ($story->rating==1 ? RFPRO_WORD4VOTE : RFPRO_WORD4VOTES );
		}
		else
		{
			$actualRating = RFPRO_WORD4NOTRATEDYET;
			$wordVote = '';
		}

		$idNrVotesDIV = $story->prefix.'rssStoryRating_'.$story->id;
		$spanNrVotes = '<span id="'.$idNrVotesDIV.'">' . $actualRating . '</span>';
		$idWordVoteDIV = $story->prefix.'rssWordVote_'.$story->id;
		$spanWordVote = '<span id="'.$idWordVoteDIV.'">' . $wordVote . '</span>';		
		
		return RFPRO_WORD4RATING.(JHTML::_('displaystories.votingThumbs',$story)).$spanNrVotes.$spanWordVote;
	}

	function diggVotes($story)
	{
		$config =& RFProHelper::getConfig();

		if(!$config->enablevoting)
		{
			return;
		}

		if($story->rating!==null)
		{
			$actualRating = $config->negativerating ? $story->rating : max($story->rating,0);
			$wordVote = ($story->rating==1 ? RFPRO_WORD4VOTE : RFPRO_WORD4VOTES );
		}
		else
		{
			$actualRating = 0;
			$wordVote = '';
		}

		$idNrVotesDIV = $story->prefix.'rssStoryRating_'.$story->id;
		$spanNrVotes = '<span id="'.$idNrVotesDIV.'">' . $actualRating . '</span>';
		$idWordVoteDIV = $story->prefix.'rssWordVote_'.$story->id;
		$spanWordVote = '<span id="'.$idWordVoteDIV.'">' . $wordVote . '</span>';
		
		$html = '<span class="digg_item_rating_number">'.$spanNrVotes.'</span><br />'.
		'<span class="digg_item_rating_wordVote">'.$spanWordVote.'</span>';

		return $html;
	}

	function modalStory($story)
	{
		$url = JRoute::_('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=getModalStory&id='.$story->id.'&format=raw&jsInHead=0');
		$text = $story->item_title;
		$attribs = 'class="feedtablelink" rel="{handler:\'iframe\'}"';

		return JHTML::link($url,$text,$attribs);
	}

	function prevLink($story)
	{
		$Itemid = JRequest::getVar('Itemid');

		$url = JRoute::_('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=visit&id='.$story->id.'&Itemid='.$Itemid);

		return JHTML::link($url,RFPRO_WORD4PREVIOUS);
	}

	function nextLink($story)
	{
		$Itemid = JRequest::getVar('Itemid');

		$url = JRoute::_('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=visit&id='.$story->id.'&Itemid='.$Itemid);
		
		return JHTML::link($url,RFPRO_WORD4NEXT);
	}

	function pickRandom()
	{
		$Itemid = JRequest::getVar('Itemid');

		$database =& JFactory::getDBO();
		$database->setQuery("SELECT `id` FROM `#__rssfactory_cache` ORDER BY RAND() LIMIT 1");
		$id = $database->loadResult();
		$url = JRoute::_('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=visit&id='.$id.'&Itemid='.$Itemid);
		
		return JHTML::link($url,RFPRO_WORD4RANDOM);
	}
}
?>