<?php
defined('_JEXEC') or die('Restricted access.');

class RFPROModelFeedSourcesList extends JModel
{
	var $parentCategory = null;
	var $sources = null;
	var $stories = null;
	var $pagination = null;
	var $categoryIds = null;

	function setCategories($categoryIds)
	{
		//remove category with id=0
		$categoryIds = array_diff((array) $categoryIds, array(0) );
		foreach($categoryIds as $categoryId)
		{
			$this->categoryIds[] = intval($categoryId);
		}

		//this is cheap, but i'm in a hurry now
		$category =& JTable::getInstance('rfpronestedset');
		$category->load($this->categoryIds[0]);
		$this->parentCategory = $category;
	}

	function getParentCategory()
	{
		return $this->parentCategory;
	}

	function deleteOldVisits()
	{
		$database =& JFactory::getDBO();
		$query = "DELETE FROM `#__rssfactory_user` WHERE UNIX_TIMESTAMP()-UNIX_TIMESTAMP(`date`)>3600";
        $database->setQuery( $query );
        $database->query();
	}

	function generatePagination()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$task = JRequest::getVar('task','','default','string');
		$searchterm = JRequest::getVar('search','','default','string');
		$limitstart = JRequest::getVar('limitstart',0,'default','int');

		$parentCategory = $this->getParentCategory();

		$query = "SELECT COUNT(`c`.`id`)
					FROM `#__rssfactory_cache` AS c
					LEFT JOIN `#__rssfactory` AS r
						ON `c`.`rssid`=`r`.`id`
					WHERE `r`.`published`='1' AND `c`.`archived`='0' ".

					( count($this->categoryIds) ? " AND `r`.`cat` IN (".$database->getEscaped( implode(',',$this->categoryIds) ).") " : " ").

					($task=='search' ? "AND (`c`.`item_title` LIKE '%". $database->getEscaped($searchterm) ."%' OR c.item_description LIKE '%". $database->getEscaped($searchterm) ."%' ) " : " ");

		$database->setQuery($query);

		$total = $database->loadResult();
		$limitNumberStories = $config->feedsperpage ? $config->feedsperpage : $total;

		JLoader::import('pagination',RSS_FACTORY_COMPONENT_PATH.DS.'helpers');
		$pageNav = new JRSSFactoryPRO_Pagination(0,$total,$limitstart,$limitNumberStories);

		$this->pagination =& $pageNav;
	}

	function &getPagination()
	{
		return $this->pagination;
	}

	function loadStories()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$this->generatePagination();

		$task = JRequest::getVar('task','','default','string');
		$searchterm = JRequest::getVar('search','','default','string');

		$parentCategory = $this->getParentCategory();
		$pageNav = $this->getPagination();

		$query = "SELECT `c`.*, `r`.`id` AS feedid,`r`.`nrfeeds`, `r`.`encoding`, `r`.`cat`, `r`.`title`, `ru`.`id` AS isVisited,
					cat.id as categoryId,cat.name as categoryName,cat.description as categoryDescription".
					($config->enablevoting ? ",SUM(`rv`.`voteValue`) AS rating " : " ").
					"FROM `#__rssfactory_cache` AS c
					LEFT JOIN  `#__rssfactory` AS r
						ON `c`.`rssid`=`r`.`id`
					LEFT JOIN `#__rssfactory_nestedcategories` AS cat
						ON `r`.`cat`=`cat`.`id`
					LEFT JOIN `#__rssfactory_user` AS ru
						ON `c`.`id`=`ru`.`newsid` ".
					($config->enablevoting ? 
					" LEFT JOIN `#__rssfactory_voting` AS rv
						ON `c`.`id`=`rv`.`cacheId` ":" ").
				 	" WHERE `r`.`published` = '1' AND `c`.`archived`='0' "

						.( count($this->categoryIds) ? " AND `r`.`cat` IN (".$database->getEscaped( implode(',',$this->categoryIds) ).") " : " ")

						.($task=='search'?"AND (`c`.`item_title` LIKE '%". $database->getEscaped($searchterm) ."%' OR `c`.`item_description` LIKE '%". $database->getEscaped($searchterm) ."%' ) " : " ").
					" GROUP BY `c`.`id` ".
					" ORDER BY ".($config->orderbydate ? " `c`.`item_date` DESC, ":" ")." `r`.`ordering`,`c`.`id` ";
		$database->setQuery($query,$pageNav->limitstart,$pageNav->limit);
		$stories = $database->loadObjectList();

		$this->stories =& $stories;
	}

	function &getStories()
	{
		return $this->stories;
	}
}
?>