<?php
defined('_JEXEC') or die('Restricted access.');

class RFPROModelModFeedSourcesTiles extends JModel
{
	var $sources = null;
	var $stories = array();	

	
	function ShortenText($in_text,$nr_chars)
	{	
		if(!$nr_chars){
			return $in_text;
		}

	    $text = $in_text." ";
	    if($nr_chars){
			$text = JString::substr($text,0,$nr_chars);
	    	$text = JString::substr($text,0,JString::strrpos($text,' '));
	    }

		if((JString::strlen($in_text))==(JString::strlen($text))){
			return $text;
		}

	    $text = $text."...";

	    return $text;
	}

	function loadStories()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();
		$option = JRequest::getVar('option');
		
		$params = $config->moduleParams;

		$moduleId = $config->moduleId;
		$moduleclass_sfx 		=$params->get( 'moduleclass_sfx' );
		$sort_order				=$params->get( 'sort_order' );
		$nr_feeds				=$params->get( 'nr_feeds' );
		$adv_filter				=$params->get( 'adv_filter' );
		$show_Category			=(array) $params->get( 'show_Category', array() );
		$firstTitleChars		=$params->get( 'firstTitleChars' );
		$firstContentChars		=$params->get( 'firstContentChars' );
		$displayAds				=$params->get( 'display_ads' );

		//build ORDER BY
		
		$orderCond = array();
		switch($sort_order){
			case 'none':
				
			break;
			case 'date':
				$orderCond[] = ' `cache`.`item_date` DESC ';
			break;
			case 'random':
				$orderCond[] =' RAND() ';
			break;
			case 'voted':
				$orderCond[] = ' rating DESC ';
			break;
		}
		$orderCond[] = ' `r`.`id` ';
		
		$order = ' ORDER BY '.implode(' , ',$orderCond);
		
		//beginning build WHERE
		
		//show only stories from published feeds
		$where = " WHERE `r`.`published`='1' AND `cache`.`archived`=0 ";

		if(count($show_Category))
		{
			$where .= ' AND `r`.`cat` IN ('.implode(',',$show_Category).') ';
		}

		//advanced filtering conditions
		if ($adv_filter && $option=='com_content'){
		
		    $view=JRequest::getVar('view','article');
		    $curcat='';
		
			//check if user is viewing an article<i></i>
		    if ($view=='article' || $view=='archive'){
		        $art_id = JRequest::getVar('id',0,'default','int');
				$database->setQuery("select * from #__content where id=$art_id ");
				$row=$database->loadObject();
		
				$curcat=$row->catid;
			}
			//check if user is viewing a category
		    elseif ($view=='category'){
		    	$curcat=JRequest::getVar('id', 0, 'default', 'int');
		    }
		    //check if the current category matches any "advanced filtering" setting
			for($i=1;$i<=9;$i++){
				if ($curcat==$params->get( "catid$i" )){
					$where .= " AND `r`.`cat`='".$database->getEscaped( $params->get( 'show_Category'.$i ) )."' ";
					break;
				}
			}
		}
		
		$query = 'SELECT `cache`.*, `ru`.`id` AS isVisited, `r`.`id` AS sourceId, `r`.`title` AS sourceTitle, '.$moduleId.' AS prefix'.
					( $config->enablevoting ? ', SUM(`rv`.`voteValue`) AS rating ':' ').
					' FROM `#__rssfactory_cache` AS cache '.
					' LEFT JOIN `#__rssfactory` AS r '.
						' ON `cache`.`rssid`=`r`.`id` '.
					' LEFT JOIN `#__rssfactory_user` AS ru '.
						' ON `cache`.`id`=`ru`.`newsid` '.
					( $config->enablevoting ?
					' LEFT JOIN `#__rssfactory_voting` AS rv '.
				 		' ON `cache`.`id`=`rv`.`cacheId` ':' ').
					$where.
					" GROUP BY `cache`.`id` ".
					$order;

		$database->setQuery($query,0,$nr_feeds);
		//vardump($database->_sql);
		$rows=$database->loadObjectList();

		$rowsBySource = array();

		$currentSource = null;
		foreach ($rows as $k=>$row)
		{
			if($currentSource != $row->sourceId)
			{
				$currentSource = $row->sourceId;
				$rowsBySource[$currentSource] = array();
			}

			$rowsBySource[$currentSource]['sourceTitle'] = $row->sourceTitle;
			$row->item_title = $this->ShortenText($row->item_title,$firstTitleChars);
			$row->item_description = $this->ShortenText($row->item_description,$firstContentChars);
			$rowsBySource[$currentSource]['stories'][] = $row;
		}

		$this->stories =& $rowsBySource;
	}

	function &getStories()
	{
		return $this->stories;
	}
}

	

?>