<?php
defined('_JEXEC') or die('Restricted access.');

class RFPROModelplgFeedSourcesList extends JModel
{
	var $parentCategory = null;
	var $sources = null;
	var $stories = array();
	var $pagination = null;
	var $categoryIds = null;

	function setCategories($categoryIds)
	{
		//remove category with id=0
		$categoryIds = array_diff((array) $categoryIds, array(0) );
		foreach($categoryIds as $categoryId)
		{
			$this->categoryIds[] = intval($categoryId);
		}

		//this is cheap, but i'm in a hurry now
		$category =& JTable::getInstance('rfprocategory');
		$category->load($this->categoryIds[0]);
		$this->parentCategory = $category;
	}

	function getParentCategory()
	{
		return $this->parentCategory;
	}

	function deleteOldVisits()
	{
		$database =& JFactory::getDBO();
		$query = "DELETE FROM `#__rssfactory_user` WHERE UNIX_TIMESTAMP()-UNIX_TIMESTAMP(`date`)>3600";
        $database->setQuery( $query );
        $database->query();
	}

	function generatePagination()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$task = JRequest::getVar('task','','default','string');
		$searchterm = JRequest::getVar('search','','default','string');
		$limitstart = JRequest::getVar('limitstart',0,'default','int');

		$parentCategory = $this->getParentCategory();

		$query = "SELECT COUNT(`c`.`id`)
					FROM `#__rssfactory_cache` AS c
					LEFT JOIN `#__rssfactory` AS r
						ON `c`.`rssid`=`r`.`id`
					WHERE `r`.`published`='1' AND `c`.`archived`='0' ".

					( count($this->categoryIds) ? " AND `r`.`cat` IN (".$database->getEscaped( implode(',',$this->categoryIds) ).") " : " ").

					($task=='search' ? "AND (`c`.`item_title` LIKE '%". $database->getEscaped($searchterm) ."%' OR c.item_description LIKE '%". $database->getEscaped($searchterm) ."%' ) " : " ");

		$database->setQuery($query);

		$total = $database->loadResult();
		$limitNumberStories = $config->feedsperpage ? $config->feedsperpage : $total;

		JLoader::import('pagination',RSS_FACTORY_COMPONENT_PATH.DS.'helpers');
		$pageNav = new JRSSFactoryPRO_Pagination(0,$total,$limitstart,$limitNumberStories);

		$this->pagination =& $pageNav;
	}

	function &getPagination()
	{
		return $this->pagination;
	}

	function loadStories()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();
		
		$this->generatePagination();

		$task = JRequest::getVar('task','','default','string');
		$searchterm = JRequest::getVar('search','','default','string');

		$parentCategory = $this->getParentCategory();
		$pageNav = $this->getPagination();

		$query = "SELECT `c`.*, `r`.`id` AS feedid,`r`.`nrfeeds`, `r`.`encoding`, `r`.`cat`, `r`.`title`, `ru`.`id` AS isVisited".
					($config->enablevoting ? ",SUM(`rv`.`voteValue`) AS rating " : " ").
					"FROM `#__rssfactory_cache` AS c
					LEFT JOIN  `#__rssfactory` AS r
						ON `c`.`rssid`=`r`.`id`
					LEFT JOIN `#__rssfactory_user` AS ru
						ON `c`.`id`=`ru`.`newsid` ".
					($config->enablevoting ? 
					" LEFT JOIN `#__rssfactory_voting` AS rv
						ON `c`.`id`=`rv`.`cacheId` ":" ").
				 	" WHERE `r`.`published` = '1' AND `c`.`archived`='0' "

						.( count($this->categoryIds) ? " AND `r`.`cat` IN (".$database->getEscaped( implode(',',$this->categoryIds) ).") " : " ")

						.($task=='search'?"AND (`c`.`item_title` LIKE '%". $database->getEscaped($searchterm) ."%' OR `c`.`item_description` LIKE '%". $database->getEscaped($searchterm) ."%' ) " : " ").
					($config->enablevoting ? " GROUP BY `c`.`id` ":" ").
					" ORDER BY ".($config->orderbydate ? " `c`.`item_date` DESC, ":" ")." `r`.`ordering`,`c`.`id` ";
		$database->setQuery($query,$pageNav->limitstart,$pageNav->limit);
		$stories = $database->loadObjectList();

		$this->stories =& $stories;
	}

	function &getStories()
	{
		return $this->stories;
	}

	function setStories($occurrence)
	{
		$database =& JFactory::getDBO();
		$cfg =& RFProHelper::getConfig();

		$session =& JFactory::getSession();
		$sessionName = $session->getName();

		$cook = $_COOKIE[$sessionName];

		preg_match('/categoryId="([0-9,\,]*)"/',$occurrence,$aCatIds);
		if(isset($aCatIds[1])){
			$catids=trim($aCatIds[1],',');
			$catids=mysql_real_escape_string($catids);
		}
		else
			$catids=null;

		preg_match('/sourceId="([0-9,\,]*)"/',$occurrence,$aSourceIds);
		if(isset($aSourceIds[1])){
			$sourceids=trim($aSourceIds[1],',');
			$sourceids=mysql_real_escape_string($sourceids);
		}
		else
			$sourceids=null;

		preg_match('/searchTerm="(.*?)"/',$occurrence,$aSearchTerms);
		if(isset($aSearchTerms[1]))
			$searchterms=explode(',',mysql_real_escape_string($aSearchTerms[1]));
		else
			$searchterms=null;

		preg_match('/nrFeeds="([0-9]*)"/',$occurrence,$aNrFeeds);
		if(isset($aNrFeeds[1]))
			$nrfeeds=mysql_real_escape_string($aNrFeeds[1]);
		else
			$nrfeeds=10;

		preg_match('/outputStyle="(.*?)"/',$occurrence,$aOutputStyle);
		if(isset($aOutputStyle[1])){
			$outputstyle=mysql_real_escape_string($aOutputStyle[1]);
			if($outputstyle!='tooltip' && $outputstyle!='table' && $outputstyle!='modal' && $outputstyle!='diggstyle')
				$outputstyle='table';
		}
		else
			$outputstyle='table';
		$cfg->showfeeddescription = $outputstyle;

		preg_match('/suppressImg="(.*?)"/',$occurrence,$aSuppressImg);
		if(isset($aSuppressImg[1])){
			$suppressImg = mysql_real_escape_string($aSuppressImg[1]);
		}
		else{
			$suppressImg = 0;
		}
		$cfg->suppress_img = $suppressImg;

		preg_match('/suppressEmbedded="(.*?)"/',$occurrence,$aSuppressEmbedded);
		if(isset($aSuppressEmbedded[1])){
			$suppressEmbedded = mysql_real_escape_string($aSuppressEmbedded[1]);
		}
		else{
			$suppressEmbedded = 0;
		}
		$cfg->suppress_embedded = $suppressEmbedded;

		preg_match('/tableAlwaysOpen="([0,1]{1})"/',$occurrence,$aTableAlwaysOpen);
		if(isset($aTableAlwaysOpen[1])){
			$tablealwaysopen = $aTableAlwaysOpen[1];
		}
		else{
			$tablealwaysopen = 0;
		}
		$cfg->table_view_open = $tablealwaysopen;

		preg_match('/orderByDate="([0,1]{1})"/',$occurrence,$aOrderByDate);
		if(isset($aOrderByDate[1]))
			$orderByDate = $aOrderByDate[1];
		else
			$orderByDate = 0;

		preg_match('/displayAds="([0,1]{1})"/',$occurrence,$aDisplayAds);

		if(isset($aDisplayAds[1]))
			$displayAds = $aDisplayAds[1];
		else
			$displayAds = 0;


		//query for extracting feeds
		$query = 'SELECT cache.*,r.encoding FROM #__rssfactory_cache cache LEFT JOIN #__rssfactory r ON cache.rssid=r.id WHERE r.published=1 ';
		$query .= $catids?' AND r.cat IN ('.$catids.') ':'';
		$query .= $sourceids?' AND r.id IN ('.$sourceids.') ':'';

		$searchQuery = '';
		if(count($searchterms)){
			$i=0;
			$searchQuery = 'AND ( ';
			foreach($searchterms as $searchterm){
				$searchQuery .= " cache.item_title LIKE '%$searchterm%' OR cache.item_description LIKE '%$searchterm%' ";
				$i++;

				if($i<count($searchterms))
					$searchQuery .= ' OR ';
			}
			$searchQuery .= ' ) ';
		}
		

		if($orderByDate){
			$query .= ' ORDER BY cache.item_date DESC,r.ordering,cache.id';
		}
		else{
			$query .= ' ORDER BY r.ordering,cache.id';
		}

		$database->setQuery($query,0,$nrfeeds);

		$rows = $database->loadObjectList();

		if($displayAds){

			//Random positioning of ads
	        if (count($rows)==0){
	        	$rand_keys =array();
	        	$rows=array();
	        }
	        else{
	        	if (count($ads)==1){
	        		$rand_keys =array(array_rand($rows, 1));
	        	}
				else{
	        		$rand_keys =(count($ads)>0)? array_rand(range(1, count($ads)), count($ads)):array();
	        	}
	        }
	    }
	    else{
			$rand_keys = array();
		}
		
        if (count($rows))
        {
	        foreach ($rows as $k=>$row){
        		//showing the bullet
				$query = "SELECT * FROM #__rssfactory_user where sid='$cook' and newsid='$row->id' ";
    			$database->setQuery( $query );
    			if (!$database->loadResult()){
    				$img[$row->id]='exp0.gif';
    			}
				else{
    				$img[$row->id]='exp1.gif';
                }

                unset($rows[$k]);
                $rows[$k]=$row;
        	}
		}

		$query = "SELECT `c`.*, `r`.`id` AS feedid,`r`.`nrfeeds`, `r`.`encoding`, `r`.`cat`, `r`.`title`, `ru`.`id` AS isVisited, 'prefix'".
					($cfg->enablevoting ? ",SUM(`rv`.`voteValue`) AS rating " : " ").
					"FROM `#__rssfactory_cache` AS c
					LEFT JOIN  `#__rssfactory` AS r
						ON `c`.`rssid`=`r`.`id`
					LEFT JOIN `#__rssfactory_user` AS ru
						ON `c`.`id`=`ru`.`newsid` ".
					($cfg->enablevoting ? 
					" LEFT JOIN `#__rssfactory_voting` AS rv
						ON `c`.`id`=`rv`.`cacheId` ":" ").
				 	" WHERE `r`.`published` = '1' AND `c`.`archived`='0' "

						.( strlen($catids) ? " AND `r`.`cat` IN (".$database->getEscaped( $catids ).") " : " ")

						.$searchQuery.
					($cfg->enablevoting ? " GROUP BY `c`.`id` ":" ").
					" ORDER BY ".($cfg->orderbydate ? " `c`.`item_date` DESC, ":" ")." `r`.`ordering`,`c`.`id` ";
		$database->setQuery($query,0,$nrfeeds);
		$stories = $database->loadObjectList();

		$this->stories =& $stories;
		
	}
}

	

?>