<?php
/*
 * ARI Colorbox
 *
 * @package		ARI Colorbox
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Module.Providers.FlickrProvider');
AriKernel::import('Module.Lightbox.Models.GalleryModel');
AriKernel::import('Colorbox.Models.Templates.SimpleGalleryTemplate');

class AriColorboxFlickrModel extends AriGalleryModel
{
	var $_prefix = 'AriColorbox';
	
	function execute($modelParams, $params, $templatePath)
	{
		$cssClass = uniqid('acb', false);
		$flickrProvider = new AriFlickrProvider($modelParams, null, 'mod_aricolorbox');
		$flickrData = $this->getData(
			$flickrProvider->getData($modelParams),
			$modelParams, 
			$params,
			$cssClass);
		
		$jsOptions = AriUtils2::getParam($params, 'opt', array());
		AriColorboxHelper::includeSpecificAssets('a.' . $cssClass, $jsOptions);
		
		if ($modelParams['type'] == 'customtext')
		{
			$cId = uniqid('ct_', false);
			$modelParams['customtemplate'] = '<div id="' . $cId . '" style="cursor: pointer;">' . $modelParams['customtemplate'] . '</div>';
			$document =& JFactory::getDocument();
			$document->addScriptDeclaration(sprintf('(window["jQueryACB"] || jQuery)(document).ready(function($){ $("#%1$s").click(function(event) { $("#%1$s").closest(".ari_lightbox_container").find("a[class^=\'%2$s\']").eq(0).click(); }); });',
				$cId,
				$cssClass));			
		}

		parent::execute(
			$flickrData['photos'], 
			array(
				'simpleGallery' => ACOLORBOX_SIMPLEGALLERYTEMPLATE,
				'singleGallery' => ACOLORBOX_SINGLEIMAGEGALLERYTEMPLATE,
				'hiddenItems' => ACOLORBOX_HIDDENITEMSTEMPLATE),
			$modelParams,
			$params,
			$templatePath);
	}
	
	function getData($flickrData, $modelParams, $params, $groupCssClass)
	{
		$data = array('photos' => array(), 'photosets' => array());
		if (empty($flickrData))
			return $data;

		$showCaption = (bool)AriUtils2::getParam($modelParams, 'showCaption');
		$captionTemplate = $showCaption ? AriUtils2::getParam($modelParams, 'caption', '{$Title}') : '';
		$needParseTemplate = $showCaption && strpos($captionTemplate, '{$') !== false;
		if (!$needParseTemplate && $captionTemplate)
			$captionTemplate = str_replace('"', '&qout;', $captionTemplate);
			
		$group = $params['opt']['rel'];
		$photos = AriUtils2::getParam($flickrData, 'photos', $flickrData);
		foreach ($photos as $key => $value)
		{
			$dataItem = $value;

			$title = $needParseTemplate
				? str_replace('"', '&qout;', AriSimpleTemplate::parse($captionTemplate, $dataItem, true))
				: $captionTemplate;
			$aAttrs = array('href' => $dataItem['imgUrl'], 'title' => $title, 'class' => $groupCssClass, 'rel' => $group);
			$imgAttrs = array('src' => $dataItem['thumbUrl'], 'border' => '0', 'alt' => $title);

			$dataItem['colorboximage'] = sprintf('<a%1$s><img%2$s/></a>',
					AriHtmlHelper::getAttrStr($aAttrs),
					AriHtmlHelper::getAttrStr($imgAttrs));
					
			$data['photos'][$key] = $dataItem;
		}
		
		$data['photosets'] = AriUtils2::getParam($flickrData, 'photosets', array());

		return $data;
	}
}
?>