<?php
/*
 * ARI Colorbox
 *
 * @package		ARI Colorbox
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Module.Providers.ThumbnailProvider');
AriKernel::import('Module.Lightbox.Models.GalleryModel');
AriKernel::import('Colorbox.Models.Templates.SimpleGalleryTemplate');

class AriColorboxImglistModel extends AriGalleryModel
{
	var $_prefix = 'AriColorbox';
	
	function execute($modelParams, $params, $templatePath)
	{
		$thumbProvider = new AriThumbnailProvider('arithumb', null, 'mod_aricolorbox');
		$data = $thumbProvider->getStoredData($this->getThumbProviderParams($modelParams, $params));
		$cssClass = uniqid('acb', false);
		
		$this->modifyData($data, $params, $modelParams, $cssClass);
		
		$jsOptions = AriUtils2::getParam($params, 'opt', array());
		AriColorboxHelper::includeSpecificAssets('a.' . $cssClass, $jsOptions);
		
		if ($modelParams['type'] == 'customtext')
		{
			$cId = uniqid('ct_', false);
			$modelParams['customtemplate'] = '<div id="' . $cId . '" style="cursor: pointer;">' . $modelParams['customtemplate'] . '</div>';
			$document =& JFactory::getDocument();
			$document->addScriptDeclaration(sprintf('(window["jQueryACB"] || jQuery)(document).ready(function($){ $("#%1$s").click(function(event) { $("#%1$s").closest(".ari_lightbox_container").find("a[class^=\'%2$s\']").eq(0).click(); }); });',
				$cId,
				$cssClass));			
		}

		parent::execute(
			$data, 
			array(
				'simpleGallery' => ACOLORBOX_SIMPLEGALLERYTEMPLATE,
				'singleGallery' => ACOLORBOX_SINGLEIMAGEGALLERYTEMPLATE,
				'hiddenItems' => ACOLORBOX_HIDDENITEMSTEMPLATE),
			$modelParams,
			$params,
			$templatePath);
	}
	
	function getThumbProviderParams($modelParams, $params)
	{
		$thumbProviderParams = $modelParams;
		$thumbProviderParams['key'] = $params['_default']['key'];
		$thumbProviderParams['checkSum'] = $params['_default']['checkSum'];
		
		return $thumbProviderParams;
	}

	function modifyData(&$data, $params, $modelParams, $groupCssClass)
	{
		$rootUri = JURI::root(true) . '/';

		$showCaption = (bool)AriUtils2::getParam($modelParams, 'showCaption');
		$captionTemplate = $showCaption ? AriUtils2::getParam($modelParams, 'caption', '{$Title}') : '';
		$needParseTemplate = $showCaption && strpos($captionTemplate, '{$') !== false;
		if (!$needParseTemplate && $captionTemplate)
			$captionTemplate = str_replace('"', '&qout;', $captionTemplate);
		
		$group = $params['opt']['rel'];
		foreach ($data as $key => $value)
		{
			$dataItem =& $data[$key];
			
			$img = $dataItem['image'];
			$title = $needParseTemplate
				? str_replace('"', '&qout;', AriSimpleTemplate::parse($captionTemplate, $dataItem, true))
				: $captionTemplate;

			$aAttrs = array('href' => $rootUri . $img, 'class' => $groupCssClass, 'title' => $title, 'rel' => $group);
			$imgAttrs = array('src' => $rootUri . $dataItem['thumb'], 'border' => '0', 'alt' => $title);
			if ($dataItem['w']) $imgAttrs['width'] = $dataItem['w'];
			if ($dataItem['h']) $imgAttrs['height'] = $dataItem['h'];
			$dataItem['colorboximage'] = sprintf('<a%1$s><img%2$s/></a>',
				AriHtmlHelper::getAttrStr($aAttrs),
				AriHtmlHelper::getAttrStr($imgAttrs));
		}
	}
}
?>