<?php
/*
 * ARI Colorbox
 *
 * @package		ARI Colorbox
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Module.Providers.InlineThumbnailProvider');
AriKernel::import('Colorbox.Models.ColorboxModel');
AriKernel::import('Colorbox.Models.Templates.SimpleGalleryTemplate');

class AriColorboxInlineimgModel extends AriColorboxModel
{
	function execute($modelParams, $params, $templatePath)
	{
		$groupCssClass = uniqid('acb', false);
		$inlineThumb = new AriInlineThumbnailProvider('arithumb', null, 'mod_aricolorbox');
		$modelParams['groupCssClass'] = $groupCssClass;
		$modelParams['groupName'] = AriUtils2::getParam($params['opt'], 'rel');
		$modelParams['content'] = $inlineThumb->updateContent($modelParams['content'], $modelParams, array(&$this, 'inlineGalleryUpdateCallback'));
		
		$jsOptions = AriUtils2::getParam($params, 'opt', array());
		AriColorboxHelper::includeSpecificAssets('a.' . $groupCssClass, $jsOptions);
		
		parent::execute($modelParams, $params, $templatePath);
	}

	function inlineGalleryUpdateCallback($content, $images, $params)
	{
		$thumbCount = $params['thumbCount'];
		$single = $params['single'];
		$theme = !empty($params['theme']) && $params['theme'] != 'none' ? $params['theme'] : '';
		$themeClass = '';
		if ($theme)
		{
			$themeClass .= ' ari-theme-' . $theme;

			if ($theme != 'shadow')
				$themeClass .= ' ari-theme-shadow';			
		}
		
		$groupName = !$single ? $params['groupName'] : null;
		for ($i = 0; $i < count($images); $i++)
		{
			$image =& $images[$i];
			$image['image']['attributes']['rel'] = $groupName;
			if (empty($image['image']['attributes']['class']))
				$image['image']['attributes']['class'] = '';
			
			$image['image']['attributes']['class'] .= ' ' . $params['groupCssClass'];
			if ($thumbCount > 0 && $i >= $thumbCount)
				$image['image']['attributes']['style'] = 'display: none;';
		}

		$originalImages = array();
		$updatedImages = array();

		for ($i = 0; $i < count($images); $i++)
		{
			$image =& $images[$i];
			$originalImage = $image['image'];
			$thumbImage = $image['thumb'];

			$originalImages[] = $originalImage['original'];
			$updatedImages[] = ($thumbCount < 1 || $i < $thumbCount) 
				? sprintf(ACOLORBOX_INLINEIMAGETEMPLATE,
					$themeClass,
					sprintf('<a %1$s><img %2$s /></a>',
						AriHtmlHelper::getAttrStr($originalImage['attributes']),
						AriHtmlHelper::getAttrStr($thumbImage['attributes'])))
				: sprintf('<a %1$s></a>', AriHtmlHelper::getAttrStr($originalImage['attributes']));
		}

		return str_replace($originalImages, $updatedImages, $content);
	}	
}
?>