<?php
/*
 * ARI Colorbox
 *
 * @package		ARI Colorbox
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Colorbox.Models.ColorboxModel');
AriKernel::import('Module.ModuleHelper');

class AriColorboxModuleModel extends AriColorboxModel
{
	function execute($modelParams, $params, $templatePath)
	{
		$module =& AriModuleHelper::getModuleById(AriUtils2::getParam($modelParams, 'id'));
		if (empty($module))
			return ;
			
		$content = AriModuleHelper::renderModule($module);
		if (empty($content))
			return ;

		$cssClass = uniqid('acb', false);
		$inlineContentId = uniqid('acb', false);
		$jsOptions = AriUtils2::getParam($params, 'opt', array());
		$jsOptions['href'] = '#' . $inlineContentId;
		$jsOptions['inline'] = true;
		AriColorboxHelper::includeSpecificAssets('a.' . $cssClass, $jsOptions);

		$modelParams['groupCssClass'] = $cssClass;
		$modelParams['href'] = $inlineContentId;
		$modelParams['group'] = $params['opt']['rel'];
		$modelParams['content'] = $content;
		
		parent::execute($modelParams, $params, $templatePath);
	}
}
?>