<?php
/*
 * ARI Data Tables Joomla! module
 *
 * @package		ARI Data Tables Joomla! module.
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

require_once dirname(__FILE__) . '/../includes/kernel/class.AriKernel.php';

AriKernel::import('Utils.Utils');
AriKernel::import('Parameters.ParametersHelper');
AriKernel::import('DataTables.DataTables');
AriKernel::import('Module.ModuleHelper');

class ModuleAjaxDispatcherAridatatables
{
	function ajaxGetData()
	{
		$moduleId = JRequest::getInt('moduleId');
		if ($moduleId < 1)
			return null;

		$module = AriModuleHelper::getModuleById($moduleId);
		if (empty($module) || $module->module != 'mod_aridatatables')
			return null;

		$params = null;
		if (J1_5)
			$params = new JParameter($module->params);
		else
		{
			$params = new JRegistry;
			$params->loadString($module->params); 
		}

		$mParams = AriParametersHelper::flatParametersToArray($params);
		$tableType = AriDataTablesHelper::cleanValue($params->get('tableType', 'htmltable'));
		$widgetParams = AriUtils::getParam(AriUtils::getParam($mParams, 'widget'), $tableType);
		$widgetModel = AriDataTablesHelper::getWidgetModel($tableType, $mParams);
		$source = AriDataTablesHelper::cleanValue($params->get('source'));
		$model = AriDataTablesHelper::getDataModel($source, $mParams);

		if (empty($widgetModel) || !$widgetModel->isSupportAjax() || empty($model) || !$model->isSupportAjax())
			return null;
			
		$columnsSettings = AriDataTablesHelper::getColumnsSettings($mParams['_default']['columns']);
		$dtRawColumns = $model->getColumns(
			AriUtils::getParam($mParams['source'], $source, array()),
			$mParams,
			false
		);
		$dtColumns = $model->resolveColumnsAlias($dtRawColumns, AriUtils::getParam($mParams['source'], $source, array()));
		$hiddenColumns = AriDataTablesHelper::getHiddenColumns(
			array_flip($dtColumns), 
			$columnsSettings
		);

		$filters = $widgetModel->getAjaxFilters($dtColumns, $hiddenColumns);

		$data = $model
			? $model->getAjaxData(
				AriUtils::getParam($mParams['source'], $source, array()),
				$mParams,
				$filters,
				$dtColumns)
			: null;
		if (!is_null($data))
			$data = $widgetModel->normalizeAjaxData($data, $mParams, $dtRawColumns, $columnsSettings, $hiddenColumns);

		return $data;
	}
}