<?php
/*
 * ARI Data Tables
 *
 * @package		ARI Data Tables
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('DataTables.Models.DataTablesWidgetModel');
AriKernel::import('Document.DocumentHelper');

class AriDataTablesWidgetDatatableModel extends AriDataTablesWidgetModel
{
	var $_prefix = 'DataTablesWidget';
	
	function init($params, $mParams, $hiddenColumns)
	{
		$this->includeAssets($params, $mParams['_default']);
		$this->initClientInstance($mParams['table']['id'], $params, $hiddenColumns, $mParams);
	}
	
	function includeAssets($params, $cfg)
	{
		static $loaded;

		if ($loaded)
			return ;

		$useJQueryUI = (bool)$params['bJQueryUI'];
		AriDataTablesHelper::includeJQuery((bool)$cfg['includeJQuery'], (bool)$cfg['noConflict'], $cfg);
		if ($useJQueryUI)
			AriDataTablesHelper::includeJQueryUITheme($cfg['jQueryUITheme']);

		$baseUri = JURI::root(true) . '/modules/mod_aridatatables/includes/js/widgets/datatable/';
		$jsUri = $baseUri . 'js/';

		AriDocumentHelper::includeJsFile($jsUri . 'jquery.dataTables.min.js');
		AriDocumentHelper::includeJsFile($jsUri . 'jquery.dataTables.extra.js');
		AriDocumentHelper::includeJsFile($baseUri . 'plugins/tabletools/js/TableTools.min.js');
		//AriDocumentHelper::includeJsFile($jsUri . 'jquery.dataTablesExt.min.js');
		AriDocumentHelper::includeCssFile($baseUri . 'css/' . ($useJQueryUI ? 'datatable_jui.css' : 'datatable.css'));
		AriDocumentHelper::includeCssFile($baseUri . 'plugins/tabletools/css/' . ($useJQueryUI ? 'TableTools_JUI.css' : 'TableTools.css'));

		$loaded = true;
	}
	
	function initClientInstance($id, $params, $hiddenColumns, $mParams)
	{
		$loadMethod = AriUtils::getParam($params, 'loadMethod', 'ready');

		$jsOptions = $this->getJsOptions($id, $params, $hiddenColumns, $mParams);
	$dtCode = sprintf('if (typeof(AriDataTables) != "undefined") AriDataTables.hideLoadingPane("#%1$s_wrapper");var options = %2$s;options["fnDrawCallback"] = function(oSettings) { adt_DataTable_DrawCallback(oSettings) };options["fnServerParams"] =function(aoData){aoData.push({"name":"leagueid","value":"' . JRequest::getString('leagueid') . '"});aoData.push({"name":"memberteamid","value":"' . JRequest::getString('teamid') . '"});aoData.push({"name":"b_TIMER","value":"' . JRequest::getString('b_TIMER') . '"});aoData.push({"name":"year","value":"' . JRequest::getString('year') . '"});aoData.push({"name":"pos_c","value":"' . JRequest::getString('pos_c') . '"});aoData.push({"name":"pos_1b","value":"' . JRequest::getString('pos_1b') . '"});aoData.push({"name":"pos_2b","value":"' . JRequest::getString('pos_2b') . '"});aoData.push({"name":"pos_3b","value":"' . JRequest::getString('pos_3b') . '"});aoData.push({"name":"pos_ss","value":"' . JRequest::getString('pos_ss') . '"});aoData.push({"name":"pos_dh","value":"' . JRequest::getString('pos_dh') . '"});aoData.push({"name":"pos_rf","value":"' . JRequest::getString('pos_rf') . '"});aoData.push({"name":"pos_lf","value":"' . JRequest::getString('pos_lf') . '"});aoData.push({"name":"pos_cf","value":"' . JRequest::getString('pos_cf') . '"});aoData.push({"name":"pos_sp","value":"' . JRequest::getString('pos_sp') . '"});aoData.push({"name":"pos_rp","value":"' . JRequest::getString('pos_rp') . '"});aoData.push({"name":"b_userteamid","value":"' . JRequest::getString('b_userteamid') . '"});aoData.push({"name":"teamid","value":"' . JRequest::getString('teamid') . '"});aoData.push({"name":"f_TIMER","value":"' . JRequest::getString('f_TIMER') . '"});aoData.push({"name":"pos_qb","value":"' . JRequest::getString('pos_qb') . '"});aoData.push({"name":"pos_rb","value":"' . JRequest::getString('pos_rb') . '"});aoData.push({"name":"pos_wr","value":"' . JRequest::getString('pos_wr') . '"});aoData.push({"name":"pos_te","value":"' . JRequest::getString('pos_te') . '"});aoData.push({"name":"pos_dst","value":"' . JRequest::getString('pos_dst') . '"});aoData.push({"name":"pos_op","value":"' . JRequest::getString('pos_op') . '"});aoData.push({"name":"pos_k","value":"' . JRequest::getString('pos_k') . '"});aoData.push({"name":"f_userteamid","value":"' . JRequest::getString('f_userteamid') . '"});aoData.push({"name":"h_userteamid","value":"' . JRequest::getString('h_userteamid') . '"});aoData.push({"name":"h_TIMER","value":"' . JRequest::getString('h_TIMER') . '"});aoData.push({"name":"pos_rw","value":"' . JRequest::getString('pos_rw') . '"});aoData.push({"name":"pos_lw","value":"' . JRequest::getString('pos_lw') . '"});aoData.push({"name":"pos_d","value":"' . JRequest::getString('pos_d') . '"});aoData.push({"name":"pos_g","value":"' . JRequest::getString('pos_g') . '"});aoData.push({"name":"name","value":"' . JRequest::getString('name') . '"})};$("#%1$s").addClass("display dataTable").dataTable(options);',
			$id,
			!empty($jsOptions) ? AriJSONHelper::encode($jsOptions) : ''
			//!empty($jsOptions['bJQueryUI']) ? sprintf('/*$("#%1$s_wrapper").find(".dataTables_wrapper").addClass("ui-widget-content")*/', $id) : ''
		);
		
		$document =& JFactory::getDocument();
		if ($loadMethod == 'load')
			$document->addScriptDeclaration('(window["ADTQuery"] || jQuery)(window).load(function() { var $ = window["ADTQuery"] || jQuery;' . $dtCode . '});');
		else
			$document->addScriptDeclaration('(window["ADTQuery"] || jQuery)(document).ready(function($) { ' . $dtCode . '});');
	}
	
	function getJsOptions($id, $options, $hiddenColumns, $params)
	{
		$defOptions = array(
			'bJQueryUI' => false,
			'bStateSave' => false,
			'iCookieDuration' => 7200,
			'bPaginate' => true,
			'sPaginationType' => 'two_button',
			'bLengthChange' => true,
			'bFilter' => true,
			'bSort' => true,
			'bInfo' => true,
			'bProcessing' => false,
			'bAutoWidth' => true,
			'iDisplayLength' => 10,
			'sDom' => 'lfrtip',
			'asStripClasses' => 'odd,even',
			'sScrollY' => '',
			'oLanguage' => array(
				'sProcessing' => 'Processing...',
				'sLengthMenu' => 'Show _MENU_ entries',
				'sZeroRecords' => 'No matching records found',
				'sInfo' => 'Showing _START_ to _END_ of _TOTAL_ entries',
				'sInfoEmpty' => 'Showing 0 to 0 of 0 entries',
				'sInfoFiltered' => '(filtered from _MAX_ total entries)',
				'sInfoPostFix' => '',
				'sSearch' => 'Search:',
				'oPaginate' => array(
					'sFirst' => 'First',
					'sPrevious' => 'Previous',
					'sNext' => 'Next',
					'sLast' => 'Last'
				)
			),
			'oSearch' => array(
				'sSearch' => ''
			)
		);

		$showExportButtons = (bool)AriUtils::getParam($options, 'showExportButtons');
		$jsOptions = AriParametersHelper::getUniqueOverrideParameters($defOptions, $options);
		
		$customPagination = $this->parseCustomPaging($options);
		if ($customPagination)
		{
			if (!isset($jsOptions['oLanguage']))
				$jsOptions['oLanguage'] = array();
				
			if (!isset($jsOptions['oLanguage']['sLengthMenu']))
				$jsOptions['oLanguage']['sLengthMenu'] = $defOptions['oLanguage']['sLengthMenu'];
				
			$pagingMenu = '<select size="1">';
			foreach ($customPagination as $key => $val)
			{
				$pagingMenu .= sprintf('<option value="%1$d">%2$s</option>',
					$key,
					$val);
			}
			$pagingMenu .= '</select>';
				
			$jsOptions['oLanguage']['sLengthMenu'] = str_replace('_MENU_', $pagingMenu, $jsOptions['oLanguage']['sLengthMenu']);
		}
		
		if (isset($jsOptions['asStripClasses']))
			$jsOptions['asStripClasses'] = explode(',', $jsOptions['asStripClasses']);
			
		$iDisplayLength = AriUtils::getParam($jsOptions, 'iDisplayLength', $defOptions['iDisplayLength']);
		if ($customPagination)
		{
			reset($customPagination);
			if (!in_array($iDisplayLength, $customPagination))
				$iDisplayLength = key($customPagination);
		}
		else if (!in_array($iDisplayLength, array(10, 25, 50, 100)))
		{
			$iDisplayLength = $defOptions['iDisplayLength'];
		}
		
		$jsOptions['iDisplayLength'] = $iDisplayLength;
		
		$sorters = $this->getSorters($options, $hiddenColumns);
		if (!is_null($sorters)) 
			$jsOptions['aaSorting'] = $sorters;
		else
			$jsOptions['aaSorting'] = array();
		$colSettings = $this->getColumsSettings($options, $hiddenColumns);
		if (!is_null($colSettings)) $jsOptions['aoColumnDefs'] = $colSettings;
		
		if (!empty($jsOptions['sScrollY']))
		{
			$jsOptions['sScrollY'] = intval($jsOptions['sScrollY'], 10);
			if ($jsOptions['sScrollY'] < 1)
				unset($jsOptions['sScrollY']);  
		}

		if (!empty($options['scrollX']))
		{
			$scrollX = intval($options['scrollX'], 10);
			if ($scrollX > 1)
			{
				$document =& JFactory::getDocument();
				$document->addStyleDeclaration(
					sprintf('#%1$s_wrapper {width:%2$dpx;}',
						$id,
						$scrollX));
				
				$jsOptions['sScrollX'] = '100%';
			}  
		}
		
		if ($showExportButtons)
		{
			$bJQueryUI = isset($options['bJQueryUI']) ? (bool)$options['bJQueryUI'] : false;
			$sDom = !isset($jsOptions['sDom']) ? $defOptions['sDom'] : $jsOptions['sDom'];
			
			if ($bJQueryUI && !isset($jsOptions['sDom']))
				$jsOptions['sDom'] = 'T<"dtclear"><"H"lfr>t<"F"ip>';
			else
				$jsOptions['sDom'] = 'T<"dtclear">' . $sDom;
				
			$jsOptions['oTableTools'] = array(
				'sSwfPath' => JURI::root(true) . '/modules/mod_aridatatables/includes/js/widgets/datatable/plugins/tabletools/swf/copy_csv_xls_pdf.swf'
			);
			
			$exportButtons = $this->getExportButtonsJsOptions($options);
			if (is_array($exportButtons))
				$jsOptions['oTableTools']['aButtons'] = $exportButtons;
		}

		if (!empty($jsOptions['oSearch']['sSearch']))
		{
			$jsOptions['oSearch']['sSearch'] = AriSimpleTemplate::parse(
				$jsOptions['oSearch']['sSearch'], 
				array(
					'REQUEST' => $_REQUEST
				), 
				true);
		}
		
		$defParams = AriUtils::getParam($params, '_default');
		$ajaxSupport = (bool)AriUtils::getParam($defParams, 'ajaxSupport');
		if ($ajaxSupport)
		{
			$moduleId = AriUtils::getParam($defParams, 'moduleId');
			
			$jsOptions['bServerSide'] = true;
			$jsOptions['sAjaxSource'] = JURI::base(true) . '/index.php?__ajaxCall=1&__method=module:aridatatables:getData&moduleId=' . $moduleId;
		}

		return $jsOptions;
	}
	
	function getExportButtonsJsOptions($options)
	{
		$exportOptions = AriUtils::getParam($options, 'export', array());
		if (empty($exportOptions))
			return null;

		$exportJsOptions = array();	
		$availButtons = array('copy', 'csv', 'xls', 'pdf', 'print');
		foreach ($availButtons as $exportButton)
		{
			$btnOptions = AriUtils::getParam($exportOptions, $exportButton);
			if (empty($btnOptions))
				continue ;
				
			$visible = (bool)AriUtils::getParam($btnOptions, 'visible');
			if (!$visible)
				continue ;

			$label = AriUtils::getParam($btnOptions, 'label');
			if (empty($label))
				continue ;
				
			$exportJsOptions[] = array(
				'sExtends' => $exportButton,
				'sButtonText' => $label
			);
		}
		
		return $exportJsOptions;
	}
	
	function getSorters($options, $hiddenColumns)
	{
		$sorting = (bool)$options['bSort'];
		if (!$sorting)
			return null;
		
		$sorters = array(); 
		$colSorters = trim($options['sorters']);
		if ($colSorters)
		{
			$colSorters = AriJSONHelper::decode($colSorters);
			if (is_array($colSorters))
			{
				foreach ($colSorters as $colSorter)
				{
					$index = @intval($colSorter['index'], 10);
					if ($index > -1)
					{
						$index = AriDataTablesHelper::recalculateIndex($index, $hiddenColumns);
						$sortDir = $colSorter['sortdir'];
						if ($sortDir == 'asc' || $sortDir == 'desc')
							$sorters[] = array($index, $colSorter['sortdir']);
					}
				}
			}
		}
		
		return count($sorters) > 0 ? $sorters : null;
	}
	
	function getColumsSettings($options, $hiddenColumns)
	{
		$sorting = (bool)$options['bSort'];
		if (!$sorting)
			return null;
		
		$sorters = array();
		
		$null = null;
		$colSorters = trim($options['sorters']);
		if ($colSorters)
		{
			$colSorters = AriJSONHelper::decode($colSorters);
			if (is_array($colSorters))
			{
				foreach ($colSorters as $colSorter)
				{
					$index = @intval($colSorter['index'], 10);
					if ($index > -1)
					{
						$index = AriDataTablesHelper::recalculateIndex($index, $hiddenColumns);
						$sorter = $colSorter['sort'];
						if ($sorter && $sorter != 'none')
							$sorters[] = array('sType' => $sorter, 'aTargets' => array($index));
						else
							$sorters[] = array('bSortable' => false, 'aTargets' => array($index));
					}
				}
			}
		}
		
		return count($sorters) > 0 ? $sorters : null;
	}
	
	function parseCustomPaging($options)
	{
		$customPagination = array();
		$mode = AriUtils::getParam($options, 'pagingMode', 'simple');
		
		if ($mode == 'advanced')
		{
			$sCustomPagination = trim($options['advCustomPagination']);
			if ($sCustomPagination)
			{
				$sCustomPagination = AriJSONHelper::decode($sCustomPagination);
				if (is_array($sCustomPagination))
				{
					foreach ($sCustomPagination as $pageItem)
					{
						$pageSize = intval($pageItem['size'], 10);
						if ($pageSize < 1 && $pageSize != -1)
							continue ;
	
						$lbl = trim(AriUtils::getParam($pageItem, 'lbl', ''));
						if (empty($lbl))
							$lbl = $pageSize;
	
						$customPagination[$pageSize] = $lbl;
					}
				}
			}
		}
		else
		{
			$sCustomPagination = AriUtils::getParam($options, 'customPagination');
			if ($sCustomPagination)
			{
				$pagination = explode(',', $sCustomPagination);
				foreach ($pagination as $value)
				{
					$length = @intval($value, 10);
					if ($length < 1) continue;
					
					$customPagination[$length] = $length;
				}
			}
		}
		
		if (count($customPagination) > 0)
			ksort($customPagination, SORT_NUMERIC);
		
		return count($customPagination) > 0 ? $customPagination : null;
	}
	
	function isSupportAjax()
	{
		return true;
	}
	
	function getAjaxFilters($aColumns, $hiddenColumns)
	{
		$sWhere = '';
		$aSearch = '';
		$sSearch = JRequest::getString('sSearch');
		if ($sSearch != '')
		{
			$db =& JFactory::getDBO();
			$rawSearch = $sSearch;
			$sSearch = $db->quote($sSearch);
			$where = array();

			for ($i = 0; $i < count($aColumns); $i++)
			{
				if (!in_array($i, $hiddenColumns))
				{
					$where[] = sprintf('%1$s LIKE CONCAT("%%", %2$s, "%%")',
						$this->safeColumnName($aColumns[$i]),
						$sSearch);
						
					$aSearch[] = array(
						'col' => $aColumns[$i],
						'op' => 'contains',
						'search' => $rawSearch
					);
				}
			}
			
			if (count($where) > 0)
			{
				$sWhere = sprintf('(%s)',
					join(' OR ', $where));
			}
		}
		
		$visibleColumns = array();
		$cIdx = 0;
		foreach ($aColumns as $column)
		{
			if (!in_array($cIdx, $hiddenColumns))
				$visibleColumns[] = $column;
			
			++$cIdx;
		}
		
		$sOrder = '';
		$sOrderField = '';
		$sOrderDir = '';
		if (isset($_REQUEST['iSortCol_0']))
		{
			$order = array();
			$sortColCount = JRequest::getInt('iSortingCols');
			for ($i = 0; $i < $sortColCount; $i++)
			{
				$idx = JRequest::getInt('iSortCol_' . $i);
				$sortable = (JRequest::getString('bSortable_' . $idx) == 'true');
				if (!$sortable || !isset($visibleColumns[$idx]))
					continue ;

				$sortName = $visibleColumns[$idx];
				$sortOrder = strtolower(JRequest::getString('sSortDir_' . $i, ''));
				if ($sortOrder != 'asc' && $sortOrder != 'desc')
					$sortOrder = 'asc';

				if (empty($sOrderField))
				{
					$sOrderField = $sortName;
					$sOrderDir = $sortOrder;
				}
					
				$order[] = $this->safeColumnName($sortName) . ' ' . $sortOrder;
			}

			if (count($order) > 0)
				$sOrder = join(',', $order);
		}
		
		
		$filters = array(
			'start' => JRequest::getInt('iDisplayStart'),
			'limit' => JRequest::getInt('iDisplayLength'),
			'order' => $sOrder,
			'orderField' => $sOrderField,
			'orderDir' => $sOrderDir,
			'where' => $sWhere,
			'search' => $aSearch
		);
		
		return $filters;
	}
	
	function safeColumnName($name)
	{
		$pointPos = strpos($name, '.');
		if ($pointPos === false)
			return '`' . $name . '`';
			
		return substr($name, 0, $pointPos) . '.`' . substr($name, $pointPos + 1) . '`';
	}
	
	function normalizeAjaxData($data, $mParams, $columnsKeys, $columnsSettings, $hiddenColumns = array())
	{
		AriKernel::import('SimpleTemplate.SimpleTemplate');
		AriKernel::import('Web.HtmlHelper');
		
		$nData = array();
		if (!empty($data['data']))
		{
			$tableCfg = $mParams['table'];
			$advStyling = (bool)$tableCfg['advancedStyling'];
			$colClassPrefix = 'ari-tbl-col-';
			
			foreach ($data['data'] as $dataItem)
			{
				$nDataItem = array();
				$colIdx = 0;
				foreach ($dataItem as $value)
				{
					$colKey = $columnsKeys[$colIdx];
					$columnSetting = AriDataTablesHelper::getColumnSettings($columnsSettings, $colKey, $colIdx);
					$colAttrs = array('class' => '');

					if (in_array($colIdx, $hiddenColumns))
					{
						++$colIdx;
						continue ;
					}

					if ($advStyling)
						$colAttrs['class'] .= $colClassPrefix . $colIdx;

					if (!empty($columnSetting['class']))
						$colAttrs['class'] .= ' ' . $columnSetting['class'];

					if (!empty($columnSetting['format']))
					{
						$value = AriSimpleTemplate::parse(
							$columnSetting['format'], 
							array(
								'value' => $value,
								'columns' => $dataItem,
								'REQUEST' => $_REQUEST
							)
						);
					}
					else if (!empty($columnSetting['reclinks']))
					{
						$value = AriHtmlHelper::linkifyContent($value, $columnSetting['linktarget']);
					}
	
					if (empty($colAttrs['class'])) 
						unset($colAttrs['class']);
						
					$nDataItem[] = sprintf('<div%2$s>%1$s</div>',
						$value,
						AriHtmlHelper::getAttrStr($colAttrs)
					);
					
					++$colIdx;
				}
				
				$nData[] = $nDataItem;
			}
		}
		
		return array(
			'sEcho' => JRequest::getString('sEcho'),
			'iTotalRecords' => $data['totalRecords'],
			'iTotalDisplayRecords' => $data['totalFilteredRecords'],
			'aaData' => $nData
		);
	}
}