<?php
/*
 * ARI Data Tables
 *
 * @package		ARI Data Tables
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('DataTables.Models.DataTablesWidgetModel');
AriKernel::import('Document.DocumentHelper');
AriKernel::import('Utils.Utils');
AriKernel::import('Web.JSON.JSONHelper');

class AriDataTablesWidgetGchartModel extends AriDataTablesWidgetModel
{
	function init($params, $mParams)
	{
		$this->includeAssets($params, $mParams['_default']);
		$this->initClientInstance($mParams['table']['id'], $params);
	}
	
	function includeAssets($params, $cfg)
	{
		static $loaded;

		if ($loaded)
			return ;

		$document =& JFactory::getDocument();
		AriDataTablesHelper::includeJQuery((bool)$cfg['includeJQuery'], (bool)$cfg['noConflict'], $cfg);
		AriDataTablesHelper::includeGoogleAPI();

		$baseUri = JURI::root(true) . '/modules/mod_aridatatables/includes/js/widgets/gchart/';

		AriDocumentHelper::includeJsFile($baseUri . 'jquery.gchart.js');
		
		$document->addScriptDeclaration('google.load("visualization", "1", {packages: ["corechart"]});');

		$loaded = true;
	}
	
	function initClientInstance($id, $params)
	{
		$jsOptions = $this->getJsOptions($id, $params);
		$document =& JFactory::getDocument();
		$document->addScriptDeclaration(sprintf('(window["ADTQuery"] || jQuery)(document).ready(function($) { $("#%1$s_chart").gChart(%2$s); });',
			$id,
			!empty($jsOptions) ? AriJSONHelper::encode($jsOptions) : ''));
	}
	
	function getJsOptions($id, $options)
	{
		$defOptions = array(
			'chartType' => 'LineChart',
			'hideTable' => true
		);
		
		$defChartOptions = array(
			'PieChart' => array(
				'width' => 0,
				'height' => 0,
				'backgroundColor' => '#FFF',
				'colors' => '',
				'fontSize' => '',
				'legendFontSize' => '',
				'legendTextColor' => '',
				'reverseCategories' => false,
				'titleColor' => '#000',
				'titleFontSize' => '',
				'tooltipFontSize' => '',
		
				'legend' => 'right',
				'is3D' => false
			),

			'LineChart' => array(
				'width' => 0,
				'height' => 0,
				'backgroundColor' => '#FFF',
				'colors' => '',
				'fontSize' => '',
				'legendFontSize' => '',
				'legendTextColor' => '',
				'reverseCategories' => false,
				'titleColor' => '#000',
				'titleFontSize' => '',
				'tooltipFontSize' => '',
			
				'curveType' => 'none',
				'legend' => 'right',
				'lineWidth' => 2,
				'pointSize' => 7,
				'hAxis' => array(
					'textColor' => '#000',
					'title' => '',
					'titleColor' => '#000',
					'gridlines' => array(
						'color' => '#ccc',
						'count' => 5
					)
				),
				'vAxis' => array(
					'baseline' => -99999,
					'baselineColor' => '#000',
					'logScale' => false,
					'textColor' => '#333',
					'title' => '',
					'titleColor' => '#000',
					'maxValue' => -99999,
					'minValue' => -99999,
					'gridlines' => array(
						'color' => '#ccc',
						'count' => 5
					)
				)
			),
			
			'AreaChart' => array(
				'width' => 0,
				'height' => 0,
				'backgroundColor' => '#FFF',
				'colors' => '',
				'fontSize' => '',
				'legendFontSize' => '',
				'legendTextColor' => '',
				'reverseCategories' => false,
				'titleColor' => '#000',
				'titleFontSize' => '',
				'tooltipFontSize' => '',
			
				'isStacked' => false,
				'legend' => 'right',
				'lineWidth' => 2,
				'pointSize' => 7,
				'hAxis' => array(
					'textColor' => '#000',
					'title' => '',
					'titleColor' => '#000',
					'gridlines' => array(
						'color' => '#ccc',
						'count' => 5
					)
				),
				'vAxis' => array(
					'baseline' => -99999,
					'baselineColor' => '#000',
					'logScale' => false,
					'textColor' => '#333',
					'title' => '',
					'titleColor' => '#000',
					'maxValue' => -99999,
					'minValue' => -99999,
					'gridlines' => array(
						'color' => '#ccc',
						'count' => 5
					)
				)
			),
			
			'BarChart' => array(
				'width' => 0,
				'height' => 0,
				'backgroundColor' => '#FFF',
				'colors' => '',
				'fontSize' => '',
				'legendFontSize' => '',
				'legendTextColor' => '',
				'reverseCategories' => false,
				'titleColor' => '#000',
				'titleFontSize' => '',
				'tooltipFontSize' => '',
			
				'isStacked' => false,
				'legend' => 'right',
				'vAxis' => array(
					'textColor' => '#333',
					'title' => '',
					'titleColor' => '#000'
				),
				'hAxis' => array(
					'baseline' => -99999,
					'baselineColor' => '#000',
					'logScale' => false,
					'textColor' => '#000',
					'title' => '',
					'titleColor' => '#000',
					'maxValue' => -99999,
					'minValue' => -99999,
					'gridlines' => array(
						'color' => '#ccc',
						'count' => 5
					)
				)
			),
			
			'ColumnChart' => array(
				'width' => 0,
				'height' => 0,
				'backgroundColor' => '#FFF',
				'colors' => '',
				'fontSize' => '',
				'legendFontSize' => '',
				'legendTextColor' => '',
				'reverseCategories' => false,
				'titleColor' => '#000',
				'titleFontSize' => '',
				'tooltipFontSize' => '',
			
				'isStacked' => false,
				'legend' => 'right',
				'hAxis' => array(
					'textColor' => '#000',
					'title' => '',
					'titleColor' => '#000'
				),
				'vAxis' => array(
					'baseline' => -99999,
					'baselineColor' => '#000',
					'logScale' => false,
					'textColor' => '#333',
					'title' => '',
					'titleColor' => '#000',
					'maxValue' => -99999,
					'minValue' => -99999,
					'gridlines' => array(
						'color' => '#ccc',
						'count' => 5
					)
				)
			)
		);
		
		$autoOptions = array(
			'LineChart' => array(
				'vAxis' => array(
					'baseline' => '',
					'maxValue' => '',
					'minValue' => ''
				)
			),
			'AreaChart' => array(
				'vAxis' => array(
					'baseline' => '',
					'maxValue' => '',
					'minValue' => ''
				)
			),
			'BarChart' => array(
				'hAxis' => array(
					'baseline' => '',
					'maxValue' => '',
					'minValue' => ''
				)
			),
			'ColumnChart' => array(
				'vAxis' => array(
					'baseline' => '',
					'maxValue' => '',
					'minValue' => ''
				)
			)
		);

		$jsOptions = AriParametersHelper::getUniqueOverrideParameters($defOptions, $options, true);
		
		$jsOptions['dataTable'] = '#' . $id;
		$chartSettings = array_merge(
			AriUtils::getParam($options, $options['chartType'], array()),
			AriUtils::getParam($options, 'chartSettings', array()));
		$defChartSettings = AriUtils::getParam($defChartOptions, $options['chartType']);
		
		if ($defChartSettings && $chartSettings)
		{
			if (isset($autoOptions[$options['chartType']]))
				$chartSettings = AriParametersHelper::removeSameParameters($chartSettings, $autoOptions[$options['chartType']]);
			
			$jsOptions['chartSettings'] = AriParametersHelper::getUniqueOverrideParameters($defChartSettings, $chartSettings, true);
		}
		
		if (!empty($jsOptions['chartSettings']['colors']) && !is_array($jsOptions['chartSettings']['colors']))
		{
			$colors = array();
			$sColors = explode("\n", $jsOptions['chartSettings']['colors']);
			foreach ($sColors as $color)
			{
				$color = trim($color);
				if ($color) $colors[] = $color;
			}
			
			$jsOptions['chartSettings']['colors'] = $colors;
		}
		
		$jsOptions['formatters'] = $this->getFormatters($options);
		$jsOptions['formatterSettings'] = $this->getFormatterSettings($options);

		return $jsOptions;
	}
	
	function getFormatterSettings($options)
	{
		$defOptions = array(
			'labelLength' => 0,
			'labelMore' => ''
		);

		if (empty($options['formatterSettings']))
			return null;
			
		return AriParametersHelper::getUniqueOverrideParameters($defOptions, $options['formatterSettings'], true);
	}
	
	function getFormatters($options)
	{
		$defChartFormatters = array(
			'DateFormat' => array(
				'formatType' => '',
				'pattern' => '',
				'timeZone' => 0
			),
			'NumberFormat' => array(
				'decimalSymbol' => '.',
				'fractionDigits' => 2,
				'groupingSymbol' => ',',
				'negativeColor' => '',
				'negativeParens' => true,
				'prefix' => '',
				'suffix' => ''
			)
		);
		
		if (empty($options['formatters']))
			return null;

		$formatters = AriJSONHelper::decode(addcslashes($options['formatters'], "\r\n"));
		if (empty($formatters))
			return null;

		$retFormatters = array();
		foreach ($formatters as $formatter)
		{
			$idx = @trim($formatter['index']);
			if (strlen($idx) == 0)
				continue ;
				
			$idx = intval($idx, 10);
			if ($idx < 0)
				continue ;

			$type = $formatter['type'];
			if (!isset($defChartFormatters[$type]))
				continue ;

			$retFormatters[$idx] = array('type' => $type);

			if (empty($formatter['params']))
				continue ;

			$defSettings = $defChartFormatters[$type];
			$params = explode("\n", $formatter['params']);

			array_walk($params, 'trim');
			$colSettings = array();
			foreach ($params as $param)
			{
				@list($key, $value) = explode('=', $param, 2);
				if (empty($key))
					continue ;
					
				$colSettings[$key] = $value;
			}

			$colSettings = AriParametersHelper::getUniqueOverrideParameters($defSettings, $colSettings, true);
			if (count($colSettings) > 0)
				$retFormatters[$idx]['settings'] = $colSettings;
		}

		return count($retFormatters) > 0 ? $retFormatters : null;
	}

	function fixColumnsSettings($columnsSettings)
	{
		if (is_null($columnsSettings))
			$columnsSettings = array();
			
		if (!isset($columnsSettings[0]))
			$columnsSettings[0] = array();
			
		$columnsSettings[0]['celltag'] = 'th';
		$columnsSettings[0]['headtag'] = 'td';
		
		return $columnsSettings;
	}
}
?>