<?php
/*
 * ARI Data Tables
 *
 * @package		ARI Data Tables
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('DataTables.Models.DataTablesWidgetModel');
AriKernel::import('Document.DocumentHelper');

class AriDataTablesWidgetMootableModel extends AriDataTablesWidgetModel
{
	var $_prefix = 'DataTablesWidget';
	
	function init($params, $mParams)
	{
		$this->includeAssets($params, $mParams['_default']);
		$this->initClientInstance($mParams['table']['id'], $params);
	}
	
	function includeAssets($params, $cfg)
	{
		static $loaded;

		if ($loaded)
			return ;

		$baseUri = JURI::root(true) . '/modules/mod_aridatatables/includes/js/widgets/mootable/';

		if (!empty($cfg['includeMooTools']))
			AriDataTablesHelper::includeMooTools();
		
		AriDocumentHelper::includeJsFile($baseUri . 'mootable.js');
		AriDocumentHelper::includeCssFile($baseUri . 'mootable.css');

		$loaded = true;
	}
	
	function initClientInstance($id, $params)
	{
		$jsOptions = $this->getJsOptions($params);
		$document =& JFactory::getDocument();
		$document->addScriptDeclaration(sprintf('window.addEvent("domready", function() { new MooTable("%1$s", %2$s);if (typeof(AriDataTables) != "undefined") AriDataTables.hideLoadingPane("#%1$s_wrapper"); });',
			$id,
			!empty($jsOptions) ? AriJSONHelper::encode($jsOptions) : '{}'));
	}
	
	function getJsOptions($options)
	{
		$defOptions = array(
			'height' => '90%',
			'resizable' => false,
			'sortable' => false,
			'useloading' => true,
			'position' => 'inside',
			'section' => 20,
			'delay' => 10,
			'fade' => false,
			'footer' => false,
			'minColWidth' => 50,
			'decimal' => '.',
			'protected' => '',
			'filter' => false
		);

		$jsOptions = AriParametersHelper::getUniqueOverrideParameters($defOptions, $options);

		return $jsOptions;
	}
}
?>