<?php
/*
 * ARI Framework Lite
 *
 * @package		ARI Framework Lite
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2009 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Web.JSON.JSON');

define('ARI_JSON_DECODE', function_exists('json_decode'));
define('ARI_JSON_ENCODE', function_exists('json_encode'));

class AriJSONHelper
{
	function encode($data)
	{
	        if (ARI_JSON_ENCODE)
	            return json_encode($data);
	
		$jsonHandler =& AriJSONHelper::_getJSONHandler();
		
		return $jsonHandler->encode($data);
	}
	
	function decode($str)
	{
		if (empty($str)) return null;
		
		if (ARI_JSON_DECODE)
	            return json_decode($str, true);

		$jsonHandler =& AriJSONHelper::_getJSONHandler();
		
		return $jsonHandler->decode($str);
	}
	
	function &_getJSONHandler()
	{
		static $jsonHandler = null;
		
		if (is_null($jsonHandler))
		{
			$jsonHandler = new Services_JSON(SERVICES_JSON_LOOSE_TYPE);
		}

		return $jsonHandler;
	}
}
?>