<?php
/*
 * ARI Data Tables Joomla! module
 *
 * @package		ARI Data Tables Joomla! module.
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

require_once dirname(__FILE__) . '/includes/kernel/class.AriKernel.php';

AriKernel::import('Utils.Utils');
AriKernel::import('Joomla.JoomlaUtils');
AriKernel::import('Document.DocumentHelper');
AriKernel::import('Template.Template');
AriKernel::import('SimpleTemplate.SimpleTemplate');
AriKernel::import('Web.HtmlHelper');
AriKernel::import('Web.JSON.JSONHelper');
AriKernel::import('Parameters.ParametersHelper');
AriKernel::import('DataTables.DataTables');

$params->set('moduleId', $module->id);
$params->set('checkSum', md5($module->params));
$isAjax = (bool)$params->get('ajaxSupport');
$mParams = AriParametersHelper::flatParametersToArray($params);

$constantId = (bool)$params->get('constantId', false);
$mParams['table']['id'] = $constantId ? 'at_' . $module->id : uniqid('at_', false);
$columnsSettings = AriDataTablesHelper::getColumnsSettings($mParams['_default']['columns']);

$source = AriDataTablesHelper::cleanValue($params->get('source'));
$model = AriDataTablesHelper::getDataModel($source, $mParams);
$isHtmlTableSource = $model ? $model->isHtmlTableSource() : false;

$tableType = AriDataTablesHelper::cleanValue($params->get('tableType', 'htmltable'));

$widgetParams = AriUtils::getParam(AriUtils::getParam($mParams, 'widget'), $tableType);
$widgetModel = AriDataTablesHelper::getWidgetModel($tableType, $mParams);

if ($isAjax)
{
	$mainframe =& JFactory::getApplication();
	if (empty($widgetModel) || !$widgetModel->isSupportAjax() || empty($model) || !$model->isSupportAjax())
	{
		$mainframe->enqueueMessage('"ARI Data Tables": server side pagination is not used because currently it is supported only by "ARI Data Table" widget for "SQL" source type.', 'error');
		
		$isAjax = false;
	}
	
	if (!class_exists('plgSystemAriajaxdispatcher'))
	{
		$mainframe->enqueueMessage('"ARI Data Tables": server side pagination is not used because "ARI Ajax Dispatcher" plugin is not installed or disabled.', 'error');
		
		$isAjax = false;
	}
	
	if (!$isAjax)
		$mParams['_default']['ajaxSupport'] = false;
	else 
		$model->initAjax(
			AriUtils::getParam($mParams['source'], $source, array()),
			$mParams
		);
}

$dtColumns = null;
if ($isAjax)
	$dtColumns = $model->getColumns(
		AriUtils::getParam($mParams['source'], $source, array()),
		$mParams
	);

$data = $model && !$isAjax
	? $model->getData(
			AriUtils::getParam($mParams['source'], $source, array()),
			$mParams)
	: null;

$hiddenColumns = AriDataTablesHelper::getHiddenColumns(
	$isAjax
		? array_flip($dtColumns)
		: (is_array($data) && count($data) > 0 ? current($data) : null), 
	$columnsSettings);

if ($widgetModel)
	$widgetModel->init($widgetParams, $mParams, $hiddenColumns);
AriDataTablesHelper::includeSpecificStyles($mParams, $columnsSettings);

$loadingPane = (bool)AriUtils::getParam($mParams['_default'], 'loadingPane');
if ($loadingPane)
{
	AriDataTablesHelper::includeJQuery((bool)$params->get('includeJQuery'), (bool)$params->get('noConflict'), $mParams['_default']);	
	AriDataTablesHelper::includeAssets();
}

ob_start();
require JModuleHelper::getLayoutPath('mod_aridatatables', $tableType);
$moduleContent = ob_get_contents();
ob_end_clean();

echo $model->postProcessing($moduleContent, AriUtils::getParam($mParams['source'], $source));