<?php
defined('_JEXEC') or die('Restricted access');

class mod_aridatatablesInstallerScript
{
	function preflight($type, $parent)
	{
		$this->installAriExtensionsPlugin();

		$type = strtolower($type);
		if ($type == 'install' || $type == 'update')
			$this->updateManifest($parent);
	}
	
	function postflight($type, $parent)
	{
		$type = strtolower($type);
		if ($type == 'install' || $type == 'update')
			$this->deleteHelpManifest($parent);
	}
	
	private function updateManifest($parent)
	{
		jimport('joomla.filesystem.file');
		
		$installer = $parent->getParent();
		$manifestFile = basename($installer->getPath('manifest'));
		$cleanManifestFile = preg_replace('/^\_+/i', '', $manifestFile);

		$dir = dirname(__FILE__) . '/install/';

		JFile::delete($dir . $cleanManifestFile);
		JFile::copy($dir . '../' . $cleanManifestFile, $dir . $cleanManifestFile);
	}
	
	private function deleteHelpManifest($parent)
	{
		jimport('joomla.filesystem.file');
		
		$installer = $parent->getParent();
		$manifestFile = basename($installer->getPath('manifest'));

		JFile::delete(JPATH_ROOT . '/modules/mod_aridatatables/' . $manifestFile);
	}
	
	private function installAriExtensionsPlugin()
	{
		$plgPath = dirname(__FILE__) . '/plg_system_ariextensions.zip';
		$installResult = JInstallerHelper::unpack($plgPath);
		if (empty($installResult)) 
		{
			$app = JFactory::getApplication();
			$app->enqueueMessage(
				'ARI Data Tables: the installer can\'t install "System - ARI Extensions" plugin. Install the plugin manually.',
				'error'
			);

			return false;
		}
		
		$installer = new JInstaller();
		$installer->setOverwrite(true);
		if (!$installer->install($installResult['extractdir'])) 
		{
			$app = JFactory::getApplication();
			$app->enqueueMessage(
				'ARI Data Tables: the installer can\'t install "System - ARI Extensions" plugin. Install the plugin manually.',
				'error'
			);

			return false;
		}
		
		$db = JFactory::getDBO();
		$db->setQuery('UPDATE #__extensions SET enabled = 1 WHERE `type` = "plugin" AND `element` = "ariextensions"');
		$db->query();
		if ($db->getErrorNum())
		{
			$app = JFactory::getApplication();
			$app->enqueueMessage(
				'ARI Data Tables: the installer can\'t enable "System - ARI Extensions" plugin. Enable the plugin manually.',
				'warning'
			);
		}

		return true;
	}
}