<?php
/*
 * ARI Data Tables Joomla! module
 *
 * @package		ARI Data Tables Joomla! module.
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2009 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

$tableCfg = $mParams['table'];

$loadingPane = (bool)AriUtils::getParam($mParams['_default'], 'loadingPane');
$loadingText = AriUtils::getParam($mParams['_default'], 'loadingText');
$caption = AriUtils::getParam($tableCfg, 'caption');
$advStyling = (bool)$tableCfg['advancedStyling'];
$colClassPrefix = 'ari-tbl-col-';
$rowClassPrefix = 'ari-tbl-row-';
$tableAttrs = array(
	'id' => $tableCfg['id'],
	'cellpadding' => intval($tableCfg['padding'], 10),
	'cellspacing' => intval($tableCfg['spacing'], 10),
	'border' => intval($tableCfg['border'], 10),
);

if ($tableCfg['cssClass'])
	$tableAttrs['class'] = $tableCfg['cssClass'];
	
$rowClasses = explode(';', $tableCfg['rowClasses']);
$rowClassesCnt = count($rowClasses);
?>

<?php
	if ($data || $dtColumns):
		$columnsKeys = null;
		if ($dtColumns)
		{
			$columnsKeys = $dtColumns;
		}
		else 
		{
			$columnsKeys = array_keys($data);
			$columnsKeys = $data[$columnsKeys[0]];
			$columnsKeys = array_keys($columnsKeys);
		}
		$columnCount = count($columnsKeys);
?>
<div id="<?php echo $tableCfg['id']; ?>_wrapper"<?php echo $loadingPane ? ' class="adt-loading"' : ''; ?>>
<?php
	if ($loadingPane && $loadingText): 
?>
	<div class="adt-loading-message"><?php echo $loadingText; ?></div>
<?php
	endif; 
?>
<table<?php echo AriHtmlHelper::getAttrStr($tableAttrs); ?>>
<?php
	if ($caption):
?>
	<caption><?php echo $caption; ?></caption>
<?php
	endif;
		if ((bool)$tableCfg['showHeader']): 
?>
	<thead>
		<?php
			require JModuleHelper::getLayoutPath('mod_aridatatables', 'table' . DS . 'header');
		?>
	</thead>
<?php
		endif;
?>
	<tbody>
<?php
	if (!empty($data)):
	$rowIdx = 0;
	foreach ($data as $dataItem):
		$rowAttrs = array('class' => '');
		if ($rowClassesCnt)
			$rowAttrs['class'] = $rowClasses[$rowIdx % $rowClassesCnt];
			
		if ($advStyling)
			$rowAttrs['class'] .= ' ' . $rowClassPrefix . $rowIdx;
			
		if (empty($rowAttrs['class'])) 
			unset($rowAttrs['class']);
?>
	<tr<?php echo AriHtmlHelper::getAttrStr($rowAttrs); ?>>
		<?php
			$colIdx = 0;
			if (count($dataItem) < $columnCount)
			{
				for ($emptyColIdx = count($dataItem); $emptyColIdx < $columnCount; $emptyColIdx++)
				{
					$dataItem[] = '';
				}
			}

			foreach ($dataItem as $value):
				$cellTag = 'td';
				$colKey = $columnsKeys[$colIdx];
				$columnSetting = AriDataTablesHelper::getColumnSettings($columnsSettings, $colKey, $colIdx);
				$colAttrs = array('class' => '');

				if (in_array($colIdx, $hiddenColumns))
				{
					++$colIdx;
					continue ;
				}
				
				if ($advStyling)
					$colAttrs['class'] .= $colClassPrefix . $colIdx;
					
				if (!empty($columnSetting['celltag']))
					$cellTag = $columnSetting['celltag'];
					
				if (!empty($columnSetting['class']))
					$colAttrs['class'] .= ' ' . $columnSetting['class'];

				if (!empty($columnSetting['format']))
				{
					$value = AriSimpleTemplate::parse(
						$columnSetting['format'], 
						array(
							'value' => $value,
							'columns' => $dataItem,
							'REQUEST' => $_REQUEST
						),
						true
					);
				}
				else if (!empty($columnSetting['reclinks']))
				{
					$value = AriHtmlHelper::linkifyContent($value, $columnSetting['linktarget']);
				}

				if (empty($colAttrs['class'])) 
					unset($colAttrs['class']);
		?>
		<<?php echo $cellTag; ?><?php echo AriHtmlHelper::getAttrStr($colAttrs); ?>><?php echo $value; ?></<?php echo $cellTag; ?>>
		<?php
				++$colIdx;
			endforeach;			
		?>
	</tr>
<?php
		++$rowIdx;
	endforeach;
	endif;
?>
	</tbody>
<?php
		if ((bool)$tableCfg['showFooter']): 
?>
	<tfoot>
		<?php
			require JModuleHelper::getLayoutPath('mod_aridatatables', 'table' . DS . 'header');
		?>
	</tfoot>
<?php
		endif;
?>
</table>
</div>
<?php
	else:
?>
	No data available.
<?php
	endif;
?>