<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');
AriKernel::import('File.FileManager');

class AriCssTemplatesLoaderPlugin extends AriSmartContentPluginBase
{
	function __construct()
	{
		parent::__construct('aricsstemplatesloader');
	}
	
	function processContent($published, $content, $params, $page)
	{
		static $loaded = false;
		
		if ($loaded) return ;
		
		$loaded = true;
		if (!$published) return true;
		
		$path = $this->getPath();
		$cssFileList = AriFileManager::getFileList($path, false, array('css'));

		if (empty($cssFileList)) return true;

		foreach ($cssFileList as $cssFile)
		{
			AriDocumentHelper::includeCssFile(AriUtils::absPath2Url($path . $cssFile));
		}
		
		return true;
	}

	function getPath()
	{
		return AriSmartContentComponent::getClientCacheDir() . AriConstantsManager::getVar('FileGroup.CSS', AriSmartContentComponent::getCodeName()) . '/';
	}
}
?>