<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');
AriKernel::import('Components.AriSmartContent.Plugins.HtmlTablePlugin');
AriKernel::import('CSV.CSVParser');

class AriCSVTablePlugin extends AriSmartContentPluginBase
{
	var $_defaultConfig = array(
		'file' => '',
		'sortBy' => '',
		'sortDir' => '',
		'sortType' => '',
		'heading' => true,
		'autoDetect' => false,
		'delimiter' => ',',
		'enclosure' => '"',
		'offset' => 0,
		'limit' => 0);
	
	function __construct()
	{
		parent::__construct('aricsvtable');
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$config = $this->getConfig($attrs);
		$results = $this->getResults($config);

		if (empty($results) || count($results) == 0) return '';

		$htmlTablePlugin = new AriSmartHtmlTablePlugin(
			$this->_tag, 
			'aricsvtablecolumns', 
			'aricsvtablecolumn', 
			'aricsvtablecolumnspan',
			$this->getParametersKey());
		$table = $htmlTablePlugin->replaceCallback($results, $attrs, $content);

		return $table;
	}
	
	function getResults($config)
	{
		$csvParser = new AriCSVParser();
		$file = trim($config['file']);
		if (empty($file)) return null;
		
		$file = AriUtils::resolvePath($file);
		if (!@file_exists($file) || !@is_readable($file)) return null;
		
		if ($config['sortBy']) 
		{
			$csvParser->sort_by = $config['sortBy'];
			if ($config['sortDir'] && strtoupper($config['sortDir']) == 'DESC') $csvParser->sort_reverse = true;
			if ($config['sortType'] && defined($config['sortType'])) $csvParser->sort_type = constant($config['sortType']);
		}
		
		if (isset($config['heading'])) $csvParser->heading = $config['heading'];
		if ($config['offset'] > 0) $csvParser->offset = $config['offset'];
		if ($config['limit'] > 0) $csvParser->limit = $config['limit'];
		if (!$config['autoDetect'])
		{
			if ($config['delimiter']) $csvParser->delimiter = $config['delimiter'];
			if ($config['enclosure']) $csvParser->enclosure = $config['enclosure'];
		}

		if ($config['autoDetect'])
		{
			$csvParser->auto($file);
		}
		else
		{
			$csvParser->parse($file);
		}
		
		$results = $csvParser->data;

		return $results;
	}
	
	function getConfig($attrs)
	{
		$config = array();
		
		foreach ($this->_defaultConfig as $key => $defValue)
		{
			$config[$key] = $this->getValueByDefSample($key, $attrs, $defValue);
		}
		
		return $config;
	}	
}
?>