<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.PluginBase');

class AriJFlexGridPlugin extends AriSmartContentPluginBase
{
	var $_idList = array();
	var $_defaultConfig = array(
		'height' => '200',
		'width' => 'auto',
		'striped' => true,
		'novstripe' => false,
		'minwidth' => 30,
		'minheight' => 80,
		'resizable' => true,
		'nowrap' => true,
		'title' => '',
/*
		'usepager' => false,
		'page' => 1,
		'total' => 2,
		'useRp' => true,
		'rp' => 15,
		'rpOptions' => '10,15,20,25,40',
		'pagestat' => 'Displaying {from} to {to} of {total} items',
		'procmsg' => 'Processing, please wait ...',
		'nomsg' => 'No items',
*/
		'minColToggle' => 1,
		'showToggleBtn' => true,
		'blockOpacity' => 0.5
		);

	function __construct()
	{
		parent::__construct('arijflexgrid');
	}
	
	function processContent($published, &$row, &$params, $page = 0)
	{
		parent::processContent($published, $row, $params, $page);
		
		$this->runtimeJsDeclaration();
	}
	
	function replaceCallback($attrs, $content = '')
	{
		$config = $this->getConfig($attrs, $this->_defaultConfig);
		
		$id = uniqid('jfg_', false);
		$this->_idList[$id] = $config;

		/*
		return sprintf('<div id="%2$s">%1$s</div><script type="text/javascript">jQuery("#%2$s > table").flexigrid(%3$s);</script>',
			$content,
			$id,
			!empty($config) ? AriJSONHelper::encode($config) : '');*/
		return sprintf('<div id="%2$s">%1$s</div>',
			$content,
			$id);
	}

	function getConfig($attrs, $defConfig)
	{
		$config = array();
		
		foreach ($defConfig as $key => $defValue)
		{
			$val = $this->getValueByDefSample($key, $attrs, $defValue);
			if ($val != $defValue)
			{
				if ($key == 'rpOptions')
				{
					$val = $this->getRpOptions($val);
				}

				$config[$key] = $val;
			}
		}
		
		return $config;
	}
	
	function getRpOptions($rpOptions)
	{
		$rpOptions = explode(',', $rpOptions);
		$retRpOptions = array();
		if ($rpOptions)
		{
			foreach ($rpOptions as $opt)
			{
				$opt = @intval($opt, 10);
				if ($opt > 0)
				{
					$retRpOptions[] = $opt;
				}
			}
			
			sort($retRpOptions);
			$retRpOptions = array_unique($retRpOptions);
		}
		
		if (empty($retRpOptions)) $retRpOptions = explode(',', $this->_defaultConfig['rpOptions']);
		
		return $retRpOptions;
	}
	
	function jsDeclaration()
	{
		$jqueryLoader = new AriJQueryLoaderPlugin();
		$jqueryLoader->load();

		$rootPath = $this->getRootPath();
		
		AriDocumentHelper::includeCssFile(AriUtils::absPath2Url($rootPath . 'flexigrid.css'));
		AriDocumentHelper::includeJsFile(AriUtils::absPath2Url($rootPath . 'flexigrid.pack.js'));
	}
	
	function runtimeJsDeclaration()
	{
		$idList = $this->_idList;
		if (empty($idList)) return ;
		
		$script = '<script type="text/javascript">';
		foreach ($idList as $id => $config)
		{
			$script .= sprintf('jQuery(document).ready(function($) { $("#%1$s > table").flexigrid(%2$s); });', 
				$id,
				!empty($config) ? AriJSONHelper::encode($config) : '');
		}
		$script .= '</script>';
		
		AriDocumentHelper::includeCustomHeadTag($script);
	}
	
	function getRootPath()
	{
		return dirname(__FILE__) . '/js/';
	}
}
?>