<?php
defined('ARI_FRAMEWORK_LOADED') or die('Direct Access to this location is not allowed.');

AriKernel::import('Components.AriSmartContent.Plugins.LoaderPluginBase');

class AriJQueryLoaderPlugin extends AriLoaderPluginBase
{
	var $_systemName = 'arijqloader';
	
	function load($module = 'jquery', $version = null)
	{
		static $noConflictLoader = false;
		
		$params = null;
		if ($module == 'jquery')
		{
			$params = $this->getParameters();
			$needLoad = AriUtils::parseValueBySample($params->get('needLoad', true), true);
			if (!$needLoad) return true;
		}
		
		if (is_null($version))
		{
			if (is_null($params)) $params = $this->getParameters();
			$jQueryVersion = $params->get('jQueryVersion', null);
			if (!empty($jQueryVersion)) $version = $jQueryVersion;
		}
		
		$res = parent::load($module, $version);
		if ($res)
		{
			if ($module == 'jquery' && !$noConflictLoader)
			{				
				$noConflict = AriUtils::parseValueBySample($params->get('noConflict', false), false);
				if ($noConflict)
				{
					AriDocumentHelper::includeJsFile(AriUtils::absPath2Url($this->getRootPath() . 'noconflict.js'));
					//AriDocumentHelper::includeCustomHeadTag('<script type="text/javascript">jQuery.noConflict();</script>');
				}
				
				$noConflictLoader = true;
			}
		}
		
		return $res;
	}

	function getRootPath()
	{
		return dirname(__FILE__) . '/js/';
	}

	function getFileModuleName($module)
	{
		return $module . '.min.js';
	}
}
?>