<?php
/*
 *
 * @package		ARI AJAX Dispatcher
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

require_once dirname(__FILE__) . '/ariajaxdispatcher/kernel/class.AriKernel.php';

jimport('joomla.plugin.plugin');
jimport('joomla.filter.filterinput');

AriKernel::import('Web.JSON.JSONHelper');

define('ARIAJAX_MARKER', '__ajaxCall');
define('ARIAJAX_METHOD', '__method');
define('ARIAJAX_METHOD_SEPARATOR', ':');

class plgSystemAriajaxdispatcher extends JPlugin
{ 
	function plgSystemAriajaxdispatcher(&$subject, $config)
	{
		parent::__construct($subject, $config); 
	}
	
	function onAfterRoute()
	{
		if (!$this->isAjaxCall())
			return ;

		$this->doAction();
	}
	
	function isAjaxCall()
	{
		return JRequest::getBool(ARIAJAX_MARKER);
	}
	
	function doAction()
	{
		$action = JRequest::getString(ARIAJAX_METHOD);
		if (empty($action))
		{
			exit();
		}

		$inputFilter = JFilterInput::getInstance();

		$action = explode(ARIAJAX_METHOD_SEPARATOR, $action);
		$type = ucfirst(strtolower($inputFilter->clean($action[0], 'WORD')));

		$actionHandler = 'doAction_' . $type;
		if (!method_exists($this, $actionHandler))
		{
			exit();
		}

		array_shift($action);
		$result = $this->$actionHandler($action);
		
		while (@ob_end_clean());

		header('Content-type: text/html; charset=utf-8');

		echo AriJSONHelper::encode($result);
		exit();		
	}
	
	function doAction_Module($params)
	{
		if (!is_array($params) || count($params) < 2)
			return null;

		$module = $params[0];
		$method = $params[1];
		
		if (!preg_match('/^[A-z][_\-0-9A-z]+$/i', $module))
			return null;

		$moduleFolder = 'mod_' . $module;
		$actionsFile = JPATH_ROOT . DS . 'modules' . DS . $moduleFolder . DS . 'ajax' . DS . 'actions.php';
		if (!@file_exists($actionsFile))
			return null;

		require_once $actionsFile;
		
		$className = 'ModuleAjaxDispatcher' . $module;

		$method = 'ajax' . ucfirst($method);
		if (!class_exists($className) && !method_exists($className, $method))
			return null;

		$dispatcher = new $className();
		$result = $dispatcher->$method();
		
		return $result;
	}
}