<?php
/*
 * ARI Colorbox Joomla! 1.5 system plugin
 *
 * @package		ARI Colorbox
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2009 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemAricolorbox extends JPlugin 
{
	var $_assetsLoaded = false;

	function plgSystemAricolorbox(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onAfterRender()
	{
		$mainframe =& JFactory::getApplication();
		$document =& JFactory::getDocument();
		$doctype = $document->getType();

		if ($mainframe->isAdmin() || $doctype !== 'html') 
			return ;

		$kernelPath = JPATH_ROOT . DS . 'modules' . DS . 'mod_aricolorbox' . DS . 'includes' . DS . 'kernel' . DS . 'class.AriKernel.php';
		if (!@file_exists($kernelPath))
			return ;

		$pageContent = JResponse::getBody();
		//$jsLoaded = (strpos($pageContent, 'modules/mod_aricolorbox/includes/js/jquery.colorbox-min.js') !== false);

		$params =& $this->params;
		$loadType = $params->get('loadType', 'always');
		if ($loadType == 'auto')
		{
			if (!preg_match('/<[^>]*class=("|\'){0,1}[^"\']*aricolorbox(\s|"|\')/i', $pageContent))
				return ;
		}

		require_once $kernelPath;

		AriKernel::import('Utils.Utils2');
		AriKernel::import('Document.DocumentIncludesManager');
		AriKernel::import('Document.DocumentHelper');
		AriKernel::import('Web.JSON.JSONHelper');
		AriKernel::import('Parameters.ParametersHelper');
		AriKernel::import('Colorbox.Colorbox');

		$includesManager = new AriDocumentIncludesManager();

		$this->loadAssets();

		$mParams = AriParametersHelper::flatParametersToArray($params);
		
		$version = new JVersion();
		$j15 = version_compare($version->getShortVersion(), '1.6.0', '<');
		$sysBaseUri = JURI::root(true) . '/plugins/system/aricolorbox/' . (!$j15 ? 'aricolorbox/' : '') . 'js/';
		
		AriDocumentHelper::includeJsFile($sysBaseUri . 'jquery.metadata.js');
		AriDocumentHelper::includeJsFile($sysBaseUri . 'colorbox.helper.js');
		
		$jsOptions = AriColorboxHelper::getJsOptions(AriUtils2::getParam($mParams, 'opt', array()));
		$document->addScriptDeclaration(
			sprintf('(window["jQueryACB"] || jQuery)(document).ready(function($){ ariColorBoxInit($, %s); });',
				!empty($jsOptions) ? AriJSONHelper::encode($jsOptions) : 'null'
			)
		);

		$includes = $includesManager->getDifferences();
		AriDocumentHelper::addCustomTagsToDocument($includes);
	}

	function loadAssets()
	{
		if ($this->_assetsLoaded)
			return ;
			
		AriKernel::import('Colorbox.Colorbox');
		AriKernel::import('Web.JSON.JSONHelper');

		$params =& $this->params;
		$mParams = AriParametersHelper::flatParametersToArray($params);
		AriColorboxHelper::includeAssets(
			AriUtils2::parseValueBySample($params->get('includeJQuery'), true),
			AriUtils2::parseValueBySample($params->get('noConflict'), true),
			AriUtils2::parseValueBySample($params->get('jQueryVer', '1.4.4'), '1.4.4'),
			AriUtils2::parseValueBySample($params->get('theme'), 'white_black'),
			AriUtils2::getParam($mParams, 'opt', array()),
			$params);

		$this->_assetsLoaded = true;
	}
}
?>