<?php
/*
 * ARI Colorbox Links Joomla! plugin
 *
 * @package		ARI Colorbox Links Joomla! plugin.
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.event.plugin');

class plgSystemAricolorboxlinks extends JPlugin
{
	var $_assetsLoaded = false;
	var $_checked = null;
	
	function plgSystemAricolorboxlinks(&$subject, $params)
	{
		$this->preCheck();
		
		parent::__construct($subject, $params);
	}
	
	function preCheck()
	{
		if (!is_null($this->_checked))
			return $this->_checked;
			
		$kernelPath = JPATH_ROOT . DS . 'modules' . DS . 'mod_aricolorbox' . DS . 'includes' . DS . 'kernel' . DS . 'class.AriKernel.php';
		$this->_checked = @file_exists($kernelPath);
		
		if (!$this->_checked)
		{
			global $mainframe;
			
			$mainframe->enqueueMessage('"System - ARI Colorbox Links" plugin requires "ARI Colorbox" module. Install the module please.', 'error');
		}
		
		return $this->_checked;
	}

	function onAfterRender()
	{	
		if (!$this->preCheck())
			return ;
			
		require_once JPATH_ROOT . DS . 'modules' . DS . 'mod_aricolorbox' . DS . 'includes' . DS . 'kernel' . DS . 'class.AriKernel.php';

		AriKernel::import('Document.DocumentIncludesManager');
		AriKernel::import('Parameters.ParametersHelper');
		AriKernel::import('Utils.Utils');
		AriKernel::import('Utils.Utils2');
		AriKernel::import('Web.JSON.JSONHelper');
		AriKernel::import('Colorbox.Colorbox');

		$mainframe =& JFactory::getApplication();
		$document =& JFactory::getDocument();
		$doctype = $document->getType();

		if ($mainframe->isAdmin() || $doctype !== 'html') 
			return ;

		$scripts = '';
		$params =& $this->params;
		$selectors = $params->get('selectors');
		if (empty($selectors))
			return ;

		$selectors = explode("\n", $selectors);
		array_walk($selectors, 'trim');

		$selectorScripts = '';
		foreach ($selectors as $selector)
		{
			$matches = array();
			if (!preg_match_all('/"?([^"]+)"?\|?(.*)/i', $selector, $matches, PREG_SET_ORDER) ||
				count($matches[0]) < 2)
			{
				continue ;
			}

			$matches = $matches[0];
			$cssSelector = $matches[1];
			$extra = isset($matches[2]) ? explode('|', $matches[2]) : '';
			$isClone = isset($extra[2]) ? (bool)$extra[2] : true;
			$lnkParams = isset($extra[0]) ? $extra[0] : '';
			$plgParams = $this->getJsOptions(isset($extra[1]) ? $extra[1] : null);

			$selectorScripts .= sprintf('ARIColorboxLinks("%s", "%s", %s, %s);',
				$cssSelector,
				$lnkParams,
				AriJSONHelper::encode($plgParams),
				$isClone ? "true" : "false");
		}

		if (!$selectorScripts)
			return ;
			
		$includesManager = new AriDocumentIncludesManager();

		$this->loadAssets();

		$version = new JVersion();
		$j15 = version_compare($version->getShortVersion(), '1.6.0', '<');

		$document->addScript(JURI::root(true) . '/plugins/system/aricolorboxlinks/' . (!$j15 ? 'aricolorboxlinks/' : '') . 'js/aricolorboxlinks.js');
		$document->addScriptDeclaration('jQuery(document).ready(function(){' . $selectorScripts . '});');

		$includes = $includesManager->getDifferences();
		AriDocumentHelper::addCustomTagsToDocument($includes);
	}
	
	function getJsOptions($plgParams)
	{
		$mParams = AriParametersHelper::flatParametersToArray($this->params);
		$defPlgParams = AriUtils::getParam($mParams, 'opt', array());
		
		if ($plgParams)
		{
			$plgParams = explode('&', $plgParams);
			foreach ($plgParams as $param)
			{
				@list($pName, $pValue) = explode('=', $param);
				if (empty($pName))
					continue;
					
				$defPlgParams[$pName] = $pValue;
			}
		}

		$plgParams = AriColorboxHelper::getJsOptions($defPlgParams);
		$plgParams['iframe'] = true;
		
		return $plgParams;
	}

	function loadAssets()
	{
		if ($this->_assetsLoaded)
			return ;
			
		AriKernel::import('Colorbox.Colorbox');
		AriKernel::import('Web.JSON.JSONHelper');

		$params =& $this->params;
		$mParams = AriParametersHelper::flatParametersToArray($params);
		AriColorboxHelper::includeAssets(
			AriUtils2::parseValueBySample($params->get('includeJQuery'), true),
			AriUtils2::parseValueBySample($params->get('noConflict'), true),
			AriUtils2::parseValueBySample($params->get('jQueryVer', '1.4.4'), '1.4.4'),
			AriUtils2::parseValueBySample($params->get('theme'), 'white_black'),
			AriUtils2::getParam($mParams, 'opt', array()),
			$params);

		$this->_assetsLoaded = true;
	}
}
?>