<?php
/**
* 
* ARI Smart Content system Joomla! plugin
* Copyright (c) 2009 ARI Soft. http://www.ari-soft.com
* Released under the GNU/GPL license: http://www.gnu.org/copyleft/gpl.html 
* 
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemAriSmartContent extends JPlugin
{
	var $_isComponentInstalled = null;
	
	function plgSystemAriSmartContent(&$subject, $config)
	{
		parent::__construct($subject, $config); 
	}
	
	function onPrepareContent(&$article, &$params, $limitstart)
	{
		$this->prepatePlgContent($article);
	}

	function onContentPrepare($context, &$article, &$params)
	{
		$this->prepatePlgContent($article);
	}

	function prepatePlgContent($article)
	{
		$document = JFactory::getDocument();
		if ($document->getType() != 'pdf')
			return ;

		$mainframe = JFactory::getApplication();
		if ($mainframe->isAdmin() || !$this->_isSCInstalled()) 
			return ;

		$this->_load();

		$bot = new AriSmartContentMambot();
		$pParams = null;
		$content = is_object($article) ? $article->text : $article;
		$bot->processContent(true, $content, $pParams);
		
		if (is_object($article))
			$article->text = $content;
		else
			$article = $content;
	}
	
	function onAfterRender()
	{
		$option = JRequest::getString('option');
		
		$document = JFactory::getDocument();
		if ($document->getType() == 'pdf')
			return ;

		$mainframe = JFactory::getApplication();
		if ($mainframe->isAdmin() || !$this->_isSCInstalled()) return ;

		if ($option == 'com_content' && JRequest::getString('view') == 'form' && JRequest::getString('layout') == 'edit')
			return ;		

		$params = $this->params;
		$allPages = $params->get('allComponents', 'no');
		if ($allPages != 'yes')
		{
			if (empty($option)) return ;

			$components = trim($this->params->get('components', ''));
			$components = explode("\n", $components);
			$components = array_map('trim', $components);
			
			if ($option != 'com_content' && !in_array($option, $components)) return ;
		}
		
		$this->_load();
		
		$includesManager = new AriDocumentIncludesManager();
 
		$bot = new AriSmartContentMambot();
		$pParams = null;
		$content = JResponse::getBody();

		$bot->processContent(true, $content, $pParams);

		JResponse::setBody($content);

		$includes = $includesManager->getDifferences();
		AriDocumentHelper::addCustomTagsToDocument($includes);
	}
	
	function _load()
	{
		static $loaded = false;
		if ($loaded) return ;
		
		require_once JPATH_SITE . '/administrator/components/com_arismartcontent/kernel/class.AriKernel.php';
		
		AriKernel::import('Constants.ClassConstants');
		AriKernel::import('Constants.ConstantsManager');
		AriKernel::import('GlobalPrefs.GlobalPrefs');
		AriKernel::import('Components.AriSmartContent.AriSmartContent');
		AriKernel::import('Components.AriSmartContent.Mambot.AriSmartContentMambot');
		AriKernel::import('Web.Utils.WebHelper');
		AriKernel::import('Web.TaskManager');
		AriKernel::import('Web.Response');
		AriKernel::import('Controllers.ControllerBase');
		AriKernel::import('Mambot.MambotBase');
		AriKernel::import('Web.JSON.JSONHelper');
		AriKernel::import('Document.DocumentHelper');
		AriKernel::import('Document.DocumentIncludesManager');
		
		$scComp = AriSmartContentComponent::instance();
		$scComp->init();
		
		$loaded = true;
	}
	
	function _isSCInstalled()
	{
		if (is_null($this->_isComponentInstalled))
		{
			$path = JPATH_ROOT;
			$adminBasePath = $path . '/administrator/components/com_arismartcontent';
			
			$this->_isComponentInstalled = @file_exists($adminBasePath); 
		}

		return $this->_isComponentInstalled; 
	}
}
?>