<?php
/**
 * @package Gantry Template Framework - RocketTheme
 * @version 1.6.3 June 14, 2011
 * @author RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2011 RocketTheme, LLC
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * Gantry uses the Joomla Framework (http://www.joomla.org), a GNU/GPLv2 content management system
 *
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted index access' );

// load and inititialize gantry class
require_once('lib/gantry/gantry.php');
$gantry->init();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $gantry->language; ?>" lang="<?php echo $gantry->language;?>" >
<head>
	<?php 
		$gantry->displayHead();
		$gantry->addStyles(array('template.css','joomla.css'));
		
		if ($gantry->get('fixedheader') && $gantry->get('menu-type') != 'splicemenu') $gantry->addScript('rt-fixedheader.js');
		
		$browser = $gantry->browser->name;
		$ver = $gantry->browser->shortversion;
		if ($browser == 'ie' && ($ver == 7 || $ver == 8 || $ver == 9)){
			$gantry->addScript('IE-animations.js');
		}
		
		if ($gantry->browser->platform != 'iphone')
			$gantry->addInlineScript('window.addEvent("domready", function(){ new SmoothScroll(); });');
		
	?>
</head>
	<body <?php echo $gantry->displayBodyTag(array('bodyLevel')); ?>>
		<div id="rt-page-surround">
			<?php /** Begin Drawer **/ if ($gantry->countModules('drawer')) : ?>
			<div id="rt-drawer">
				<div class="rt-container">
					<?php echo $gantry->displayModules('drawer','standard','standard'); ?>
					<div class="clear"></div>
				</div>
			</div>
			<?php /** End Drawer **/ endif; ?>
			<div id="rt-page-background">
				<div id="rt-header-surround" <?php echo $gantry->displayClassesByTag('rt-header-surround'); ?>>
					<div id="rt-header-background" <?php echo $gantry->displayClassesByTag('rt-header-background'); ?>>
						<?php /** Begin Top **/ if ($gantry->countModules('top')) : ?>
						<div id="rt-top">
							<div class="rt-container">
								<?php echo $gantry->displayModules('top','standard','standard'); ?>
								<div class="clear"></div>
							</div>
						</div>
						<?php /** End Top **/ endif; ?>
						<?php /** Begin Header **/ if ($gantry->countModules('header')) : ?>
						<div id="rt-header">
							<div class="rt-container">
								<?php echo $gantry->displayModules('header','standard','standard'); ?>
								<div class="clear"></div>
							</div>
						</div>
						<?php /** End Header **/ endif; ?>
					</div>
					<?php /** Begin Navigation **/ if ($gantry->countModules('navigation')) : ?>
					<div id="rt-navigation" class="<?php if ($gantry->get('menu-centering')) : ?>centered<?php endif; ?>">
						<div class="rt-container">
							<?php echo $gantry->displayModules('navigation','basic','basic'); ?>
					    	<div class="clear"></div>
						</div>
					</div>
					<?php /** End Navigation **/ endif; ?>
					<div id="rt-header-bottom"></div>
				</div>
				<div id="rt-body-background">
					<div class="rt-container">
						<?php /** Begin Controls **/ if ($gantry->countModules('controls')) : ?>
						<div id="rt-controls">
							<?php echo $gantry->displayModules('controls','basic','basic'); ?>
						</div>
						<div class="clear"></div>
						<?php /** End Controls **/ endif; ?>
						<?php /** Begin Utility **/ if ($gantry->countModules('utility')) : ?>
						<div id="rt-utility">
							<?php echo $gantry->displayModules('utility','standard','standard'); ?>
							<div class="clear"></div>
						</div>
						<?php /** End Utility **/ endif; ?>
						<?php /** Begin Showcase **/ if ($gantry->countModules('showcase')) : ?>
						<div id="rt-showcase">
							<?php if (controlsDisplay('showcase')): ?>
							<div class="controls"><span class="down"></span><span class="up"></span></div>
							<?php endif; ?>
							<?php echo $gantry->displayModules('showcase','standard','scroller'); ?>
							<div class="clear"></div>
						</div>
						<?php /** End Showcase **/ endif; ?>
						<?php /** Begin Feature **/ if ($gantry->countModules('feature')) : ?>
						<div id="rt-feature">
							<?php if (controlsDisplay('feature')): ?>
							<div class="controls"><span class="down"></span><span class="up"></span></div>
							<?php endif; ?>
							<?php echo $gantry->displayModules('feature','standard','scroller'); ?>
							<div class="clear"></div>
						</div>
						<?php /** End Feature **/ endif; ?>
						<?php /** Begin Main Top **/ if ($gantry->countModules('maintop')) : ?>
						<div id="rt-maintop">
							<?php echo $gantry->displayModules('maintop','standard','standard'); ?>
							<div class="clear"></div>
						</div>
						<?php /** End Main Top **/ endif; ?>
						<?php /** Begin Breadcrumbs **/ if ($gantry->countModules('breadcrumb')) : ?>
						<div id="rt-breadcrumbs">
							<?php echo $gantry->displayModules('breadcrumb','basic','breadcrumbs'); ?>
							<div class="clear"></div>
						</div>
						<?php /** End Breadcrumbs **/ endif; ?>
						<?php /** Begin Main Body **/ ?>
					    <?php echo $gantry->displayMainbody('mainbody','sidebar','standard','standard','standard','standard','standard'); ?>
						<?php /** End Main Body **/ ?>
						<?php /** Begin Main Bottom **/ if ($gantry->countModules('mainbottom')) : ?>
						<div id="rt-mainbottom">
							<?php echo $gantry->displayModules('mainbottom','standard','standard'); ?>
							<div class="clear"></div>
						</div>
						<?php /** End Main Bottom **/ endif; ?>
					</div>
				</div>
				<?php /** Begin Footer Section **/ if ($gantry->countModules('bottom') or $gantry->countModules('footer') or $gantry->countModules('copyright') or $gantry->countModules('debug')) : ?>
				<div id="rt-footer-surround" <?php echo $gantry->displayClassesByTag('rt-footer-surround'); ?>>
					<?php /** Begin Bottom **/ if ($gantry->countModules('bottom')) : ?>
					<div id="rt-bottom">
						<div class="rt-container">
							<div class="rt-section-surround">
								<div class="rt-row-surround">
									<?php echo $gantry->displayModules('bottom','bottom','standard'); ?>
								</div>
							</div>
							<div class="clear"></div>
						</div>
					</div>
					<?php /** End Bottom **/ endif; ?>
					<?php /** Begin Footer **/ if ($gantry->countModules('footer')) : ?>
					<div id="rt-footer">
						<div class="rt-container">
							<?php echo $gantry->displayModules('footer','standard','standard'); ?>
							<div class="clear"></div>
						</div>
					</div>
					<?php /** End Footer **/ endif; ?>
					<?php /** Begin Copyright **/ if ($gantry->countModules('copyright')) : ?>
					<div id="rt-copyright">
						<div class="rt-container">
							<?php echo $gantry->displayModules('copyright','standard','standard'); ?>
							<div class="clear"></div>
						</div>
					</div>
					<?php /** End Copyright **/ endif; ?>
					<?php /** Begin Debug **/ if ($gantry->countModules('debug')) : ?>
					<div id="rt-debug">
						<div class="rt-container">
							<?php echo $gantry->displayModules('debug','standard','standard'); ?>
							<div class="clear"></div>
						</div>
					</div>
					<?php /** End Debug **/ endif; ?>
				</div>
				<?php /** End Footer Section **/ endif; ?>
			</div>
			<?php /** Begin Popups **/ 
			echo $gantry->displayModules('popup','popup','popup');
			echo $gantry->displayModules('login','login','popup'); 
			/** End Popup s**/ ?>
			<?php /** Begin Analytics **/ if ($gantry->countModules('analytics')) : ?>
			<?php echo $gantry->displayModules('analytics','basic','basic'); ?>
			<?php /** End Analytics **/ endif; ?>
		</div>
	</body>
</html>
<?php
$gantry->finalize();

function controlsDisplay($positionStub){
	global $gantry;
	
	$published = array();	
	$showControls = false;
	$positions = $gantry->getPositions($positionStub);
	
	foreach($positions as $position){
		if ($gantry->countModules($position)) array_push($published, $position);
	}
	
	foreach($published as $position){
		if (!$showControls && $gantry->get('scrolling'.$positionStub.'-enabled') && $gantry->countSubPositionModules($position) > 1) $showControls = true;
	}
	
	return $showControls;
	
}

?>