<?php
/**
 * @package   Zephyr Template - RocketTheme
 * @version   1.6.5 February 19, 2012
 * @author    RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2012 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * Rockettheme Zephyr Template uses the Joomla Framework (http://www.joomla.org), a GNU/GPLv2 content management system
 *
 */
defined('JPATH_BASE') or die();

$gantry_config_mapping = array(
    'belatedPNG' => 'belatedPNG',
	'ie6Warning' => 'ie6Warning'
);

$gantry_presets = array (
    'presets' => array (
        'preset1' => array (
            'name' => 'Preset 1',
			'bodylevel' => 'high',
			'background' => 'img-splats',
			'page-background' => '#1E1E1E',
			'page-text' => '#AAAAAA',
			'page-overlay' => 'dark',
			'page-link' => '#CF3F1B',
			'header-text' => '#AAAAAA',
			'header-link' => '#CF3F1B',
			'header-overlay' => 'dark',
            'navigation-background' => '#373737',
            'navigation-text' => '#FFFFFF',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#055B9F',
			'showcase-background' => '#951E01',
			'showcase-text' => '#EEEEEE',
			'showcase-overlay' => 'dark',
			'showcase-link' => '#FFFFFF',
			'feature-background' => '#373737',
			'feature-text' => '#AAAAAA',
			'feature-overlay' => 'dark',
			'feature-link' => '#CF3F1B',
			'utility-overlay' => 'dark',
			'body-background' => '#373737',
			'body-text' => '#AAAAAA',
			'body-overlay' => 'dark',
			'body-link' => '#CF3F1B',
			'bottom-background' => '#050505',
			'bottom-text' => '#AAAAAA',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#CF3F1B',
			'footer-background' => 'transparent',
			'footer-text' => '#AAAAAA',
			'footer-overlay' => 'dark',
			'footer-link' => '#FFFFFF',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
        'preset2' => array (
            'name' => 'Preset 2',
			'bodylevel' => 'high',
			'background' => 'img-sky',
			'page-background' => '#FFFFFF',
			'page-text' => '#666666',
			'page-overlay' => 'light',
			'page-link' => '#23759C',
			'header-text' => '#666666',
			'header-overlay' => 'light',
			'header-link' => '#23759C',
			'navigation-background' => '#FFFFFF',
			'navigation-text' => '#666666',
			'navigation-overlay' => 'light',
			'navigation-link' => '#E7F8FF',
			'showcase-background' => 'transparent',
			'showcase-text' => '#666666',
			'showcase-overlay' => 'dark',
			'showcase-link' => '#23759C',
			'feature-background' => 'transparent',
			'feature-text' => '#666666',
			'feature-overlay' => 'light',
			'feature-link' => '#23759C',
			'utility-overlay' => 'light',
			'body-background' => '#ffffff',
			'body-text' => '#666666',
			'body-overlay' => 'light',
			'body-link' => '#23759C',
			'bottom-background' => '#FFFFFF',
			'bottom-text' => '#666666',
			'bottom-overlay' => 'light',
			'bottom-link' => '#23759C',
			'footer-background' => 'transparent',
			'footer-text' => '#666666',
			'footer-overlay' => 'light',
			'footer-link' => '#23759C',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
        'preset3' => array (
            'name' => 'Preset 3',
            'bodylevel' => 'high',
            'background' => 'img-grunge',
            'page-background' => '#0A091B',
            'page-text' => '#cccccc',
            'page-overlay' => 'dark',
            'page-link' => '#A25679',
            'header-text' => '#eeeeee',
            'header-link' => '#FFFFFF',
            'header-overlay' => 'dark',
            'navigation-background' => '#4E5061',
            'navigation-text' => '#ffffff',
            'navigation-overlay' => 'dark',
            'navigation-link' => '#742247',
            'showcase-background' => '#292B40',
            'showcase-text' => '#cccccc',
            'showcase-overlay' => 'dark',
            'showcase-link' => '#ffffff',
            'feature-background' => '#15172F',
            'feature-text' => '#cccccc',
            'feature-overlay' => 'dark',
            'feature-link' => '#A25679',
            'utility-overlay' => 'dark',
            'body-background' => '#15172F',
            'body-text' => '#cccccc',
            'body-overlay' => 'dark',
            'body-link' => '#A25679',
            'bottom-background' => 'transparent',
            'bottom-text' => '#cccccc',
            'bottom-overlay' => 'dark',
            'bottom-link' => '#A25679',
            'footer-background' => 'transparent',
            'footer-text' => '#999999',
            'footer-overlay' => 'dark',
            'footer-link' => '#A25679',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
        'preset4' => array (
            'name' => 'Preset 4',
			'bodylevel' => 'high',
			'background' => 'img-circles',
			'page-background' => '#170505',
			'page-text' => '#CCCCCC',
			'page-overlay' => 'dark',
			'page-link' => '#DF7746',
			'header-text' => '#ffffff',
			'header-overlay' => 'dark',
			'header-link' => '#ffffff',
			'navigation-background' => '#572728',
			'navigation-text' => '#FFFFFF',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#BC5523',
			'showcase-background' => 'transparent',
			'showcase-text' => '#EEEEEE',
			'showcase-overlay' => 'light',
			'showcase-link' => '#FFFFFF',
			'feature-background' => '#3C1B1B',
			'feature-text' => '#CCCCCC',
			'feature-overlay' => 'dark',
			'feature-link' => '#DF7746',
			'utility-overlay' => 'dark',
			'body-background' => '#3C1B1B',
			'body-text' => '#CCCCCC',
			'body-overlay' => 'dark',
			'body-link' => '#DF7746',
			'bottom-background' => 'transparent',
			'bottom-text' => '#CCCCCC',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#DF7746',
			'footer-background' => 'transparent',
			'footer-text' => '#CCCCCC',
			'footer-overlay' => 'dark',
			'footer-link' => '#DF7746',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
        'preset5' => array (
            'name' => 'Preset 5',
			'bodylevel' => 'high',
			'background' => 'img-planets',
			'page-background' => '#111111',
			'page-text' => '#AAAAAA',
			'page-overlay' => 'dark',
			'page-link' => '#A077AC',
			'header-text' => '#AAAAAA',
			'header-overlay' => 'dark',
			'header-link' => '#A077AC',
			'navigation-background' => '#373737',
			'navigation-text' => '#FFFFFF',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#171717',
			'showcase-background' => '#2E0F39',
			'showcase-text' => '#EEEEEE',
			'showcase-overlay' => 'dark',
			'showcase-link' => '#FFFFFF',
			'feature-background' => '#373737',
			'feature-text' => '#AAAAAA',
			'feature-overlay' => 'dark',
			'feature-link' => '#A077AC',
			'utility-overlay' => 'dark',
			'body-background' => '#373737',
			'body-text' => '#AAAAAA',
			'body-overlay' => 'dark',
			'body-link' => '#A077AC',
			'bottom-background' => '#2E0F39',
			'bottom-text' => '#AAAAAA',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#A077AC',
			'footer-background' => 'transparent',
			'footer-text' => '#AAAAAA',
			'footer-overlay' => 'dark',
			'footer-link' => '#FFFFFF',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
        'preset6' => array (
			'name' => 'Preset 6',
			'bodylevel' => 'high',
			'background' => 'trans-camo',
			'page-background' => '#252E24',
			'page-text' => '#AAAAAA',
			'page-overlay' => 'dark',
			'page-link' => '#C8B1A4',
			'header-text' => '#AAAAAA',
			'header-overlay' => 'dark',
			'header-link' => '#C8B1A4',
			'navigation-background' => '#313930',
			'navigation-text' => '#FFFFFF',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#655146',
			'showcase-background' => '#30382E',
			'showcase-text' => '#EEEEEE',
			'showcase-overlay' => 'light',
			'showcase-link' => '#C8B1A4',
			'feature-background' => '#655146',
			'feature-text' => '#AAAAAA',
			'feature-overlay' => 'dark',
			'feature-link' => '#C8B1A4',
			'utility-overlay' => 'dark',
			'body-background' => '#252E24',
			'body-text' => '#AAAAAA',
			'body-overlay' => 'dark',
			'body-link' => '#C8B1A4',
			'bottom-background' => '#111611',
			'bottom-text' => '#AAAAAA',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#C8B1A4',
			'footer-background' => 'transparent',
			'footer-text' => '#AAAAAA',
			'footer-overlay' => 'dark',
			'footer-link' => '#C8B1A4',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
		'preset7' => array (
			'name' => 'Preset 7',
			'bodylevel' => 'high',
			'background' => 'trans-digital',
			'page-background' => '#FFFFFF',
			'page-text' => '#333333',
			'page-overlay' => 'light',
			'page-link' => '#105F7D',
			'header-text' => '#333333',
			'header-overlay' => 'light',
			'header-link' => '#105F7D',
			'navigation-background' => '#A8BD10',
			'navigation-text' => '#FFFFFF',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#105F7D',
			'showcase-background' => '#A8BD10',
			'showcase-text' => '#EEEEEE',
			'showcase-overlay' => 'light',
			'showcase-link' => '#FFFFFF',
			'feature-background' => '#FFFFFF',
			'feature-text' => '#333333',
			'feature-overlay' => 'light',
			'feature-link' => '#105F7D',
			'utility-overlay' => 'light',
			'body-background' => '#ffffff',
			'body-text' => '#666666',
			'body-overlay' => 'light',
			'body-link' => '#105F7D',
			'bottom-background' => '#105F7D',
			'bottom-text' => '#EEEEEE',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#FFFFFF',
			'footer-background' => 'transparent',
			'footer-text' => '#333333',
			'footer-overlay' => 'light',
			'footer-link' => '#105F7D',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
		'preset8' => array (
			'name' => 'Preset 8',
			'bodylevel' => 'high',
			'background' => 'trans-grunge-1',
			'page-background' => '#131919',
			'page-text' => '#DEE9ED',
			'page-overlay' => 'dark',
			'page-link' => '#E35C13',
			'header-text' => '#DEE9ED',
			'header-overlay' => 'dark',
			'header-link' => '#E35C13',
			'navigation-background' => '#3B3F3F',
			'navigation-text' => '#FFFFFF',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#E35C13',
			'showcase-background' => '#273D3B',
			'showcase-text' => '#DEE9ED',
			'showcase-overlay' => 'dark',
			'showcase-link' => '#ffffff',
			'feature-background' => 'transparent',
			'feature-text' => '#DEE9ED',
			'feature-overlay' => 'dark',
			'feature-link' => '#E35C13',
			'utility-overlay' => 'dark',
			'body-background' => '#2F3333',
			'body-text' => '#DEE9ED',
			'body-overlay' => 'dark',
			'body-link' => '#E35C13',
			'bottom-background' => '#2F3333',
			'bottom-text' => '#DEE9ED',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#E35C13',
			'footer-background' => 'transparent',
			'footer-text' => '#DEE9ED',
			'footer-overlay' => 'dark',
			'footer-link' => '#E35C13',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
		'preset9' => array (
			'name' => 'Preset 9',
			'bodylevel' => 'high',
			'background' => 'trans-wood-1',
			'page-background' => '#332823',
			'page-text' => '#C2C9BF',
			'page-overlay' => 'dark',
			'page-link' => '#60ACA4',
			'header-text' => '#C2C9BF',
			'header-overlay' => 'dark',
			'header-link' => '#60ACA4',
			'navigation-background' => '#5F665C',
			'navigation-text' => '#FFFFFF',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#60ACA4',
			'showcase-background' => '#262A24',
			'showcase-text' => '#C2C9BF',
			'showcase-overlay' => 'dark',
			'showcase-link' => '#60ACA4',
			'feature-background' => '#3A312E',
			'feature-text' => '#C2C9BF',
			'feature-overlay' => 'dark',
			'feature-link' => '#60ACA4',
			'utility-overlay' => 'dark',
			'body-background' => '#3A312E',
			'body-text' => '#C2C9BF',
			'body-overlay' => 'dark',
			'body-link' => '#60ACA4',
			'bottom-background' => '#262A24',
			'bottom-text' => '#C2C9BF',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#60ACA4',
			'footer-background' => 'transparent',
			'footer-text' => '#C2C9BF',
			'footer-overlay' => 'dark',
			'footer-link' => '#60ACA4',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
		'preset10' => array (
			'name' => 'Preset 10',
			'bodylevel' => 'high',
			'background' => 'trans-wood-2',
			'page-background' => '#EFF3FF',
			'page-text' => '#535863',
			'page-overlay' => 'light',
			'page-link' => '#586344',
			'header-text' => '#535863',
			'header-overlay' => 'light',
			'header-link' => '#586344',
			'navigation-background' => '#8B93A6',
			'navigation-text' => '#FFFFFF',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#687452',
			'showcase-background' => '#565D6C',
			'showcase-text' => '#EEEEEE',
			'showcase-overlay' => 'dark',
			'showcase-link' => '#FFFFFF',
			'feature-background' => '#687452',
			'feature-text' => '#EEEEEE',
			'feature-overlay' => 'dark',
			'feature-link' => '#FFFFFF',
			'utility-overlay' => 'light',
			'body-background' => '#E3E5EB',
			'body-text' => '#535863',
			'body-overlay' => 'light',
			'body-link' => '#586344',
			'bottom-background' => '#565D6C',
			'bottom-text' => '#EEEEEE',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#FFFFFF',
			'footer-background' => '#E3E5EB',
			'footer-text' => '#535863',
			'footer-overlay' => 'light',
			'footer-link' => '#586344',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
		'preset11' => array (
			'name' => 'Preset 11',
			'bodylevel' => 'high',
			'background' => 'img-fire',
			'page-background' => '#000000',
			'page-text' => '#AAAAAA',
			'page-overlay' => 'dark',
			'page-link' => '#3681BD',
			'header-text' => '#AAAAAA',
			'header-overlay' => 'dark',
			'header-link' => '#ffffff',
			'navigation-background' => '#111111',
			'navigation-text' => '#EEEEEE',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#2C6FA5',
			'showcase-background' => '#000000',
			'showcase-text' => '#AAAAAA',
			'showcase-overlay' => 'dark',
			'showcase-link' => '#FFFFFF',
			'feature-background' => '#111111',
			'feature-text' => '#AAAAAA',
			'feature-overlay' => 'dark',
			'feature-link' => '#3681BD',
			'utility-overlay' => 'dark',
			'body-background' => '#111111',
			'body-text' => '#AAAAAA',
			'body-overlay' => 'dark',
			'body-link' => '#3681BD',
			'bottom-background' => '#050505',
			'bottom-text' => '#AAAAAA',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#3681BD',
			'footer-background' => 'transparent',
			'footer-text' => '#AAAAAA',
			'footer-overlay' => 'dark',
			'footer-link' => '#3681BD',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        ),
		'preset12' => array (
			'name' => 'Preset 12',
			'bodylevel' => 'high',
			'background' => 'img-sc2',
			'page-background' => '#0D1526',
			'page-text' => '#AAAAAA',
			'page-overlay' => 'dark',
			'page-link' => '#42A178',
			'header-text' => '#AAAAAA',
			'header-overlay' => 'dark',
			'header-link' => '#42A178',
			'navigation-background' => '#1B2232',
			'navigation-text' => '#EEEEEE',
			'navigation-overlay' => 'dark',
			'navigation-link' => '#026A3E',
			'showcase-background' => '#182E52',
			'showcase-text' => '#CCCCCC',
			'showcase-overlay' => 'light',
			'showcase-link' => '#FFFFFF',
			'feature-background' => 'transparent',
			'feature-text' => '#CCCCCC',
			'feature-overlay' => 'dark',
			'feature-link' => '#42A178',
			'utility-overlay' => 'dark',
			'body-background' => '#0E1526',
			'body-text' => '#AAAAAA',
			'body-overlay' => 'dark',
			'body-link' => '#42A178',
			'bottom-background' => 'transparent',
			'bottom-text' => '#AAAAAA',
			'bottom-overlay' => 'dark',
			'bottom-link' => '#42A178',
			'footer-background' => 'transparent',
			'footer-text' => '#AAAAAA',
			'footer-overlay' => 'dark',
			'footer-link' => '#42A178',
			'articlestyle' => 'title4',
			'articledetails' => 'layout3',
            'font-family' => 'enigmatic'
        )
    )
);

$gantry_browser_params = array(
    'ie6' => array(
        'bodylevel' => 'low',
        'readonstyle' => 'link'
    )
);

$gantry_belatedPNG = array('.png', '#rt-logo', '.stuff', '.rt-joomla .icon','#rt-mainbody .inputbox','#rt-mainbody input#email','#rt-mainbody input#name','#rt-mainbody input#username','#rt-mainbody input#password','#rt-mainbody input#password2','#rt-mainbody input#passwd','#rt-mainbody .rt-joomla-table tr.even td','#rt-mainbody .rt-joomla-table th','span.breadcrumbs img','#breadcrumbs-home','ul.bullet-no1 li','ul.bullet-no2 li','ul.bullet-no3 li','#gantry-totop .totop-icon','#rt-accessibility a.small .button','#rt-accessibility a.large .button','.article-rating .rating-bar','.article-rating .rating-bar div','.roknewspager-next','.roknewspager-next-disabled','.roknewspager-prev','.roknewspager-prev-disabled','.date-icon','#rt-login-button .buttontext .icon','#rt-popupmodule-button .buttontext .icon ','#rt-page-background','.roksearch-wrapper','#roksearch_search_str','#modlgn_username','#modlgn_passwd','.details-layout3 .rt-infobutton');

$gantry_ie6Warning = "<h3>IE6 DETECTED: Currently Running in Compatibility Mode</h3><h4>This site is compatible with IE6, however your experience will be enhanced with a newer browser</h4><p>Internet Explorer 6 was released in August of 2001, and the latest version of IE6 was released in August of 2004.  By continuing to run Internet Explorer 6 you are open to any and all security vulnerabilities discovered since that date.  In March of 2009, Microsoft released version 8 of Internet Explorer that, in addition to providing greater security, is faster and more standards compliant than both version 6 and 7 that came before it.</p> <br /><a class='external'  href='http://www.microsoft.com/windows/internet-explorer/?ocid=ie8_s_cfa09975-7416-49a5-9e3a-c7a290a656e2'>Download Internet Explorer 8 NOW!</a>";