<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

require(RSS_FACTORY_XAJAX_PATH.DS.'thefactory.xajax.php');

class JRfProAdminXajax extends JTheFactoryXajax{
	function JRfProAdminXajax(){
		$aCallableObjects = array();
		$aCallableObjects[] = new RfProAdminXajaxMethods;

		$aCallableFunctions = array();

		parent::__construct('rssfactory_pro',$aCallableObjects,$aCallableFunctions);
	}
}

class RfProAdminXajaxMethods{
	//this property is populated by JTheFactoryXajax class, when it registers an instance of this class;
	//it is needed, for example, in "listCategories" method, when sending back a js call to the "deleteRestriction" method
	//if you have a better idea, do tell
	var $xajaxMethods = null;

	function FeedSourceRefreshIcon($feedid)
	{
	    $database = &JFactory::getDBO();
		$objResponse = new xajaxResponse();

		if (! RSS_FACTORY_SITE_SAFE_MODE_ON)
		{
			set_time_limit(180);
		}

	 	$source =& JTable::getInstance('rfprosource');
	    if(!$source->load($feedid)){
	    	$objResponse->alert('Oups! Bad source id or smth...');
	    	return $objResponse;
	    }

	    RFProAdminHelper::getSiteIcon($source->id,$source->url);

		$newSrc = RSS_FACTORY_COMPONENT_URI.'images/ico_'.md5($source->id).'.png?'.time();

		$objResponse->assign('feedicon_'.$source->id,'src',$newSrc);
		$objResponse->script('HideProgress();alert(\'Icon Refreshed!\');');
		return $objResponse;
	}

	function truncateCacheTable(){

		$objResponse = new xajaxResponse();

		$database = &JFactory::getDBO();
		$database->setQuery("TRUNCATE TABLE `#__rssfactory_cache`");
		if($database->query()){
			$objResponse->script	('HideProgress();alert(\'Cache Cleared!\');');
		}
		else{
			$objResponse->script	('HideProgress();alert(\'Problem clearing cache!\');');
		}

		$objResponse->assign('nr_feeds','innerHTML',0);
		return $objResponse;
	}

	function refreshFeedSource($sourceId){
		$objResponse = new xajaxResponse();
		$database = &JFactory::getDBO();

		if (!RSS_FACTORY_SITE_SAFE_MODE_ON){
			set_time_limit(180);
		}

		$row =& JTable::getInstance('rfprosource');
		$row->load($sourceId);

		if(!$row->url){
			$objResponse->script("HideProgress();alert('Feed does not exist!!');");
		}
		else{
			$nrNewStories = RFProAdminHelper::refreshSpecificFeedSource($row);

			$msg = addslashes( $nrNewStories.' stories added from source "'.$row->title.'"' );
			$objResponse->script("HideProgress();alert('$msg');");
			
			$database->setQuery("SELECT COUNT(*) FROM `#__rssfactory_cache` WHERE `rssid`='".$row->id."' AND `archived`='0'");
			$nrStoriesInCache = $database->loadResult();
			if($row->nrfeeds!=0){
				$objResponse->assign('nrStories_'.$row->id,'innerHTML',$nrStoriesInCache);
			}
			else{
				$objResponse->assign('nrStories_'.$row->id,"innerHTML",'All( '.$nrStoriesInCache.' )');
			}
			$objResponse->assign('refreshDate_'.$row->id,'innerHTML',$row->date);
		}

		return $objResponse;
	}

	function refreshAllFeedSources()
	{
		$objResponse = new xajaxResponse();
		$database = &JFactory::getDBO();

		if (! RSS_FACTORY_SITE_SAFE_MODE_ON){
			set_time_limit(6000);
		}

		$query = 'SELECT `r`.*,COUNT(`c`.`id`) AS storiesInCache '.
						' FROM `#__rssfactory` AS r '. 
						' LEFT JOIN `#__rssfactory_cache` AS c '.
							' ON `r`.`id`=`c`.`rssid` '.
						' WHERE (`c`.`archived`=0 OR `c`.`archived` IS NULL) '.
						' GROUP BY `r`.`id` '.
						' ORDER BY `r`.`date` DESC ';
		$database->setQuery( $query );
		$rows=$database->LoadObjectList();

		$totalNewStories=0;

		foreach($rows as $row){
			$currentSouceNewStories = RFProAdminHelper::refreshSpecificFeedSource($row);
			$totalNewStories += $currentSouceNewStories;

			if($row->nrfeeds!=0){
	    		$objResponse->assign('nrStories_'.$row->id,'innerHTML',$currentSouceNewStories);
 			}
	    	else{
	    		$objResponse->assign('nrStories_'.$row->id,'innerHTML','All( '.$currentSouceNewStories.' )');
    		}
	    	$objResponse->assign( 'refreshDate'.$row->id,'innerHTML', date('Y-m-d H:i:s') );
	    }

		$msg = $totalNewStories.' stories added to cache!';
		$objResponse->script("HideProgress();alert('$msg!');");

		return $objResponse;
	}
	
	function feedSourceChangePublishedStatus($sourceId)
	{
		$objResponse = new xajaxResponse();
		$database = &JFactory::getDBO();
		
		if(!$sourceId){
			return;
		}
		
		$row =& JTable::getInstance('rfprosource');
		$row->load($sourceId);
		$row->published = 1 - $row->published;
		$row->store();

		$publishedStatusSrc = ($row->published) ? 'images/publish_g.png' : 'images/publish_x.png';

		$objResponse->assign('imgPublishedStatus_'.$row->id,'src',$publishedStatusSrc);
		
		return $objResponse;
	}

	function configSelectDefaultSection(){
		$objResponse = new xajaxResponse();
		$database = &JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$content_sections = array();
		$content_sections[] = JHTML::_('select.option',0,'Select section');
		$database->setQuery( 'SELECT `id` AS value,`title` AS text FROM `#__sections` ORDER BY `ordering`' );
		$content_sections = array_merge($content_sections,$database->loadObjectList());

		$this->xajaxMethods['configselectdefaultcategory']->setParameter(0,XAJAX_JS_VALUE,'this.value');
		$data = JHTML::_('select.genericlist',$content_sections,'i2c_default_sectionid','onchange="'.$this->xajaxMethods['configselectdefaultcategory']->getScript().'" class="inputbox"','value','text',$config->i2c_default_sectionid);

		$objResponse->assign('container_I2CdefaultSection','innerHTML',$data);

		return $objResponse;
	}
	
	function configSelectDefaultCategory($sectionid){
		$objResponse = new xajaxResponse();
		$database = &JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		if(!$sectionid){
			$objResponse->clear('container_I2CdefaultCategory','innerHTML');
			return $objResponse;
		}

		$content_categories = array();
		$content_categories[] = JHTML::_('select.option',0,'Select category');
		$database->setQuery( 'SELECT `id` AS value,`title` AS text FROM `#__categories` WHERE `section`=\''.$database->getEscaped($sectionid).'\' ORDER BY `ordering`' );
		$content_categories = array_merge($content_categories,$database->loadObjectList());

		$data = JHTML::_('select.genericlist',$content_categories,'i2c_default_catid','class="inputbox"','value','text',$config->i2c_default_catid);

		$objResponse->assign('container_I2CdefaultCategory','innerHTML',$data);

		return $objResponse;
	}

	function optimizeCacheTable(){
		$objResponse = new xajaxResponse();

		$database = &JFactory::getDBO();
		$database->setQuery('OPTIMIZE TABLE `#__rssfactory_cache`');
		$database->query();

		$objResponse->assign('cacheOverheadSize','innerHTML','0');
		$objResponse->alert('Cache table optimized!');

		return $objResponse;
	}
	
	function selectI2CSection($sourceId){
		$objResponse = new xajaxResponse();
		$database = &JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$source =& JTable::getInstance('rfprosource');
		$source->load($sourceId);
		$selected = $source->i2c_sectionid ? $source->i2c_sectionid : $config->i2c_default_sectionid;

		$content_sections = array();
		$content_sections[] = JHTML::_('select.option',0,'Select section');
		$database->setQuery( 'SELECT `id` AS value,`title` AS text FROM `#__sections` ORDER BY `ordering`' );
		$content_sections = array_merge($content_sections,$database->loadObjectList());

		$this->xajaxMethods['selecti2ccategory']->setParameter(0,XAJAX_QUOTED_VALUE,$sourceId);
		$this->xajaxMethods['selecti2ccategory']->setParameter(1,XAJAX_JS_VALUE,'this.value');
		$data = JHTML::_('select.genericlist',$content_sections,'i2c_sectionid','onchange="'.$this->xajaxMethods['selecti2ccategory']->getScript().'" class="inputbox"','value','text',$selected);

		$objResponse->assign('container_I2CSection','innerHTML',$data);

		return $objResponse;
	}
	
	function selectI2CCategory($sourceId,$sectionId){
		$objResponse = new xajaxResponse();
		$database = &JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$source =& JTable::getInstance('rfprosource');
		$source->load($sourceId);
		$selected = $source->i2c_catid ? $source->i2c_catid : $config->i2c_default_catid;

		if(!$sectionId){
			$objResponse->clear('container_I2CCategory','innerHTML');
			return $objResponse;
		}

		$content_categories = array();
		$content_categories[] = JHTML::_('select.option',0,'Select category');
		$database->setQuery( 'SELECT `id` AS value,`title` AS text FROM `#__categories` WHERE `section`=\''.$database->getEscaped($sectionId).'\' ORDER BY `ordering`' );
		$content_categories = array_merge($content_categories,$database->loadObjectList());

		$data = JHTML::_('select.genericlist',$content_categories,'i2c_catid','class="inputbox"','value','text',$selected);

		$objResponse->assign('container_I2CCategory','innerHTML',$data);

		return $objResponse;
	}

	function adChangePublishedStatus($adId){
		$objResponse = new xajaxResponse();
		$database = &JFactory::getDBO();
		
		if(!$adId)
		{
			return;
		}
		
		$row =& JTable::getInstance('rfproad');
		$row->load($adId);
		$row->published = 1 - $row->published;
		$row->store();

		$publishedStatusSrc = ($row->published) ? 'images/publish_g.png' : 'images/publish_x.png';

		$objResponse->assign('imgPublishedStatus_'.$row->id,'src',$publishedStatusSrc);
		
		return $objResponse;
	}

	function addI2CRule($sourceId)
	{
		$objResponse = new xajaxResponse();

		$sourceRule =& JTable::getInstance('rfproi2crules');
		$sourceRule->sourceId = $sourceId;
		$sourceRule->store();

		$data = JHTML::_('editSourceFeed.divI2CRule',$sourceRule);
		$objResponse->append('i2cRulesContainer','innerHTML',$data);

		return $objResponse;
	}

	function removeRuleContainer($ruleId)
	{
		$objResponse = new xajaxResponse();

		$sourceRule =& JTable::getInstance('rfproi2crules');
		$sourceRule->delete($ruleId);

		$objResponse->remove('i2crule_'.$ruleId);

		return $objResponse;
	}

	function previewI2Crules($arr)
	{
		$objResponse = new xajaxResponse();

		$storyId = $arr['storyId'];
		$story =& JTable::getInstance('rfproitem');
		$story->load($storyId);

		$rules = $arr['rules'];

		$data = RFProAdminHelper::parseFullArticle($story,$rules,true);
		if(!strlen($data))
		{
			$objResponse->alert('Empty result! Please refine your rules!');
			return $objResponse;
		}
		$objResponse->assign('previewContent','innerHTML',$data);

		return $objResponse;
	}

	function getPageBreak($sourceId){
		$objResponse = new xajaxResponse();
		$db =& JFactory::getDBO();
		$db->setQuery("SELECT COUNT(1) FROM `#__rssfactory_i2c_sources_rules` WHERE `sourceId`='".$db->getEscaped($sourceId)."' AND `allowedTags`='pagebreak'");
		if($db->loadResult()){
			$objResponse->alert('You have already set a pagebreak!');
			return $objResponse;
		}
		
		$sourceRule =& JTable::getInstance('rfproi2crules');
		$sourceRule->sourceId = $sourceId;
		$sourceRule->allowedTags = 'pagebreak'; 
		$sourceRule->store();

		$data = JHTML::_('editSourceFeed.divI2Cpagebreak',$sourceRule);
		$objResponse->append('i2cRulesContainer','innerHTML',$data);

		return $objResponse;
	}
	
	function removepagebreak($sourceId){
		$objResponse = new xajaxResponse();

		$sourceRule =& JTable::getInstance('rfproi2crules');
		$sourceRule->delete($sourceId);

		$objResponse->remove('i2cpagebreak_'.$sourceId);

		return $objResponse;
	}
}
?>