<?php
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class RFPROAdminController extends JController
{
	function __construct()
	{
		//add path to tables classes
		JTable::addIncludePath( JPATH_COMPONENT_ADMINISTRATOR.DS.'tables' );

		//load the helpers; here, in admin, we need the front helper too; from now on, we can use any method defined in helpers
		require(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'admin.helper.php');
		require(JPATH_COMPONENT_SITE.DS.'helpers'.DS.'helper.php');

		//Add the helper path to the JHTML library
		JHTML::addIncludePath(RSS_FACTORY_COMPONENT_ADMIN_PATH.DS.'helpers'.DS.'html');

		//require the main view - the class in this file is the ancestor for all the other views
		require(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'view.php');

		parent::__construct();
	}

	function processXajaxRequest(){
		require(JPATH_COMPONENT_ADMINISTRATOR.DS.'admin.rssfactory_pro.xajax.php');
		$req = new JRfProAdminXajax();
		$xajax =& $req->getXajaxInstance();
		ob_end_clean();
		$xajax->processRequest();
		exit();
	}

	function categoryManager()
	{
		$model =& $this->getModel('categories');
		$view =& $this->getView('manageCategories');
		$view->setModel($model,true);
		$view->display();
	}

	function quickAddCat()
	{
		global $option;
		$mainframe =& JFactory::getApplication();

		JTheFactoryCategory::QuickAddCat();

		$this->setRedirect('index.php?option='.$option.'&task=categories',JText::_('Category added'));

		return true;
	}

	function orderCat( &$arr, $oparams=null)
	{
		global $option,$mainframe;
		$database = &JFactory::getDBO();

		$actual_order_id =JRequest::getVar('actual_order_id');
		$new_order_id = JRequest::getVar('new_order_id');
		if(!$actual_order_id || !$new_order_id){
			$mainframe->redirect( 'index2.php?option='.$option.'&task=catman', 'Ordering error!' );
		}

		$q="SELECT id,ordering FROM #__rssfactory_nestedcategories WHERE id IN ('".$actual_order_id."','".$new_order_id."')";
		$database->setQuery($q);
		$res = $database->loadObjectList('id');

		$q="UPDATE #__rssfactory_nestedcategories SET ordering='".$res[$new_order_id]->ordering."' WHERE id='".$actual_order_id."'";
		$database->setQuery($q);
		$database->query();

		$q="UPDATE #__rssfactory_nestedcategories SET ordering='".$res[$actual_order_id]->ordering."' WHERE id='".$new_order_id."'";
		$database->setQuery($q);
		$database->query();

		$mainframe->redirect( 'index2.php?option='.$option.'&task=catman' );
	}

	function addMultipleCategories()
	{	
		$model =& $this->getModel('categories');
		$view =& $this->getView('addMultipleCategories');
		$view->setModel($model);
		$view->display();
	}

	function reIndexCategoryOrdering()
	{
		$model =& $this->getModel('categories');
		$model->reIndexOrdering(0);
	}

	function saveMultipleCategories()
	{
		global $option;

		$model =& $this->getModel('categories');
		$nrInsertedCategories = $model->saveMultipleCategories();
		if( $nrInsertedCategories )
		{
			$msg = $nrInsertedCategories.' categories inserted successfully!';
			$this->setRedirect('index.php?option='.$option.'&task=catman',$msg);
		}
		else
		{
			$this->addMultipleCategories();
		}
	}

	function restoreBackup()
	{
		global $option;
		$model =& $this->getModel('backup');
		$msg = $model->restoreBackup() ? 'Restore complete!' : 'Problems during restore!!!';

		//if it's an old backup file, we pass the POST crafted by this model to the "settings" model, so teh "settings.php" can be saved properly
		if($model->oldBackup()){
			$modelSettings =& $this->getModel('settings');
			$modelSettings->saveSettings();
		}
		//else we just replace the "settings.php" fiel with the one from the zip backup
		else{
			$model->replaceSettingsFile();
		}

		$this->setRedirect('index.php?option='.$option.'&task=showconfig',$msg);		
	}

	function manageSources()
	{
		$modelSources =& $this->getModel( 'feedSources' );
		$modelCategories =& $this->getModel('categories');

		$view =& $this->getView('manageSourceFeeds');

		$view->setModel( $modelSources, true );
		$view->setModel( $modelCategories, true );

		$view->display();
	}

	function listsubmitedfeeds()
	{
		global $mainframe, $option;
		$database = &JFactory::getDBO();

		$model =& $this->getModel('submittedfeeds');
		$model->loadSubmittedFeeds();

		$view =& $this->getView('managesubmittedfeeds');
		$view->setModel($model);
		$view->display();		
	}

	function editRSS()
	{
		$modelCategories =& $this->getModel('categories');
		$modelSources =& $this->getModel('feedsources');

		$view =& $this->getView('editSourceFeed');
		$view->setModel($modelCategories);
		$view->setModel($modelSources);	
		$view->display();
	}

	function saveRSS()
	{
		global $option;

		$model =& $this->getModel('feedSources');
		if( $model->saveSourceFeed() )
		{
			$this->setRedirect('index.php?option='.$option.'&task=managerss','Source feed saved successfully!');
		}
		else
		{
			JRequest::setVar('task','editrss');
			$this->editRSS();
		}
	}

	function editcat()
	{
		global $option;

		//when trying to EDIT a category, check if the id was properly transmitted
		$id = JRequest::getVar('cid',0,'default','int');
		$task = JRequest::getVar('task');
		if(!$id && $task=='editcat')
		{
			$this->setRedirect('index.php?option='.$option.'&task=catman','<span style="color:#FF0000;">Edit category error!</span>');
		}

		//$model =& $this->getModel('categories');
		$view =& $this->getView('editCategory');
		//$view->setModel($model,true);
		$view->display();

		return;
	}

	function saveCategory()
	{
		global $option;

		$model =& $this->getModel('categories');
		if($model->saveCategory())
		{
			$this->setRedirect('index.php?option='.$option.'&task=catman','Category saved!');
		}
		else{
			JRequest::setVar('task','editcat');
			$this->editcat();
		}
	}
	
	function deleteCategories()
	{
		global $option;

		$model =& $this->getModel('categories');
		$model->deleteCategories();

		$this->setRedirect('index.php?option='.$option.'&task=catman');
	}

	function saveConfig()
	{
		global $option;

		$model =& $this->getModel('settings');
		$msg = $model->saveSettings() ? 'Config saved successfully' : 'Error while saving config!';

		$this->setRedirect( 'index.php?option='.$option.'&task=showconfig', $msg);
	}

	function showConfig(){
		$view =& $this->getView('manageConfiguration');
		$view->display();
	}
		
	function generateBackup()
	{
		$model =& $this->getModel('backup');
		$model->generateZIPBackup();
	}

	function saveCSV()
	{
		global $option,$mainframe;
		$database = &JFactory::getDBO();

	    $tmpfile=$_FILES['csvfile']['tmp_name'];
	    $csvsep=JRequest::getVar('csvseparator','TAB');

	    if ($csvsep=="TAB"){
			$csvsep="\t";
		}

	    $handle = fopen($tmpfile, "r");
	    $count=0;
	    while( $data = fgetcsv($handle, 10000, $csvsep) )
		{
	        $cat=$data[0];
	        $title=$data[1];
	        $url=$data[2];
	    	$row =& JTable::getInstance( 'rfprosource' );
	        $row->title=$title;
	        if(!ctype_digit($cat))
	        {
	        	$database->setQuery("SELECT `id` FROM `#__rssfactory_nestedcategories` WHERE `name`=`".$database->getEscaped($cat)."` LIMIT 1");
	        	if(!$row->cat = $database->loadResult())
	        	{
	        		$category =& JTable::getInstance('rfprocategory');
	        		$category->title = $cat;
	        		$category->store();
	        		$row->cat = $category->id;
	        	}
	        }
	        else
	        {
	        	$row->cat = $cat;
	        }
  
			$row->url=$url;
	        $row->published=1;
	        $row->ordering=$count;
	        if ($row->store())
	        {
	        	$count++;
	        }
	    }
	    fclose($handle);

		$this->setRedirect( 'index.php?option='.$option.'&task=managerss', $count. " feeds added" );
	}

	function showImportCSV(&$arr,$oparams=null) {
		global $mainframe;
		$database = &JFactory::getDBO();
		$option = JArrayHelper::getValue($arr,'option','');
		$this->html_admin->ShowImport($option);
	}

	function orderupsource()
	{
		global $mainframe;
		$database = &JFactory::getDBO();

		$cid = JRequest::getVar('cid',array());
		$id = $cid[0];
		if(!$id){
			$mainframe->redirect( 'index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=managerss', 'Ordering error!' );
		}

		$query = "select ordering from #__rssfactory where id ='".$database->getEscaped($id)."'";
		$database->setQuery( $query );
		$ord = $database->loadResult();

		$query = "update #__rssfactory set ordering = ordering + 1 where ordering = ".($ord-1);
		$database->setQuery( $query );
		$database->query();

		$query = "update #__rssfactory set ordering = ".($ord - 1)." where id=".$database->getEscaped($id);
		$database->setQuery( $query );
		$database->query();

		$mainframe->redirect( 'index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=managerss' );
	}

	function orderdownsource()
	{
		global $mainframe;
		$database = &JFactory::getDBO();

		$cid = JRequest::getVar('cid',array());
		$id = $cid[0];
		if(!$id){
			$mainframe->redirect( 'index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=managerss', 'Ordering error!' );
		}

		$query = "select ordering from #__rssfactory where id ='".$database->getEscaped($id)."'";
		$database->setQuery( $query );
		$ord = $database->loadResult();

		$query = "update #__rssfactory set ordering = ordering - 1 where ordering = ".($ord + 1);
		$database->setQuery( $query );
		$database->query();

		$query = "update #__rssfactory set ordering = ".($ord + 1)." where id=".$database->getEscaped($id);
		$database->setQuery( $query );
		$database->query();
		
		$mainframe->redirect( 'index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=managerss' );
	}

	function delRSS()
	{
		global $option;

		$model =& $this->getModel('feedSources');
		$model->deleteFeedSources();
		$this->setRedirect( 'index.php?option='.$option.'&task=managerss' );		
	}

	function publishFeedSources()
	{
		global $mainframe,$option;
		$database = &JFactory::getDBO();

		$cid = JRequest::getVar('cid',array(),'default','array');
		$newPublishedStatus = JRequest::getVar('changedPublishedStatus',null,'default','bool');

		$model =& $this->getModel('feedSources');
		$model->changePublishedStatus($cid,$newPublishedStatus);
		
		$msg = count($cid).' source feeds ';
		$msg .= $newPublishedStatus ? 'published' : 'unpublished';

		$this->setRedirect( 'index.php?option='.$option.'&task=managerss', $msg );
	}

	//--ads
	function saveAds()
	{
		global $option;

		$modelAds =& $this->getModel('ads');
		if($modelAds->saveAd())
		{
			$this->setRedirect('index.php?option='.$option.'&task=showads');
		}
		else
		{
			JRequest::setVar('task','editads');
			$this->editAds();
		}
	}

	function editAds()
	{
		$view =& $this->getView('editAd');
		$model =& $this->getModel('categories');
		$view->setModel($model);
		$view->display();
	}

	function delAds()
	{
		global $option;

		$model =& $this->getModel('ads');
		$model->deleteAds();
		$this->setRedirect( 'index.php?option='.$option.'&task=showads' );		
	}

	function showAds()
	{
		$view =& $this->getView('manageAds');
		$model =& $this->getModel('ads');
		$view->setModel($model,true);
		$model =& $this->getModel('categories');
		$view->setModel($model);
		$view->display();
	}

	function ShowAboutBox()
	{
		$view =& $this->getView('about');
		$view->display();
	}

	function mainMenu()
	{
		$view =& $this->getView('mainMenu');
		$view->display();
	}

	function displayBackupRestore()
	{
		$view =& $this->getView('manageBackupRestore');
		$view->display();
	}

	function allowedFeedsCategory()
	{
		$model =& $this->getModel('categories');
		$view =& $this->getView('iframeSelectCategory');
		$view->setModel($model);
		$view->display();
		return;
	}

	function allowSubmittedFeeds()
	{
		//vardump($_POST,1);
		$categoryId = JRequest::getVar('categoryId',0,'default','int');
		$ids = JRequest::getVar('cid',array(),'default','array');

		foreach($ids as $id)
		{
			$submittedFeed =& JTable::getInstance('rfprosubmitted');
			$submittedFeed->load($id);
			
			$newFeed =& JTable::getInstance('rfprosource');
			$newFeed->userid = $submittedFeed->userId;
			$newFeed->url = $submittedFeed->url;
			$newFeed->published = 1;
			$newFeed->date = $submittedFeed->date;
			$newFeed->cat = $categoryId;

			$newFeed->store();

			$submittedFeed->delete();
		}

		$this->setRedirect('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=listsubmitedfeeds','Feeds were added to the selected category!');
		return;
	}

	function disallowSubmittedFeeds()
	{
		$ids = JRequest::getVar('cid',array(),'default','array');
		foreach($ids as $id)
		{
			$submittedFeed =& JTable::getInstance('rfprosubmitted');
			$submittedFeed->delete($id);
		}

		$this->setRedirect('index.php?option=com_'.RSS_FACTORY_COMPONENT_NAME.'&task=listsubmitedfeeds','Submitted feed deleted!');
		return;
	}

	function categories(){
		$config = array();
		//$config['categoryId'] = JRequest::getVar('id',0,'default','int');
		$model =& $this->getModel('categories','',$config);
		$view =& $this->getView('manageCategories');
		$view->setModel($model,true);
		$view->display();
	}
}
?>