<?php
defined('_JEXEC') or die('Restricted access.');

class JHTMLEditSourceFeed{

	function selectI2CAuthor($source)
	{
		$config =& RFProHelper::getConfig();

		$authors = RFProHelper::getAllUsers();
		$selected = $source->i2c_author ? $source->i2c_author : $config->i2c_default_author;

		return JHTML::_('select.genericlist',$authors,'i2c_author','class="inputbox"','value','text',$selected);
	}

	function selectI2CSection($xMethod,$source)
	{
		$document =& JFactory::getDocument();
		$config =& RFProHelper::getConfig();

		$xMethod->setParameter(0,XAJAX_QUOTED_VALUE,$source->id);
		$js = 'window.addEvent(\'domready\', function(){ '.$xMethod->getScript().' });';
		$document->addScriptDeclaration($js);

		return;
	}

	function selectI2CCategory($xMethod,$source)
	{
		$document =& JFactory::getDocument();
		$config =& RFProHelper::getConfig();
		
		$sectionId = $source->i2c_sectionid ? $source->i2c_sectionid : $config->i2c_default_sectionid;

		$xMethod->setParameter(0,XAJAX_QUOTED_VALUE,$source->id);
		$xMethod->setParameter(1,XAJAX_QUOTED_VALUE,$sectionId);

		$js = 'window.addEvent(\'domready\', function(){ '.$xMethod->getScript().' });';
		$document->addScriptDeclaration($js);	

		return;
	}
	
	function radioPublishedState($source){
		$selected = $source->id ? $source->published : 1;
		return JHTML::_('select.booleanlist', 'published','class="inputbox"', $selected);
	}

	function selectOrdering($source){
		$database =& JFactory::getDBO();

		$query = 'SELECT `ordering` AS value, `title` AS text FROM `#__rssfactory` ORDER BY `ordering`';
		return JHTML::_('list.specificordering',$source,$source->id,$query,1);
	}
	
	function inputPublishingPeriod($source){
		$config =& RFProHelper::getConfig();

		$value = $source->i2c_publishing_period ? $source->i2c_publishing_period : $config->i2c_default_publishing_period;
		return '<input type="text" name="i2c_publishing_period" value="'.$value.'" /> '.RFPRO_WORD4DAYS;
	}
	
	function linkRefreshIcon($xMethod,$source){
		$xMethod->setParameter(0,XAJAX_QUOTED_VALUE,$source->id);

		return '<a href="#" onclick="'.$xMethod->getScript().'; return false;">Refresh from site\'s "favicon"</a>';
	}

	function buttonAddI2CRule($sourceId)
	{
		$xMethods =& RFProAdminHelper::getXajaxMethods();

		$text = '<img src="images/new_f2.png" alt="New rule"/>';
		$url = '#';
		$xMethods['addi2crule']->setParameter(0,XAJAX_QUOTED_VALUE,$sourceId);
		$attribs = 'onclick="'.$xMethods['addi2crule']->getScript().'" title="New rule"';

		return JHTML::link($url,$text,$attribs);
	}

	function buttonAddPageBreak($sourceId){
		$xMethods =& RFProAdminHelper::getXajaxMethods();

		$text = '<img src="'.JURI::base().'components/com_rssfactory_pro/images/pagebreak.gif" alt="Page break"/>';
		$url = '#';
		$xMethods['getpagebreak']->setParameter(0,XAJAX_QUOTED_VALUE,$sourceId);
		$attribs = 'onclick="'.$xMethods['getpagebreak']->getScript().'" title="Page break"';

		return JHTML::link($url,$text,$attribs);
	}

	function buttonPreviewI2CRules()
	{
		$xMethods =& RFProAdminHelper::getXajaxMethods();

		$text = '<img src="images/mark_f2.png" alt="Preview rules"/>';
		$url = '#';

		$xMethods['previewi2crules']->setParameter(0,XAJAX_JS_VALUE,'getPreviewI2C()');
		$attribs = 'onclick="if(getPreviewI2C()){'.$xMethods['previewi2crules']->getScript().'; showPreviewArticle();}" title="Preview"';

		return JHTML::link($url,$text,$attribs);
	}

	function divI2CRule($sourceRule)
	{
		$xajaxMethods =& RFProAdminHelper::getXajaxMethods();

		ob_start();
	?>
		<div id="i2crule_<?php echo $sourceRule->id; ?>" style="width:100%; vertical-align: middle;">
			<div style="float:left; width:30%;">
				<span style="vertical-align: middle;">Start from: </span>
				<textarea style="vertical-align: middle;" id="ruleStart_<?php echo $sourceRule->id; ?>" name="ruleStart_<?php echo $sourceRule->id; ?>" rows="4" cols="30"><?php echo $sourceRule->ruleStart; ?></textarea>
			</div>
			<div style="float:left;width:5px;">&nbsp;</div>
			<div style="float:left; width:30%;">
				<span style="vertical-align: middle;">End at: </span>
				<textarea style="vertical-align: middle;" id="ruleEnd_<?php echo $sourceRule->id; ?>" name="ruleEnd_<?php echo $sourceRule->id; ?>" rows="4" cols="30"><?php echo $sourceRule->ruleEnd; ?></textarea>
			</div>
			<div style="float:left;width:5px;">&nbsp;</div>
			<div style="float:left; width:15%;">
				<div>
					<span>Strip HTML: </span>
					<?php echo JHTML::_('editSourceFeed.checkbox','stripHTML_'.$sourceRule->id,$sourceRule->stripHTML,'onchange="document.getElementById(\'container_allowedTags_'.$sourceRule->id.'\').style.display = (this.checked) ? \'block\' : \'none\';";'); ?>
				</div>
				<div id="container_allowedTags_<?php echo $sourceRule->id; ?>">
					<span style="vertical-align: middle;">Allowed tags: </span>
					<input type="text" id="allowedTags_<?php echo $sourceRule->id; ?>" name="allowedTags_<?php echo $sourceRule->id; ?>" style="vertical-align: middle;" value="<?php echo $sourceRule->allowedTags; ?>" />
				</div>
			</div>
			<div style="float:left;width:5px;">&nbsp;</div>
			<div style="float:left; width:5%;">
				<span style="vertical-align: middle;">Append this to article: </span>
				<?php echo JHTML::_('editSourceFeed.checkbox','include_'.$sourceRule->id,$sourceRule->include ); ?>
			</div>
			<div style="float:left;width:25px;">&nbsp;</div>
			<div style="float:left;">
				<?php $xajaxMethods['removerulecontainer']->setParameter(0,XAJAX_QUOTED_VALUE,$sourceRule->id); ?>
				<span onclick="<?php $xajaxMethods['removerulecontainer']->printScript(); ?>" style="cursor:pointer;">
					<div><img src="images/delete_f2.png" /></div>
					<div>Remove rule</div>
				</span>
			</div>
			<div style="clear:both;"><br /></div>
		</div>
	<?php
		return ob_get_clean();
	}

	function divI2Cpagebreak($sourceRule){
		$xajaxMethods	 =& RFProAdminHelper::getXajaxMethods();

		ob_start();
	?>
		<div id="i2cpagebreak_<?php echo $sourceRule->id; ?>" style="width:100%; vertical-align: middle; height: 50px; background-color: #ccc;">
			<div style="float: left; width: 100%; border: dotted red 1px;">
				<div style="float:left;">&nbsp;</div>
				<div style="float:left;width:5px;">&nbsp;</div>
				<div style="float:right;">
					<?php $xajaxMethods['removepagebreak']->setParameter(0,XAJAX_QUOTED_VALUE,$sourceRule->id); ?>
					<span onclick="<?php $xajaxMethods['removepagebreak']->printScript(); ?>" style="cursor:pointer;">
						<div><img src="images/delete_f2.png" /></div>
						<div>Remove pagebreak</div>
					</span>
				</div>
			</div>
		</div>
	<?php
		return ob_get_clean();
	}

	function checkbox($name,$checked,$attribs='',$value='1')
	{
		$c = $checked ? ' checked="" ' : '';
		return '<input type="checkbox" id="'.$name.'" name="'.$name.'" '.$c.' '.$attribs.' value="'.$value.'" />';
	}

	function lastStories($lastStories)
	{
		$radioLastStories = '';
		foreach($lastStories as $story)
		{
			$s = '<input type="radio" name="previewStory" value="'.$story->id.'" />';

			$url = '#';
			$text = '<i>'.$story->item_title.'</i>';
			$s .= JHTML::link($url,$text,'onclick="window.open (\''.$story->item_link.'\' , \'previewArticle\', \'menubar=1, resizable=1, width=550, height=400, scrollbars=1\');"');

			$s .='<br />';

			$radioLastStories .= $s;
		}		

		return $radioLastStories;
	}
}
?>