<?php
defined('_JEXEC') or die('Restricted access.');

class JHTMLManageSources{
	
	function filterPublished($name='published_state'){
		global $mainframe;
	    $options = array();
		$options[] = JHTML::_('Select.option', '0', JText::_('SELECT STATE') );
		$options[] = JHTML::_('Select.option', '1', JText::_('PUBLISHED') );
		$options[] = JHTML::_('Select.option', '-1', JText::_('UNPUBLISHED') );
		return JHTML::_( 'select.genericlist', $options, $name, 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $mainframe->getUserState('feedSources.'.$name) );
	}
	
	function filterCategory($aCategories,$name='catid'){
		global $mainframe;

		$defaultOption = new stdClass;
		$defaultOption->id = '';
		$defaultOption->name = JText::_('SELECT CATEGORY');
		$defaultOption->depth = 0;

		array_unshift($aCategories,$defaultOption);

		return JHTML::_('editcategory.selectCategory', $aCategories, $name, $mainframe->getUserState('feedSources.'.$name), 'class="inputbox" size="1" onchange="document.adminForm.submit( );"' );
	}
	
	function filterSearch($name='search'){
		global $mainframe;
		return '<input type="text" name="'.$name.'" value="'.$mainframe->getUserState('feedSources.'.$name).'" class="text_area" onchange="document.adminForm.submit();" />';
	}
	
	function createSiteIco($sourceId){
		global $mainframe;
	
		//refresh the admin ico only in backend
		if (! file_exists(RSS_FACTORY_COMPONENT_PATH.DS.'images'.DS.'ico_'.md5($sourceId).'.png') && $mainframe->isAdmin() ){
			$source =& JTable::getInstance('rfprosource');
			$source->load($sourceId);
			RFProAdminHelper::getSiteIcon($source->id,$source->url);
		}
		if (file_exists(RSS_FACTORY_COMPONENT_PATH.DS.'images'.DS.'ico_'.md5($sourceId).'.png')){
			$img_src= RSS_FACTORY_COMPONENT_URI.'images/ico_'.md5($sourceId).'.png';
		}
		else{
			$img_src= RSS_FACTORY_COMPONENT_URI.'images/default.png';
		}
		if($mainframe->isAdmin()){
			$img = '<img class="siteicon" src="'.$img_src.'" border="0" alt="" id="feedicon_'.$sourceId.'" />';
		}
		else{
			$img = '<img class="siteicon" src="'.$img_src.'" border="0" alt="" />';
		}
		
		return $img;
	}
	
	function filterReset($name='resetFilters'){
		global $mainframe;
		return '<input type="button" value="Reset filters" class="text_area" onclick="document.adminForm.'.$name.'.value=1;document.adminForm.submit();" />';
	}
	
	function linkChangePublishedStatus($row,$entryType)
	{
		$xMethods = RFProAdminHelper::getXajaxMethods();
		
		switch($entryType)
		{
			case 'feedsource':
				$xMethod = $xMethods['feedsourcechangepublishedstatus'];
			break;
			case 'ad':
				$xMethod = $xMethods['adchangepublishedstatus'];
			break;
			default:
				return false;
			break;
		}

		
		$xMethod->setParameter(0,XAJAX_QUOTED_VALUE,$row->id);
		$publishedStatusSrc = ($row->published) ? 'images/publish_g.png' : 'images/publish_x.png';
				
		$html = 
		'<a href="#" onclick="'.$xMethod->getScript().'; return false;">'.
			'<img id="imgPublishedStatus_'.$row->id.'" src="'.$publishedStatusSrc.'" border="0" alt="" />'.
		'</a>';
		
		return $html;
	}

	function refreshError($row)
	{
		return ($row->rsserror) ? 
	            "<img src='".JURI::root()."/includes/js/ThemeOffice/warning.png' border=0 onMouseOver=\"return overlib('There was a timeout, or the resource is no longer available.', CAPTION, 'Last refresh caused error', BELOW, RIGHT);\" onMouseOut='return nd();'>" : '-';
	}

	function refreshAllSourcesIcon()
	{
		$xMethods = RFProAdminHelper::getXajaxMethods();

		$html = '<span class="refresh_all">'. RFPRO_WORD4REFRESHALLLINKS .' - <img name="image1" style="vertical-align:top;" src="'.RSS_FACTORY_COMPONENT_URI.'/images/refresh.jpg" border="0"
			onmouseout="this.src=\''. RSS_FACTORY_COMPONENT_URI.'images/refresh.jpg\'"
		 	onmouseover="this.src=\''. RSS_FACTORY_COMPONENT_URI.'images/refresh2.jpg\'"
			onclick="ShowProgress();'. $xMethods['refreshallfeedsources']->getScript().'" alt="" />';
		return $html;
	}

	function refreshSourceIcon($row)
	{
		$xMethods = RFProAdminHelper::getXajaxMethods();

		$xMethods['refreshfeedsource']->setParameter(0,XAJAX_QUOTED_VALUE,$row->id);
		
		$html = '<span id="nrStories_'. $row->id .'">';
		$html .= ($row->nrfeeds ? $row->nrStoriesInCache : 'All ('.$row->nrStoriesInCache.')');
		$html .= '</span>&nbsp;';
		$html .= '<img src="'. RSS_FACTORY_COMPONENT_URI.'images/refresh.jpg' . '" border="0" 
						onmouseout="this.src=\''. RSS_FACTORY_COMPONENT_URI.'images/refresh.jpg\'"
						onmouseover="this.src=\''. RSS_FACTORY_COMPONENT_URI. 'images/refresh2.jpg\'"
						onclick="ShowProgress();'. $xMethods['refreshfeedsource']->getScript().'" alt="" />';
		return $html;
	}

	function stringCategoryName($row)
	{
		if($row->cat_title == 'RFPRO_WORD4ROOT'){
			return RFPRO_WORD4ROOT;
		}
		return RFProHelper::rssfactory_pro_html_entity_decode($row->cat_title);
	}
}
?>