DROP TABLE IF EXISTS `#__rssfactory`;
DROP TABLE IF EXISTS `#__rssfactory_ads`;
DROP TABLE IF EXISTS `#__rssfactory_ad_category_map`;
DROP TABLE IF EXISTS `#__rssfactory_cache`;
DROP TABLE IF EXISTS `#__rssfactory_nestedcategories`;
DROP TABLE IF EXISTS `#__rssfactory_related_categories_map`;
DROP TABLE IF EXISTS `#__rssfactory_user`;
DROP TABLE IF EXISTS `#__rssfactory_voting`;
DROP TABLE IF EXISTS `#__rssfactory_i2c_sources_rules`;
DROP TABLE IF EXISTS `#__rssfactory_submitted`;

CREATE TABLE `#__rssfactory` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL,
  `url` text NOT NULL,
  `title` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `nrfeeds` tinyint(1) NOT NULL DEFAULT '0',
  `cat` varchar(250) NOT NULL DEFAULT '',
  `date` datetime DEFAULT NULL,
  `rsserror` int(1) DEFAULT '0',
  `encoding` varchar(30) DEFAULT NULL,
  `i2c_enabled` int(1) NOT NULL DEFAULT '1',
  `i2c_author` int(11) NOT NULL DEFAULT '0',
  `i2c_publishing_period` int(11) NOT NULL DEFAULT '0',
  `i2c_sectionid` int(11) NOT NULL DEFAULT '0',
  `i2c_catid` int(11) NOT NULL DEFAULT '0',
  `i2c_frontpage` tinyint(4) NOT NULL DEFAULT '0',
  `i2c_published` int(1) NOT NULL DEFAULT '1',
  `i2c_prepend` text NOT NULL,
  `i2c_append` text NOT NULL,
  `i2c_full_article` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `cat` (`cat`),
  KEY `userid` (`userid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `#__rssfactory` (`id`, `userid`, `url`, `title`, `ordering`, `published`, `nrfeeds`, `cat`, `date`, `rsserror`, `encoding`, `i2c_enabled`, `i2c_author`, `i2c_publishing_period`, `i2c_sectionid`, `i2c_catid`, `i2c_frontpage`, `i2c_published`, `i2c_prepend`, `i2c_append`) VALUES 
(1, 0, 'http://www.thefactory.ro/index.php?option=com_rss&amp;feed=ATOM0.3&amp;type=com_frontpage', 'The Factory', 1, 1, 15, '1', '2009-07-20 11:13:09', 0, 'UTF-8', 0, 62, 0, 0, 0, 0, 1, '', ''),
(2, 0, 'http://feeds2.feedburner.com/Techcrunch', 'TechCrunch', 2, 1, 15, '1', '2009-07-20 11:13:09', 0, 'UTF-8', 0, 62, 0, 0, 0, 0, 1, '', ''),
(3,0,'http://feeds.nytimes.com/nyt/rss/US','NY Times US',3,1,0,1,'2009-07-20 11:13:09',0,'UTF-8',0,62,5,0,0,0,1,'','');

CREATE TABLE `#__rssfactory_ads` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(250) default NULL,
  `adtext` text,
  `published` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
INSERT INTO `#__rssfactory_ads` VALUES (1,'Here comes an AD!','<div><a href=\'http://www.thefactory.ro/\'>The Factory - Joomla Components and Custom Joomla Work</a></div>',1);

CREATE TABLE `#__rssfactory_cache` (
  `id` bigint(20) NOT NULL auto_increment,
  `rssid` int(11) default NULL,
  `rssurl` text,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `channel_title` text,
  `channel_link` text,
  `channel_description` text,
  `channel_category` text,
  `item_title` text,
  `item_description` text,
  `item_link` text,
  `item_source` text,
  `item_date` datetime default NULL,
  `item_enclosure` text,
  `item_hash` varchar(40) NOT NULL default '',
  `archived` tinyint(1) NOT NULL default '0',
  `hits` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `rssid` (`rssid`),
  KEY `item_hash` (`item_hash`),
  KEY `archived` (`archived`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE `#__rssfactory_ad_category_map` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `adId` int(11) NOT NULL,
  `categoryId` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `categoryId` (`categoryId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE `#__rssfactory_nestedcategories` (
    `id` INT(11) NOT NULL AUTO_INCREMENT,
    `parentId` INT(11) NOT NULL,
    `name` VARCHAR(255) NOT NULL,
    `description` TEXT NOT NULL,
    `lft` INT(11) NOT NULL,
    `rgt` INT(11) NOT NULL,
    `published` TINYINT(1) NOT NULL DEFAULT '1',
    PRIMARY KEY (`id`),
    INDEX `parentId` (`parentId`),
    INDEX `lft` (`lft`),
    INDEX `rgt` (`rgt`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
INSERT INTO `#__rssfactory_nestedcategories` VALUES ('1',0,'ROOT','',1,6,1);
INSERT INTO `#__rssfactory_nestedcategories` VALUES ('2',0,'&quot;The Factory&quot; News','News about Joomla from &quot;The Factory&quot;',2,5,1);
INSERT INTO `#__rssfactory_nestedcategories` VALUES ('3',0,'Tech','Tech related...',3,4,1);

CREATE TABLE `#__rssfactory_related_categories_map` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `categoryId` int(11) NOT NULL,
  `relatedId` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `categoryId_2` (`categoryId`,`relatedId`),
  KEY `categoryId` (`categoryId`,`relatedId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__rssfactory_submitted` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url` text NOT NULL,
  `userid` int(11) NOT NULL,
  `comment` text NOT NULL,
  `date` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `#__rssfactory_user` (
  `id` int(11) NOT NULL auto_increment,
  `sid` varchar(250) NOT NULL default '',
  `url` varchar(250) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `newsid` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `sid` (`sid`),
  KEY `newsid` (`newsid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE `#__rssfactory_voting` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cacheId` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL,
  `voteValue` int(1) NOT NULL default '0',
  `voteHash` varchar(40) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `cacheId` (`cacheId`),
  KEY `userid` (`userid`),
  KEY `voteHash` (`voteHash`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE `#__rssfactory_i2c_sources_rules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sourceId` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  `ruleStart` text NOT NULL,
  `ruleEnd` text NOT NULL,
  `include` tinyint(1) NOT NULL DEFAULT '1',
  `stripHTML` tinyint(1) NOT NULL,
  `allowedTags` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `sourceId` (`sourceId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `#__rssfactory_i2c_sources_rules` (`id`, `sourceId`, `ordering`, `ruleStart`, `ruleEnd`, `include`, `stripHTML`, `allowedTags`) VALUES (1, 3, 1, '<nyt_text >', '</nyt_text>', 1, 0, '');