<?php
defined('_JEXEC') or die( 'Restricted access' );

class RFPROAdminModelBackup extends JModel
{
	function generateZIPBackup()
	{
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.archive');

		$zip =& JArchive::getAdapter('zip');

		//first file to backup: settings.php
		$fileSettings = RSS_FACTORY_COMPONENT_ADMIN_PATH.DS.'config'.DS.'settings.php';
		$aFiles[] = array('name'=>'settings.php','data'=>file_get_contents($fileSettings));

		//second file for backup: the sql queries
		$aFiles[] = array('name'=>'RSSFactoryPRO.sql','data'=>$this->getBackupSQL() );

		//the second parameter for this function is very odd
		//as you can see above, each "file" entity needs to be an array with 2 keys: 'name' and 'data'
		$backupName = 'RSSFactoryPro_Backup_'.date('Y-m-d').'.zip';
		$backupFile = RSS_FACTORY_TMP_PATH.DS.$backupName;
		$zip->create( $backupFile, $aFiles );

		$backupSize = filesize($backupFile);

		header("Pragma: public");
		header("Expires: 0");
//	    //HTTP/1.1
	    header("Cache-Control: must-revalidate,post-check=0,pre-check=0");
//	    //HTTP/1.0
	    header("Content-Type: application/x-compressed");
		header('Content-Disposition: attachment; filename="'.$backupName.'"');
	    header("Content-Length: ".$backupSize);
	    header("Content-size: ".$backupSize);
	    header('Content-Transfer-Encoding: binary');

		readfile($backupFile);
		unlink($backupFile);
		exit();
	}

	function getBackupSQL()
	{
		$data = '';
		$data .= $this->generateTableBackup('#__rssfactory_nestedcategories');
		$data .= $this->generateTableBackup('#__rssfactory_related_categories_map');
		$data .= $this->generateTableBackup('#__rssfactory');
		$data .= $this->generateTableBackup('#__rssfactory_ads');
		$data .= $this->generateTableBackup('#__rssfactory_ad_category_map');

		//add the component version
		$data .="/*version=".RSS_FACTORY_COMPONENT_VERSION."*/";

	    return $data;
	}

	function generateTableBackup($tableName)
	{
		$database =& JFactory::getdBO();
		$res = $database->getTableFields($tableName);
		$fs = array_keys($res[$tableName]);
		$fields = '`'.implode('`,`',$fs).'`';

		$database->setQuery('SELECT * FROM `'.$tableName.'`');
		$rows = $database->loadAssocList();

		$query = '';
		foreach($rows as $row)
		{
			//escape those values; php4 compatible
			foreach($row as $k=>$v)
			{
				$row[$k] = $database->getEscaped($v);
			}
			$values = '';
			$values .= "'".implode("','",$row)."'";
			$query .= 'INSERT INTO `'.$tableName.'` ('.$fields.') VALUES ('.$values.')'.PHP_EOL;
		}

		return $query;
	}
	
	function restoreBackup()
	{
		global $option,$mainframe;

	    $database = &JFactory::getDBO();

        $database->setQuery("TRUNCATE TABLE `#__rssfactory_nestedcategories`");
        $database->query();
		$database->setQuery("TRUNCATE TABLE `#__rssfactory`");
        $database->query();
        $database->setQuery("TRUNCATE TABLE `#__rssfactory_ads`");
        $database->query();
	    $database->setQuery("TRUNCATE TABLE `#__rssfactory_voting`");
	    $database->query();
		$database->setQuery("TRUNCATE TABLE `#__rssfactory_cache`");
	    $database->query();
	    $database->setQuery("TRUNCATE TABLE `#__rssfactory_ad_category_map`");
	    $database->query();
	    $database->setQuery("TRUNCATE TABLE `#__rssfactory_related_categories_map`");
	    $database->query();
	    
	    $tmp_file = $_FILES['backupfile']['tmp_name'];
		if($this->oldBackup())
	    {
	    	$restoreSQL = file($tmp_file);
	    }
	    else
	    {
	    	jimport('joomla.filesystem.archive');
			$zip =& JArchive::getAdapter('zip');
			$zip->extract($tmp_file,RSS_FACTORY_TMP_PATH);
			$restoreSQL = file(RSS_FACTORY_TMP_PATH.DS.'RSSFactoryPRO.sql',FILE_IGNORE_NEW_LINES);
	    }

	    if(!$this->executeSQL($restoreSQL))
	    {
	    	return false;
	    }
	    $this->removeTmpBackupFiles();
		
		return true;
	}

	function oldBackup()
	{
		static $oldBackup=null;
		if(null === $oldBackup){
			jimport('joomla.filesystem.file');
			$fileName = $_FILES['backupfile']['name'];
			$extension = JFile::getExt($fileName);

			$oldBackup = ('sql'==$extension) ? true : false;
		}

		return $oldBackup;
	}

	function executeSQL($aSQLStatements)
	{
		$database =& JFactory::getDBO();

		$nrsources = $nrcats = $nrads = $qCount= 0;
		foreach($aSQLStatements as $line){
			
			//restore #__rssfactory table
			if(preg_match('/INSERT INTO `?#__rssfactory`? /',$line)){
				if(!$this->oldBackup())
				{
					$database->setQuery($line);
					if(!$database->query())
					{
						JError::raiseWarning(1,'Error while restoring feed sources!');
					}
					$nrsources++;
					$qCount++;
				}
				else
				{
					//before v1.5.0, the insert queries were generated without the fields; this leads to some problems, depending on what fields have been added later
					preg_match('#INSERT INTO \#__rssfactory VALUES \((.*?)\)#',$line,$match);
					$oVs = $match[1];

					//what i'm going to do here is shitty, but it needs to be done because of an incompatibility with the 1.5.0 table format (my mistake, of course)
					$aOldValues = explode("','",trim($oVs,"'"));

					if(count($aOldValues)==16)
					{
						//hack: replace temprss field(removed in 1.5.0 version) with an already empty field ('i2c_prepend' for example)
						$aOldFields = array('`id`','`url`','`title`','`ordering`','`published`','`nrfeeds`','`cat`','`i2c_prepend`',  /* '`temprss`',*/ '`date`','`rsserror`','`encoding`','`i2c_author`','`i2c_publishing_period`','`i2c_sectionid`','`i2c_catid`','`i2c_frontpage`');
					}
					else if(count($aOldValues)==21)
					{
						array_pop($aOldValues);
						$aOldFields = array('`id`','`userid`','`url`','`title`','`ordering`','`published`','`nrfeeds`','`cat`', '`date`','`rsserror`','`encoding`','`i2c_enabled`','`i2c_author`','`i2c_publishing_period`','`i2c_sectionid`','`i2c_catid`','`i2c_frontpage`','i2c_published','i2c_prepend','i2c_append');	
					}

					$query = "INSERT INTO `#__rssfactory` (".implode(',',$aOldFields).") VALUES ('".implode("','",$aOldValues)."')";
					$database->setQuery($query);
					//vardump($database->_sql,1);
					if(!$database->query())
					{
						JError::raiseWarning(1,'Error while restoring feed sources!');
					}
					$nrsources++;
					$qCount++;
				}
			}
			//restore #__rssfactory_categories table
			elseif(preg_match('/INSERT INTO `?#__rssfactory_nestedcategories`?/',$line)){
				$database->setQuery($line);
				if(!$database->query())
				{
					JError::raiseWarning(1,'Error while restoring ads!');
				}
				$nrcats++;
				$qCount++;
			}
			elseif( preg_match('/INSERT INTO `?#__rssfactory_categories`? \((.*?)\)\s*VALUES\s*\((.*?)\)/',$line) ){
				if(!$this->oldBackup())
				{
					static $convertedCategories = false;
					if($convertedCategories){
						continue;
					}

					$nrRestoredCategories = $this->convertCategories($aSQLStatements);
					$convertedCategories = true;

					$nrcats += $nrRestoredCategories;
					$qCount += $nrRestoredCategories;
				}
				else
				{
					preg_match('#INSERT INTO \#__rssfactory_categories VALUES \(\'(.*?)\'\)#',$line,$match);
					$oldValues = $match[1];
					$aOldValues = explode("','",$oldValues);
					$categoryId = $aOldValues[0];
					//remove the last two values: relatedcats and hash, which are managed differently now
					array_pop($aOldValues);
					//we need to insert the related cats in their table
					$relatedcats = array_pop($aOldValues);
					$aRelatedCategories = explode(',',$relatedcats);

					$newValues = "'".implode("','",$aOldValues)."'";
					$newQuery = 'INSERT INTO `#__rssfactory_categories` VALUES ('.$newValues.')';
					$database->setQuery($newQuery);
					if(!$database->query())
					{
						JError::raiseWarning(1,'Error while restoring categories!');
					}
					$nrcats++;
					$qCount++;
					if(count($aRelatedCategories))
					{
						$pairs = array();
						foreach($aRelatedCategories as $relatedId){
							$pairs[] = "('".$categoryId."','".$relatedId."')";
						}
						$relatedCategoriesQuery = 'INSERT INTO `#__rssfactory_related_categories_map` (`categoryId`,`relatedId`) VALUES '.implode(',',$pairs);
						$database->setQuery($relatedCategoriesQuery);
						$qCount++;
					}					
				}
			}
			//restore #__rssfactory_ads table
			elseif(preg_match('/INSERT INTO `?#__rssfactory_ads`? /',$line))
			{
				//ads kept the same table structure, excepting for the filed ""Adtext", which became "adtext", so the old queries SHOULD work
				$database->setQuery($line);
				if(!$database->query())
				{
					JError::raiseWarning(1,'Error while restoring ads!');
				}
				$nrads++;
				$qCount++;
			}
			//restore #__rssfactory_ad_category_map table
			elseif(preg_match('/INSERT INTO `?#__rssfactory_ad_category_map`? /',$line))
			{
				$database->setQuery($line);
				if(!$database->query())
				{
					JError::raiseWarning(1,'Error while restoring ad-category map!');
				}
				$qCount++;
			}
			//restore #__rssfactory_related_categories_map table
			elseif(preg_match('/INSERT INTO `?#__rssfactory_related_categories_map`? /',$line))
			{
				$database->setQuery($line);
				if(!$database->query())
				{
					JError::raiseWarning(1,'Error while restoring related categories map!');
				}
				$qCount++;
			}	
			elseif(preg_match('/INSERT INTO `?#__rssfactory_config`? /',$line))
			{
				//THIS QUERY CAN EXIST ONLY IN OLD BACKUP FILES, SO WE HAVE TO TREAT IT IN A SPECIAL WAY, BECAUSE NOW THE SETTINGS ARE STORED IN A FILE
				preg_match('#INSERT INTO \#__rssfactory_config VALUES \(\'(.*?)\'\)#',$line,$match);
				$aConfigValues = explode("','",$match[1]);
				$this->composeSettingsRequest($aConfigValues);
			}
		}
		JError::raiseNotice(1,$nrsources.' feed sources restored ');
		JError::raiseNotice(1,$nrcats++.' categories restored');
		JError::raiseNotice(1,$nrads++.' ads restored');
		JError::raiseNotice(1,$qCount++.' SQL queries runned');

		return true;
	}

	function convertCategories($aSqlStatements){
		$database =& JFactory::getDBO();
		
		$queriesTicker = 0;
		$oldSqlCategories = array();
		foreach($aSqlStatements as $sql){
			if(preg_match('#INSERT INTO `\#__rssfactory_categories`.*#iu',$sql,$m))
			$oldSqlCategories[] = $m[0];
		}
		natcasesort($oldSqlCategories);

		$oldValues = array();
		foreach($oldSqlCategories as $sql){
			preg_match('/INSERT INTO `?#__rssfactory_categories`? \((.*?)\)\s*VALUES\s*\((.*?)\)/',$sql,$m16);
			//$fields = $m16[1];$fields = explode('`,`',trim($fields,'`'));
			$oldValues[] = explode(',',$m16[2]);
		}

		$parentsTable = array();
		$category =& JTable::getInstance('rfpronestedset');
		$rN = $category->getRootNode();
		$parentsTable[0] = $rN->id;

		foreach($oldValues as $oldValue){
			foreach($oldValue as &$v){
				$v = trim($v,'\'');
			}
			$category->id = null;
			$oldValue[1] = stripslashes($oldValue[1]);
			$oldValue[4] = stripslashes($oldValue[4]);

			if(isset( $parentsTable[$oldValue[2]] )) {
				$category->insertChildNode( $oldValue[1], $parentsTable[$oldValue[2]] );								
			}
			else{
				$category->insertChildNode( $oldValue[1], $parentsTable[0] );
			}
			$category->id = $database->insertid();
			$parentsTable[$oldValue[0]] = $category->id;

			$category->description = $oldValue[4];
			$category->store();

			$queriesTicker += 2;
		}
		return $queriesTicker;
	}

	//in the next function we craft a special request form the old config values, so that later we will save this request through the "settings" model
	function composeSettingsRequest($aConfigValues)
	{
		//remove the first element from array (it's the id from the old table)
		array_shift($aConfigValues);
		//get the last element from array (the "params" field)
		$params = array_pop($aConfigValues);

		$settings = '';
		$aConfigNames = array('nrads','description','refresh_password','showSearch','unpublisherr','showcategory','liststyle','limitrss','showfeeddescription','refreshinterval','lastcron','use_pseudocron','use_favicons','date_format','hideDate','hideBullet','table_view_open','cat_previewnr','force_charset');
		$i=0;
		foreach($aConfigNames as $configName)
		{
			JRequest::setVar($configName,$aConfigValues[$i]);
			$i++;
		}
		//now let's take care of the "params" field
		$aParams = explode('\n',$params);
		foreach($aParams as $param){
			$param = trim($param,'\r');
			list($paramName,$paramValue) = explode('=',$param);
			JRequest::setVar($paramName,$paramValue);
		}
	}

	function replaceSettingsFile()
	{
		$backupSettingsFile = RSS_FACTORY_TMP_PATH.DS.'settings.php';
		$data = file_get_contents($backupSettingsFile);
		$actualSettingsFile = RSS_FACTORY_COMPONENT_ADMIN_PATH.DS.'config'.DS.'settings.php';
		if(file_put_contents($actualSettingsFile,$data))
		{
			return true;
		}

		return false;
	}

	function removeTmpBackupFiles()
	{
		if ($handle = opendir(RSS_FACTORY_TMP_PATH)) {
    		/* This is the correct way to loop over the directory. */
    		while ( false !== ( $file = readdir($handle) ) ) {
    			if (!preg_match('#\.htaccess$#',$file)){
    			    unlink($file);
    			}
    		}
    		closedir($handle);
    	}
	}
}
?>