<?php
defined('_JEXEC') or die( 'Restricted access' );

class RFPROAdminModelFeedSources extends JModel{
	
	var $db = null;
	var $_sqlWhere = ' WHERE 1=1  AND (NOT cache.archived OR cache.archived IS NULL) ';
	var $_pagination = null;

	function RFPROAdminModelFeedSources(){
		$this->db = & JFactory::getDBO();
		parent::__construct();
	}

	function setFilters()
	{
		global $mainframe;

		if(JRequest::getVar('resetFilters')){
			$mainframe->setUserState('feedSources.search',null);
			$mainframe->setUserState('feedSources.catid',null);
			$mainframe->setUserState('feedSources.published_state',null);
		}
		else{
			$search = $mainframe->getUserStateFromRequest('feedSources.search','search',null,'string');
			if($search){
				$this->_sqlWhere .= " AND `r`.`title` LIKE '%".$this->db->getEscaped($search)."%' ";
			}
	
			$catid = $mainframe->getUserStateFromRequest('feedSources.catid','catid',null,'int');
			if($catid){
				$this->_sqlWhere .= " AND `r`.`cat`='".$this->db->getEscaped($catid)."' ";
			}
	
			$published_state = $mainframe->getUserStateFromRequest('feedSources.published_state','published_state',null,'int');
			if($published_state){
				$ps = $published_state>0 ? '1' : '0'; 
				$this->_sqlWhere .= " AND `r`.`published`='".$ps."' ";
			}
		}

		$this->_setPagination();
	}

	function _setPagination(){
		global $mainframe;

		$limit = $mainframe->getUserStateFromRequest('limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest('feedSources.limitstart', 'limitstart', 0, 'int' );

		$this->db->setQuery( "SELECT COUNT(*) FROM `#__rssfactory` AS r 
								LEFT JOIN `#__rssfactory_cache` AS cache
									ON `r`.`id`=`cache`.`rssid`
							 ".$this->_sqlWhere );
		$total = $this->db->loadResult();

		if($total<$limitstart){
			$limitstart = 0;
		}

		jimport('joomla.html.pagination');
		$this->_pagination = new JPagination( $total, $limitstart, $limit );
	}

	function getFeedSources(){
		$query = "SELECT r.*, `c`.`name` AS cat_title, COUNT( cache.id ) AS nrStoriesInCache
					FROM `#__rssfactory` AS r
					LEFT JOIN `#__rssfactory_nestedcategories` AS c
						ON `r`.`cat`=`c`.`id`
					LEFT JOIN `#__rssfactory_cache` AS cache
						ON `r`.`id`=`cache`.`rssid`	
					".$this->_sqlWhere."
					GROUP BY `r`.`id`
					ORDER BY `r`.`ordering`,`r`.`cat`,`r`.`id`";
		$this->db->setQuery($query,$this->_pagination->limitstart, $this->_pagination->limit);
		$res = $this->db->loadObjectList('id');
		return $res;
	}

	function getPagination(){
		return $this->_pagination;
	}

	function changePublishedStatus($aIds,$newPublishedStatus){
		$aIds = (array) $aIds;
		$newPublishedStatus = (int) $newPublishedStatus;

		$ids = implode( ',', $aIds );
		$this->db->setQuery("UPDATE `#__rssfactory` SET `published`='".$this->db->getEscaped($newPublishedStatus)."' WHERE id IN (".$this->db->getEscaped($ids).")");
		return $this->db->query();
	}

	function saveSourceFeed()
	{
		$source =& JTable::getInstance('rfprosource');
		$source->bind($_REQUEST);
		if(!trim($source->title)){
			JError::raiseWarning(1,'Source feed needs a title!');
			return false;
		}
		if(!trim($source->url)){
			JError::raiseWarning(1,'Source feed needs a URL!');
			return false;
		}

		$source->setOrdering();

		if(!$source->store()){
			JError::raiseWarning(1,'Error while saving the feed source!');
			return false;
		}

		$tmpfile=$_FILES['siteicon']['tmp_name'];
		if($tmpfile){
			if(!move_uploaded_file($tmpfile,RSS_FACTORY_COMPONENT_PATH.DS.'images'.DS.'ico_'.md5($source->id).'.png')){
				JError::raiseNotice(1,'The new ico file could not be uploaded!');
			}
		}

		//save the I2C rules for parsing full article; tough job...
		$config =& RFProHelper::getConfig();

		if(JRequest::getVar('sourceRulesI2C',0,'default','int')==$source->id)
		{
			$database = &JFactory::getDBO();
			$database->setQuery("SELECT `id`,`ordering` FROM `#__rssfactory_i2c_sources_rules` WHERE `sourceId`='".$source->id."'");
			$rulesIds = $database->loadAssocList();

			$rule =& JTable::getInstance('rfproi2crules');
			foreach($rulesIds as $ruleId)
			{
				$rule->id = $ruleId['id'];
				$rule->ordering = $ruleId['ordering'];

				$rule->sourceId = $source->id;
				$rule->ruleStart = JRequest::getVar('ruleStart_'.$rule->id,'','default','string',2);
				$rule->ruleEnd = JRequest::getVar('ruleEnd_'.$rule->id,'','default','string',2);
				$rule->stripHTML = JRequest::getVar('stripHTML_'.$rule->id);
				$rule->allowedTags = JRequest::getVar('allowedTags_'.$rule->id,'','default','string',2);
				$rule->include = JRequest::getVar('include_'.$rule->id);

				if(!($rule->ruleStart && $rule->ruleEnd))
				{
					continue;
				}

				$rule->store();
			}
		}

		return true;
	}

	function deleteFeedSources(){
		global $option;
		$database = &JFactory::getDBO();

		$cid = JRequest::getVar('cid',array());

		$ids = implode(',',$cid );
		$database->setQuery( 'DELETE FROM `#__rssfactory` WHERE `id` IN ('.$database->getEscaped($ids).')' );
		if($database->query()){
			JError::raiseNotice(1,'Feed sources deleted!');
		}
		else{
			JError::raiseWarning(1,'Error while deleting feed sources!');
		}

		return true;
	}

	function getI2CRules($sourceId)
	{
		$database = &JFactory::getDBO();
		$database->setQuery('SELECT * FROM `#__rssfactory_i2c_sources_rules` WHERE `sourceId`=\''.$sourceId.'\' ORDER BY `ordering`');
		return $database->loadObjectList();
	}

	function getLastStories($sourceId)
	{
		$database = &JFactory::getDBO();
		$database->setQuery('SELECT * FROM `#__rssfactory_cache` WHERE `rssid`=\''.$sourceId.'\' ORDER BY `date`',0,3);
		return $database->loadObjectList();
	}
}
?>