<?php
defined('_JEXEC') or die( 'Restricted access' );

class RFPROAdminModelRefreshSources extends JModel
{
	var $totalStoriesAdded = 0;
	var $results = array();
	var $feedSources = null;

	function &getAllFeedSources()
	{
		$database = &JFactory::getDBO();

		$query = "SELECT * FROM `#__rssfactory` WHERE `published`='1' ORDER BY date ASC";
    	$database->setQuery( $query );
    	$return = $database->loadObjectList();

    	return $return;
	}

	function &getPseudoCronFeedSources()
	{
		$config =& RFProHelper::getConfig();
		$database = &JFactory::getDBO();

		//first update the never refreshed feeds.
		$query = "SELECT * FROM `#__rssfactory` WHERE `published`='1' AND `date` IS NULL";
		$query .= ' UNION ';
		//then the other feed sources
		$query = "SELECT * FROM `#__rssfactory` WHERE `published`='1' AND DATE_SUB(NOW(),INTERVAL $config->refreshinterval MINUTE)>`date`";
		$database->setQuery($query);
		$return = $database->loadObjectList();

    	return $return;
	}

	function refreshFeedSources($withPseudoCron=false)
	{
        $config =& RFProHelper::getConfig();
        
        if(!$withPseudoCron)
        {
        	$rows =& $this->getAllFeedSources();
        }
        else
        {
        	$rows =& $this->getPseudoCronFeedSources();
        }

		if (!RSS_FACTORY_SITE_SAFE_MODE_ON)
		{
			set_time_limit(0);
		}

    	require_once(RSS_FACTORY_COMPONENT_ADMIN_PATH.DS.'helpers'.DS.'admin.helper.php');

        $memory_limit = 4;
		if(function_exists('ini_get') && function_exists('ini_set') && function_exists('memory_get_usage'))
		{
			//set memory_limit to at least 64M
			$actual_memory = trim(ini_get('memory_limit'));
			if (RFProHelper::Unit2Mega($actual_memory)<64){
					@ini_set('memory_limit','64M');
			}
			$actual_memory = trim(ini_get('memory_limit'));
    		$memory_limit = RFProHelper::Unit2Mega($actual_memory);
		}

		($memory_limit <4) ? ($memory_limit = 4*1024*1024) : ($memory_limit *= 1024*1024);

        $stat_time = RFProHelper::rss_microtime_float();

		foreach ( $rows as $row)
		{
    		if(function_exists('memory_get_usage')){
				$begin_step_memory = memory_get_usage();
			}

			$nr = RFProAdminHelper::refreshSpecificFeedSource($row);

			if(function_exists('memory_get_usage')){
				$end_step_memory = memory_get_usage();
				$delta = ( $end_step_memory - $begin_step_memory ) * 1.1;

				if ($end_step_memory+$delta>$memory_limit)
				{
                    JError::raiseNotice(1, 'Memory will soon be exceeded, now we take a break');
				    break;
				}
			}

			$this->setResults($row,$nr);
    		$this->totalStoriesAdded += $nr;

            $now_time = RFProHelper::rss_microtime_float();
            $seconds=$now_time-$stat_time;

            $timeLimit = ($config->refreshscripttimelimit <= 0) ? 180 : $config->refreshscripttimelimit;

			if ($seconds>$timeLimit) {
                echo '<li>Max '.$timeLimit.' minutes, now we take a break</li>';
                break; //Max 3 minutes
            }
    	}
    	
	}

	function setResults($row,$nr)
	{
		$this->results[$row->id]['url'] = $row->url;
		$this->results[$row->id]['storiesAdded'] = $nr;
	}

	function getResults()
	{
		return $this->results;
	}

	function getTotalStoriesAdded()
	{
		return $this->totalStoriesAdded;
	}

	function checkPassword()
	{
		$config =& RFProHelper::getConfig();

		$pass=JRequest::getVar('password','');

		return ($pass==$config->refresh_password) ? true : false ;
	}
}