<?php
defined('_JEXEC') or die( 'Restricted access' );

class RFPROAdminModelSettings extends JModel
{
	function saveSettings()
	{	 
		$parameters = RFProHelper::getSettingsParameters();

		$settingsFile = RSS_FACTORY_COMPONENT_ADMIN_PATH.DS.'config'.DS.'settings.php';

		$oldPermissions = null;
		if(!is_writable($settingsFile))
		{
			$oldPermissions = fileperms($settingsFile);
			if( !chmod($settingsFile,0777) )
			{
				JError::raiseError(1,'Settings file not writable. Could not save settings!');
				return false;
			}
		}

		$data = '<?php'.PHP_EOL;
		$data .= 'defined(\'_JEXEC\') or die(\'Restricted access.\');'.PHP_EOL.PHP_EOL;

		
		foreach($parameters as $parameter)
		{
			$value = $this->filterParameter($parameter);
			$data .= 'define(\'RFPRO_SETTING_'.strtoupper($parameter).'\',\''.addslashes($value).'\');'.PHP_EOL;
		}
		$data .= '?>';

		file_put_contents($settingsFile,$data);

		if($oldPermissions)
		{
			chmod($settingsFile,$oldPermissions);
		}
		return true;
	}

	function filterParameter($parameter)
	{
		$value = isset($_REQUEST[$parameter]) ? $_REQUEST[$parameter] : null;

		switch($parameter)
		{
			case 'description':
				//return stripslashes($value);
				return $value;
			break;

			case 'nrads':
			case 'refreshscripttimelimit':
			case 'refreshinterval':
			case 'archivedeleteinterval':
			case 'i2c_default_publishing_period':
			case 'cat_previewnr':
			case 'iframe_height':
			case 'feedsperpage':
				return intval($value);
			break;

			case 'refresh_password':
			case 'readmore_options':
			case 'refreshallowedwords':
			case 'refreshbannedwords':
			case 'i2c_default_prepend_text':
			case 'i2c_default_append_text':
			case 'i2callowedwords':
			case 'i2cbannedwords':
			case 'allowed_html_tags':
			case 'channellink':
			case 'force_charset':
			case 'force_output_charset':
			case 'submitfeedstext':
			case 'lang':
			case 'output_iframe':
			case 'liststyle':
			case 'showfeeddescription':
			case 'date_format':
			case 'ol_fgcolor':
			case 'ol_bgcolor':
			case 'ol_txcolor':
			case 'ol_capcolor':
			case 'ol_txsize':
			case 'ol_capsize':
			case 'ol_bordersize':
				return (string) $value;
			break;

			default:
				return (int) $value;
			break;
		}
		
	}
}
?>