<?php

defined('_JEXEC') or die('Restricted access!');

jimport('joomla.html.pagination');

class JRSSFactoryPro_Pagination
{
	
	var $total=null;
	var $limitstart=null;
	var $limit=null;
	var $nrpages=null;

	//sourceId=0 for "listed" display
	function JRSSFactoryPro_Pagination($sourceId=0,$total,$limitstart,$limit){

		$this->sourceId = (int) $sourceId;
		$this->total = (int) $total;
		$this->limitstart = (int) $limitstart;
		$this->limit = (int) $limit ? $limit : 10;
		$this->nrpages = ceil($this->total/$this->limit);

	}

	function getHrefElements()
	{
		$option = JRequest::getVar('option');
		$task = JRequest::getVar('task');
		$catid = JRequest::getVar('id',0,'default','int');
		
		$hrefElements = array();
		$hrefElements['option'] = 'com_'.RSS_FACTORY_COMPONENT_NAME;
		$hrefElements['task'] = $task;
		$hrefElements['id'] = $catid;
		$hrefElements['activeSource'] = $this->sourceId;
		
		if('search'==$task && $searchterm = JRequest::getVar('search','','default','string'))
		{
			$hrefElements['search'] = $searchterm;
		}
		if($forcefeeddescription = JRequest::getVar('forcefeeddescription'))
		{
			$hrefElements['forcefeeddescription'] = $forcefeeddescription;
		}
		if($forceliststyle = JRequest::getVar('forceliststyle'))
		{
			$hrefElements['forceliststyle'] = $forceliststyle;
		}

		return $hrefElements;
	}

	function implodeHrefElements($hrefElements)
	{
		$get = '';

		foreach($hrefElements as $k=>$v)
		{
			$get .= $k.'='.$v.'&';
		}

		return trim($get,'&');
	}

	function getPagesLinks(){

		if($this->nrpages<2){
			return;
		}

		$hrefRoot = 'index.php?';
		$hrefElements = $this->getHrefElements();

		$feedsperpage = $this->limit;

		$activeSource = JRequest::getVar('activeSource',0);

		$actual_page = 1;
		if(isset($this->sourceId))
		{
			if($activeSource == $this->sourceId)
			{
				$offset = $this->limitstart;
				$actual_page += $offset/$feedsperpage;
			}
		}
		else
		{
			$offset = $this->limitstart;
			$actual_page += $offset/$feedsperpage;
		}
		if($actual_page==1)
		{
			$start_link = '&laquo;&nbsp;'.JText::_('START').'&nbsp;';
			$prev_link = '&nbsp;'.JText::_('PREV').'&nbsp;';
		}
		if($actual_page>1)
		{
			$url = $hrefRoot.$this->implodeHrefElements($hrefElements);
			$text = '&laquo;&nbsp;'.JText::_('START').'&nbsp;';
			$start_link = JHTML::link(JRoute::_($url),$text);
			
			$hrefElements['limitstart'] = ($actual_page-2)*$feedsperpage;
			$url = $hrefRoot.$this->implodeHrefElements($hrefElements);
			$text = JText::_('PREV').'&nbsp;';
			$prev_link = JHTML::link(JRoute::_($url),$text);
		}
		if($actual_page<$this->nrpages)
		{
			$hrefElements['limitstart'] = $actual_page*$feedsperpage;
			$url = $hrefRoot.$this->implodeHrefElements($hrefElements);
			$text = JText::_('NEXT').'&nbsp;';
			$next_link = JHTML::link(JRoute::_($url),$text);
			
			$hrefElements['limitstart'] = ($this->nrpages-1)*$feedsperpage;
			$url = $hrefRoot.$this->implodeHrefElements($hrefElements);
			$text = JText::_('END').'&nbsp;&raquo;';
			$end_link = JHTML::link(JRoute::_($url),$text);
		}
		if($actual_page==$this->nrpages)
		{
			$next_link = ' '.JText::_('NEXT').' ';
			$end_link = ' '.JText::_('END').'&raquo; ';
		}

		echo '<div class="rss_pro_pagination" style="z-index:10000;">';

			echo $start_link;
			echo $prev_link;

			for($i=1;$i<=$this->nrpages;$i++)
			{
				$limitstart=($i-1)*$feedsperpage;

				if($i!=$actual_page)
				{
					$hrefElements['limitstart'] = $limitstart;
					$url = $hrefRoot.$this->implodeHrefElements($hrefElements);
					$text = $i;
					echo '<span>'.JHTML::link(JRoute::_($url),$i).'&nbsp;</span>';
					array_pop($hrefElements);
				}
				else{
					echo '<span style="font-weight:bold;">'.$i.'</span> ';
				}
			}

			echo $next_link;
			echo $end_link;

		echo '</div>';
	}

}
?>