<?php
defined('_JEXEC') or die( 'Restricted access' );

class RFPROModelCategories extends JModel{
	
	var $parentCategory=null;

	function __construct()
	{
		parent::__construct();
	}
	
	function _setParentCategory($categoryId)
	{
		$parentCategory =& JTable::getInstance('rfprocategory');
		$parentCategory->load($categoryId);

		$this->parentCategory = $parentCategory;
	}

	function getParentCategory()
	{
		if('RFPRO_WORD4ROOT'==$this->parentCategory->name){
			$this->parentCategory->name = constant('RFPR_WORD4ROOT');
		}
		return $this->parentCategory;
	}

	function loadCategories($categoryId,$includeParent=false,$maxLevel=2)
	{
		$config =& RFProHelper::getConfig();

		$c =& JTable::getInstance('rfpronestedset');

		//first check: if user wants to display un-populated categories, 
		if($config->showemptycategories)
		{			
			 $categories = $c->getSubTree($categoryId,$includeParent,$maxLevel);
			 //vardump($this->childrenCategories,1);
		}
		else
		{
			$categories = $c->getSubTree($categoryId,$includeParent,$maxLevel,true);
		}

		$this->loadExtraCategoryInfo($categories);
		$this->categories = $this->treeStructure($categories);

		return true;	
	}

	function treeStructure($categories){
		$treeStructure = array();

		foreach($categories as $k=>$category){
			if($category->depth==0){
				$treeStructure[0] = $category;
				$treeStructure[0]->children = array();
			}
			if($category->depth==1){
				$lastChild = $k;
				$treeStructure[0]->children[$k] = $category;
				$treeStructure[0]->children[$lastChild]->children = array();
			}
			if($category->depth==2){
				$treeStructure[0]->children[$lastChild]->children[] = $category;
			}
		}

		return $treeStructure;
	}

	function getCategories(){
		return $this->categories;
	}

	function loadHeadlines($categoryId)
	{
		$config =& RFProHelper::getConfig();
		$database =& JFactory::getDBO();

		$query = "SELECT `c`.*,`r`.`encoding`
					FROM `#__rssfactory_cache` AS c 
					LEFT JOIN `#__rssfactory` AS r
				 		ON `c`.`rssid`=`r`.`id`
					WHERE `r`.`published`='1' AND `r`.`cat`='".$database->getEscaped($categoryId)."'
					ORDER BY `r`.`ordering`,`c`.`id`";
		$database->setQuery( $query, 0, $config->cat_previewnr );

		return $database->loadObjectList();
	}

	function loadExtraCategoryInfo($aCategories)
	{
		$config =& RFProHelper::getConfig();

		$categoriesWithResume = array();
		foreach($aCategories as $k=>$category)
		{
			//load the extra information needed for each category
			$category->title = RFProHelper::rssfactory_pro_html_entity_decode($category->name);
			$category->description = RFProHelper::rssfactory_pro_html_entity_decode($category->description);

			//$category->nrfeeds = $this->countCachedStories($category->id);
			//$category->nrsources = $this->countFeedSources($category->id);
			//$category->childrenCategories = ($config->showemptycategories) ? $category->getAllChildren() : $category->getPopulatedChildren();
			$category->headlines = $this->loadHeadlines($category->id);

			$categoriesWithResume[] = $category;
		}

		return $categoriesWithResume;
	}
}
?>