<?php
defined('_JEXEC') or die('Restricted access.');

class RFPROModelFeedSources extends JModel
{
	var $parentCategory = null;
	var $sources = null;
	var $stories = null;
	var $paginations = null;

	function setParentCategory($categoryId)
	{
		$category =& JTable::getInstance('rfprocategory');
		$category->load($categoryId);
		$this->parentCategory = $category;
	}

	function getParentCategory()
	{
		return $this->parentCategory;
	}

	function deleteOldVisits()
	{
		$database =& JFactory::getDBO();
		$query = "DELETE FROM `#__rssfactory_user` WHERE UNIX_TIMESTAMP()-UNIX_TIMESTAMP(date)>3600";
        $database->setQuery( $query );
        $database->query();
	}

	function getAds()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$query = 
		"SELECT `a`.* 
			FROM `#__rssfactory_ads` AS a 
			LEFT JOIN `#__rssfactory_ad_category_map` AS acmap
			ON `a`.`id`=`acmap`.`adId`
			WHERE `a`.`published`='1' ORDER BY RAND()";
    	$database->setQuery($query,0,$config->nrads);

		return $database->loadObjectList();
	}

	function setSources()
	{
		$searchterm = JRequest::getVar('search','','default','string');

		static $sources=null;
		if(!$sources)
		{
			$database =& JFactory::getDBO();
			$parentCategory = $this->getParentCategory();
			
			$task = JRequest::getVar('task','','default','string');
	
			$database->setQuery("SELECT `r`.`id`,`r`.`title`
									FROM `#__rssfactory` AS r
									LEFT JOIN `#__rssfactory_cache` AS c
										ON `r`.`id`=`c`.`rssid`
									WHERE `r`.`published`='1' AND `c`.`archived`='0' ". 
									( ($task=='search') ? " AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '".$database->getEscaped($searchterm)."' ) " : ' '
									).
								( $parentCategory->id ? " AND `r`.`cat`='".$database->getEscaped($parentCategory->id)."' " : " ")
								." ORDER BY `r`.`ordering`");
		}

		$this->sources = $database->loadObjectList('id');
	}

	function getTotals()
	{
		$sources = $this->getSources();

		$database =& JFactory::getDBO();
		$task = JRequest::getVar('task','','default','string');
		$searchterm = JRequest::getVar('search','','default','string');

		$count_queries = array();
		foreach($sources as $source)
		{
			//we don't want the sources without any news
			//if(!$total[$source->id]['cacheCount']){
			//	unset($sources[$source->id]);
			//}
			$count_queries[] = "(SELECT `r`.`id` AS sourceId, COUNT(`c`.`id`) AS cacheCount
						FROM `#__rssfactory` AS r
						LEFT JOIN `#__rssfactory_cache` AS c
							ON `r`.`id`=`c`.`rssid`
						WHERE `r`.`id`='".$source->id."' AND (`c`.`archived`='0' OR `c`.`archived` IS NULL)"

							.($task=='search'?"AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '%".$database->getEscaped($searchterm)."%' ) " : " ").
						" GROUP BY `r`.`id`) ";
		}

		$count_query = implode(' UNION ',$count_queries);
		$database->setQuery($count_query);
		vardump($database->_sql,1);
		//number of news for every source being displayed
		return $database->loadAssocList('sourceId');
	}

	function setStories()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$this->setSources();
		$this->setPaginations();

		$queries = array();
		$channel_title_queries = array();
		$task = JRequest::getVar('task','','default','string');
		$searchterm = JRequest::getVar('search','','default','string');

		foreach($sources as $source)
		{
			$queries[] = "(SELECT `c`.*, `r`.`encoding`, `r`.`id` AS sourceId, `r`.`cat`, `r`.`title` AS sourceTitle, `ru`.`id` AS isVisited". 
			($config->enablevoting?",SUM(`rv`.`voteValue`) AS rating ":" ").
						"FROM `#__rssfactory_cache` AS c
						LEFT JOIN  `#__rssfactory` AS r
							ON `c`.`rssid`=`r`.`id`
						LEFT JOIN `#__rssfactory_user` AS ru
							ON `c`.`id`=`ru`.`newsid`".
						($config->enablevoting ?
						"LEFT JOIN `#__rssfactory_voting` AS rv
							ON `c`.`id`=`rv`.`cacheId` ":" ").
						"WHERE `r`.`id`='".$source->id."' AND `r`.`published`='1' AND `c`.`archived`='0' "

							.($task=='search'?"AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '%".$database->getEscaped($searchterm)."%' ) " : " ").

						($config->enablevoting?
						"GROUP BY `c`.`id` ":" ").
						"ORDER BY ".($config->orderbydate ? " `c`.`item_date` DESC, ":" ")." `c`.`id` ".
						"LIMIT ".$pageNavs[$source->id]->limitstart.",".$pageNavs[$source->id]->limit.") ";

			//get the title from XML
			if($config->showtruetitle)
			{
				$channel_title_queries[] = "(SELECT `rssid` AS id,`channel_title` AS `XMLTitle` FROM `#__rssfactory_cache` WHERE `rssid`='".$database->getEscaped($source->id)."' LIMIT 1) ";
			}
		}

		$query = implode(' UNION ',$queries);
		$orderby = ('list' == $config->listsyle && $config->orderbydate ) ? ' ORDER BY `item_date`' : ' ';
		$database->setQuery($query.$orderby);
		$rows = $database->loadObjectList();

		if($config->showtruetitle){
			$channel_title_query = implode(' UNION ',$channel_title_queries);
			$database->setQuery($channel_title_query);
			$channel_titles = $database->loadAssocList('id');
		}

		$rowsBySource = array();

		$currentSource = null;
		foreach ($rows as $k=>$row)
		{
			if($currentSource != $row->sourceId)
			{
				$currentSource = $row->sourceId;
				$rowsBySource[$currentSource] = array();
				$sourceCounter = 0;
			}

			if($config->showtruetitle)
			{
				$rowsBySource[$currentSource]['sourceTitle'] = $channel_titles[$row->sourceId]['XMLTitle'];
			}
			else
			{
				$rowsBySource[$currentSource]['sourceTitle'] = $row->sourceTitle;
			}
			
			$rowsBySource[$currentSource]['stories'][] = $row;
    	}

		return $rowsBySource;
	}

	function setPaginations()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		$sources = $this->getSources();

		$limitstart = JRequest::getVar('limitstart',0,'default','int');

		$parentCategory = $this->getParentCategory();

		$totals = $this->getTotals($sources);
		
		JLoader::import('pagination',RSS_FACTORY_COMPONENT_PATH.DS.'helpers');

		//the id of the source viewed at the previous display
		$change_page = JRequest::getVar('activeSource',0);

		foreach($sources as $source)
		{
			$limit = ($config->feedsperpage)?($config->feedsperpage):$totals[$source->id]['cacheCount'];
			//here i get the limitstart from POST
			$limitstart = ($change_page == $source->id) ? JRequest::getVar('limitstart',0,'default','int') : 0;
			$pageNavs[$source->id] = new JRSSFactoryPRO_Pagination($source->id,$totals[$source->id]['cacheCount'],$limitstart,$limit);
		}

		$this->paginations = $pageNavs;
	}

	function dragdivReOrder($sources)
	{
		$categoryId = JRequest::getVar('id',0,'default','int');
		//get the order for draggable divs from cookie
		$order = JRequest::getVar('rfpro_dragdiv_orderlist_'.$categoryId);
		$order = explode(',',$order);

		//first check if the cookie has the same number of source ids like the result from the db; the check if all the ids in the cookie are found in the db result
		$tests = true;
		if(count($order)==count($sources))
		{
			foreach($sources as $source_id=>$source)
			{
				if(!in_array($source_id,$order))
				{
					$tests = false;
					break;
				}
			}
		}
		else
		{
			$tests = false;
		}
		if($tests)
		{
			$reordered_sources = array();

			//reordering the sources
			foreach($order as $source_id){
				$reordered_sources[] = $sources[$source_id];
			}
			return $reordered_sources;
		}
		return $sources;
	}

	function getSources()
	{
		return $this->sources;
	}

	function getStories()
	{
		return $this->stories;
	}

	function getPaginations()
	{
		return $this->paginations;
	}
}
?>