<?php
defined('_JEXEC') or die('Restricted access.');

class RFPROModelFeedSourcesTiles extends JModel
{
	var $categoryIds = null;
	var $parentCategory = null;
	var $sources = null;
	var $stories = null;
	var $paginations = null;

	var $filters = array();

	function setCategories($categoryIds)
	{
		//remove category with id=0
		$categoryIds = array_diff((array) $categoryIds, array(0) );
		foreach($categoryIds as $categoryId)
		{
			$this->categoryIds[] = intval($categoryId);
		}

		$category =& JTable::getInstance('rfpronestedset');
		$category->load($this->categoryIds[0]);
		$this->parentCategory = $category;
	}

	function getParentCategory()
	{
		return $this->parentCategory;
	}

	function deleteOldVisits()
	{
		$database =& JFactory::getDBO();
		$query = "DELETE FROM `#__rssfactory_user` WHERE UNIX_TIMESTAMP()-UNIX_TIMESTAMP(date)>3600";
        $database->setQuery( $query );
        $database->query();
	}

	function loadSources()
	{
		$searchterm = JRequest::getVar('search','','default','string');

		static $sources=null;
		if(!$sources)
		{
			$database =& JFactory::getDBO();
			$parentCategory = $this->getParentCategory();

			$task = JRequest::getVar('task','','default','string');

			$query = "SELECT `r`.`id`,`r`.`title`
						FROM `#__rssfactory` AS r 
						WHERE `r`.`published`='1' ".
						( count($this->categoryIds) ? " AND `r`.`cat` IN (".$database->getEscaped( implode(',',$this->categoryIds) ).") " : " ").
					" ORDER BY `r`.`ordering` ";
			if('search'==$task)
			{
				$query = "SELECT `r`.`id`,`r`.`title`
							FROM `#__rssfactory` AS r
							LEFT JOIN `#__rssfactory_cache` AS c
								ON `r`.`id`=`c`.`rssid`
							WHERE `r`.`published`='1' AND `c`.`archived`='0' ". 
							" AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '%".$database->getEscaped($searchterm)."%' ) ".
						" ORDER BY `r`.`ordering` ";
			}
			$database->setQuery($query);

			$sources = $database->loadObjectList('id');
		}

		$this->sources =& $sources;
	}

	function &getSources()
	{
		return $this->sources;
	}

	function loadTotals()
	{
		$database =& JFactory::getDBO();
		$parentCategory = $this->getParentCategory();
		$task = JRequest::getVar('task','','default','string');

		$searchterm = JRequest::getVar('search','','default','string');

		$count_query = "SELECT `r`.`id` AS sourceId, COUNT(`c`.`id`) AS cacheCount
					FROM `#__rssfactory` AS r
					LEFT JOIN `#__rssfactory_cache` AS c
						ON `r`.`id`=`c`.`rssid`
					WHERE (`c`.`archived`='0' OR `c`.`archived` IS NULL)".
						( count($this->categoryIds) ? " AND `r`.`cat` IN (".$database->getEscaped( implode(",",$this->categoryIds) ).") " : " ").
						($task=='search'?"AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '%".$database->getEscaped($searchterm)."%' ) " : " ").
					" GROUP BY `r`.`id` 
					ORDER BY `r`.`ordering`";
		
		$database->setQuery($count_query);
		//number of news for every source being displayed
		return $database->loadAssocList('sourceId');
	}

	function loadStories()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();
		
		$this->loadSources();

		$sourceIds=array();
		foreach($this->sources as $source)
		{
			$sourceIds[]=$source->id;
		}

		$this->generatePagination();

		$pageNav =& $this->getPagination();
		//need the first pagination tot take the limit
		$pageNavItem = reset($pageNav) ? reset($pageNav) : new stdClass;

		$channel_title_queries = array();
		$task = JRequest::getVar('task','','default','string');
		$searchterm = JRequest::getVar('search','','default','string');
		$activesource = JRequest::getVar('activeSource',0,'default','int');
		
		$limitstart = 0;
		if($activesource)
		{
			$limitstart = $pageNav[$activesource]->limitstart;
		}

		$database->setQuery("SET @rfproCurrentSource=0");
		$database->query();
		$database->setQuery("SET @rfproCounter=0");
		$database->query();

		$query = "SELECT `c`.*, `r`.`encoding`, `r`.`id` AS sourceId, `r`.`cat`, `r`.`title` AS sourceTitle, `ru`.`id` AS isVisited,
			cat.id as categoryId,cat.name as categoryName,cat.description as categoryDescription,
			IF(@rfproCurrentSource<>`r`.`id`,(CONCAT(@rfproCurrentSource:=`r`.`id`,@rfproCounter:=0 )),(@rfproCounter:=@rfproCounter+1) ), @rfproCounter AS cacat ". 
		($config->enablevoting?",SUM(`rv`.`voteValue`) AS rating ":" ").
					" FROM `#__rssfactory_cache` AS c
					LEFT JOIN  `#__rssfactory` AS r
						ON `c`.`rssid`=`r`.`id`
					LEFT JOIN `#__rssfactory_nestedcategories` AS cat
						ON `r`.`cat`=`cat`.`id`
					LEFT JOIN `#__rssfactory_user` AS ru
						ON `c`.`id`=`ru`.`newsid`".
					($config->enablevoting ? 
					" LEFT JOIN `#__rssfactory_voting` AS rv
						ON `c`.`id`=`rv`.`cacheId` ":" ").
					" WHERE `r`.`id` IN ('".implode("','",$sourceIds)."')
						AND `r`.`published`='1'
						AND `c`.`archived`='0' ".
					($task=='search'?" AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '%".$database->getEscaped($searchterm)."%' ) " : " ").

					" GROUP BY `c`.`id` ".
					" HAVING IF(`r`.`id`='".intval($activesource)."',`cacat`>=".intval($limitstart)." AND `cacat`<".intval($limitstart + $pageNavItem->limit).",`cacat`<".intval($pageNavItem->limit)." ) ".

					" ORDER BY `r`.`ordering`,`r`.`id`,".($config->orderbydate ? " `c`.`item_date` DESC, ":" ")." `c`.`id` ";

		$database->setQuery($query);
		$rows = $database->loadObjectList();
		//vardump($database->_sql,1);

		//get the title from XML
		if($config->showtruetitle)
		{
			$channel_title_query = "SELECT `rssid` AS id,`channel_title` AS `XMLTitle` FROM `#__rssfactory_cache` WHERE `rssid` IN ('".implode("','",$sourceIds)."')";
			$database->setQuery($channel_title_query);
			$channel_titles = $database->loadAssocList('id');
		}

		$rowsBySource = array();

		$currentSource = null;
		foreach ($rows as $k=>$row)
		{
			if($currentSource != $row->sourceId)
			{
				$currentSource = $row->sourceId;
				$rowsBySource[$currentSource] = array();
			}

			if($config->showtruetitle)
			{
				$rowsBySource[$currentSource]['sourceTitle'] = $channel_titles[$row->sourceId]['XMLTitle'];
			}
			else
			{
				$rowsBySource[$currentSource]['sourceTitle'] = $row->sourceTitle;
			}
			
			$rowsBySource[$currentSource]['stories'][] = $row;
		}

		//reorder if draggable divs
		if('dragdiv'==$config->liststyle || 'dragdiv'==JRequest::getVar('forceliststyle',null,'default','string'))
		{
			$rowsBySource = $this->dragdivReOrder($rowsBySource);
		}

		$this->stories =& $rowsBySource;
	}

	function &getStories()
	{
		return $this->stories;
	}

	function generatePagination()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		//$parentCategory = $this->getParentCategory();

		$totals = $this->loadTotals();

		JLoader::import('pagination',RSS_FACTORY_COMPONENT_PATH.DS.'helpers');

		//the id of the source viewed at the previous display
		$activeSource = JRequest::getVar('activeSource',0);

		$pageNavs = array();
		foreach($this->sources as $source)
		{
			$limit = ($config->feedsperpage) ? ($config->feedsperpage) : $totals[$source->id]['cacheCount'];
			//here i get the limitstart from POST
			$limitstart = ($activeSource == $source->id) ? JRequest::getVar('limitstart',0,'default','int') : 0;
			$total = isset($totals[$source->id]) ? $totals[$source->id]['cacheCount'] : 0;
			$pageNavs[$source->id] = new JRSSFactoryPRO_Pagination($source->id,$total,$limitstart,$limit);
		}

		$this->paginations =& $pageNavs;
	}

	function &getPagination()
	{
		return $this->paginations;
	}

	function dragdivReOrder($rowsBySource)
	{
		$categoryId = JRequest::getVar('id',0,'default','int');
		//get the order for draggable divs from cookie
		$order = JRequest::getVar('rfpro_dragdiv_orderlist_'.$categoryId);
		$order = explode(',',$order);

		//first check if the cookie has the same number of source ids like the result from the db; the check if all the ids in the cookie are found in the db result
		$tests = true;
		if(count($order)==count($rowsBySource))
		{
			foreach($rowsBySource as $sourceId=>$val)
			{
				if(!in_array($sourceId,$order))
				{
					$tests = false;
					break;
				}
			}
		}
		else
		{
			$tests = false;
		}

		if($tests)
		{
			$reordered_sources = array();

			//reordering the sources
			foreach($order as $sourceId){
				$reordered_sources[$sourceId] = $rowsBySource[$sourceId];
			}
			return $reordered_sources;
		}
		return $rowsBySource;
	}
}
?>