<?php
defined('_JEXEC') or die('Restricted access.');

class RFPROModelPlgFeedSourcesTiles extends JModel
{
	var $categoryIds = null;
	var $parentCategory = null;
	var $sources = null;
	var $stories = null;
	var $paginations = null;

	var $filters = array();

	function setCategories($categoryIds)
	{
		//remove category with id=0
		$categoryIds = array_diff((array) $categoryIds, array(0) );
		foreach($categoryIds as $categoryId)
		{
			$this->categoryIds[] = intval($categoryId);
		}

		//this is cheap, but i'm in a hurry now
		$category =& JTable::getInstance('rfprocategory');
		$category->load($this->categoryIds[0]);
		$this->parentCategory = $category;
	}

	function getParentCategory()
	{
		return $this->parentCategory;
	}

	function deleteOldVisits()
	{
		$database =& JFactory::getDBO();
		$query = "DELETE FROM `#__rssfactory_user` WHERE UNIX_TIMESTAMP()-UNIX_TIMESTAMP(date)>3600";
        $database->setQuery( $query );
        $database->query();
	}

	function loadSources()
	{
		$searchterm = JRequest::getVar('search','','default','string');

		static $sources=null;
		if(!$sources)
		{
			$database =& JFactory::getDBO();
			$parentCategory = $this->getParentCategory();

			$task = JRequest::getVar('task','','default','string');

			$query = "SELECT `r`.`id`,`r`.`title`
						FROM `#__rssfactory` AS r 
						WHERE `r`.`published`='1' ".
						( count($this->categoryIds) ? " AND `r`.`cat` IN (".$database->getEscaped( implode(',',$this->categoryIds) ).") " : " ").
					" ORDER BY `r`.`ordering` ";
			if('search'==$task)
			{
				$query = "SELECT `r`.`id`,`r`.`title`
							FROM `#__rssfactory` AS r
							LEFT JOIN `#__rssfactory_cache` AS c
								ON `r`.`id`=`c`.`rssid`
							WHERE `r`.`published`='1' AND `c`.`archived`='0' ". 
							" AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '%".$database->getEscaped($searchterm)."%' ) ".
						" ORDER BY `r`.`ordering` ";
			}
			$database->setQuery($query);

			$sources = $database->loadObjectList('id');
		}

		$this->sources =& $sources;
	}

	function &getSources()
	{
		return $this->sources;
	}

	function loadTotals()
	{
		$database =& JFactory::getDBO();
		$parentCategory = $this->getParentCategory();
		$task = JRequest::getVar('task','','default','string');

		$searchterm = JRequest::getVar('search','','default','string');

		$count_query = "SELECT `r`.`id` AS sourceId, COUNT(`c`.`id`) AS cacheCount
					FROM `#__rssfactory` AS r
					LEFT JOIN `#__rssfactory_cache` AS c
						ON `r`.`id`=`c`.`rssid`
					WHERE (`c`.`archived`='0' OR `c`.`archived` IS NULL)".
						( count($this->categoryIds) ? " AND `r`.`cat` IN (".$database->getEscaped( implode(",",$this->categoryIds) ).") " : " ").
						($task=='search'?"AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '%".$database->getEscaped($searchterm)."%' ) " : " ").
					" GROUP BY `r`.`id` 
					ORDER BY `r`.`ordering`";
		
		$database->setQuery($count_query);
		//number of news for every source being displayed
		return $database->loadAssocList('sourceId');
	}

	function loadStories()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();
		
		$this->loadSources();

		$sourceIds=array();
		foreach($this->sources as $source)
		{
			$sourceIds[]=$source->id;
		}

		$this->generatePagination();

		$pageNav =& $this->getPagination();
		//need the first pagination tot take the limit
		$pageNavItem = reset($pageNav) ? reset($pageNav) : new stdClass;

		$channel_title_queries = array();
		$task = JRequest::getVar('task','','default','string');
		$searchterm = JRequest::getVar('search','','default','string');
		$activesource = JRequest::getVar('activeSource',0,'default','int');
		
		$limitstart = 0;
		if($activesource)
		{
			$limitstart = $pageNav[$activesource]->limitstart;
		}

		$database->setQuery("SET @rfproCurrentSource=0");
		$database->query();
		$database->setQuery("SET @rfproCounter=0");
		$database->query();

		$query = "SELECT `c`.*, `r`.`encoding`, `r`.`id` AS sourceId, `r`.`cat`, `r`.`title` AS sourceTitle, `ru`.`id` AS isVisited, 
			IF(@rfproCurrentSource<>`r`.`id`,(CONCAT(@rfproCurrentSource:=`r`.`id`,@rfproCounter:=0 )),(@rfproCounter:=@rfproCounter+1) ), @rfproCounter AS cacat ". 
		($config->enablevoting?",SUM(`rv`.`voteValue`) AS rating ":" ").
					" FROM `#__rssfactory` AS r
					LEFT JOIN  `#__rssfactory_cache` AS c
						ON `c`.`rssid`=`r`.`id`
					LEFT JOIN `#__rssfactory_user` AS ru
						ON `c`.`id`=`ru`.`newsid`".
					($config->enablevoting ? 
					" LEFT JOIN `#__rssfactory_voting` AS rv
						ON `c`.`id`=`rv`.`cacheId` ":" ").
					" WHERE `r`.`id` IN ('".implode("','",$sourceIds)."')
						AND `r`.`published`='1'
						AND `c`.`archived`='0' ".
					($task=='search'?" AND (`c`.`item_title` LIKE '%".$database->getEscaped($searchterm)."%' OR `c`.`item_description` LIKE '%".$database->getEscaped($searchterm)."%' ) " : " ").
						
					" GROUP BY `c`.`id` ".
					" HAVING IF(`r`.`id`='".intval($activesource)."',`cacat`>=".intval($limitstart)." AND `cacat`<".intval($limitstart + $pageNavItem->limit).",`cacat`<".intval($pageNavItem->limit)." ) ".

					" ORDER BY `r`.`ordering`,`r`.`id`,".($config->orderbydate ? " `c`.`item_date` DESC, ":" ")." `c`.`id` ";

		$database->setQuery($query);
		$rows = $database->loadObjectList();

		//get the title from XML
		if($config->showtruetitle)
		{
			$channel_title_query = "SELECT `rssid` AS id,`channel_title` AS `XMLTitle` FROM `#__rssfactory_cache` WHERE `rssid` IN ('".implode("','",$sourceIds)."')";
			$database->setQuery($channel_title_query);
			$channel_titles = $database->loadAssocList('id');
		}

		$rowsBySource = array();

		$currentSource = null;
		foreach ($rows as $k=>$row)
		{
			if($currentSource != $row->sourceId)
			{
				$currentSource = $row->sourceId;
				$rowsBySource[$currentSource] = array();
			}

			if($config->showtruetitle)
			{
				$rowsBySource[$currentSource]['sourceTitle'] = $channel_titles[$row->sourceId]['XMLTitle'];
			}
			else
			{
				$rowsBySource[$currentSource]['sourceTitle'] = $row->sourceTitle;
			}
			
			$rowsBySource[$currentSource]['stories'][] = $row;
		}

		//reorder if draggable divs
		if('dragdiv'==$config->liststyle || 'dragdiv'==JRequest::getVar('forceliststyle',null,'default','string'))
		{
			$rowsBySource = $this->dragdivReOrder($rowsBySource);
		}

		$this->stories =& $rowsBySource;
	}

	function &getStories()
	{
		return $this->stories;
	}

	function generatePagination()
	{
		$database =& JFactory::getDBO();
		$config =& RFProHelper::getConfig();

		//$parentCategory = $this->getParentCategory();

		$totals = $this->loadTotals();

		JLoader::import('pagination',RSS_FACTORY_COMPONENT_PATH.DS.'helpers');

		//the id of the source viewed at the previous display
		$activeSource = JRequest::getVar('activeSource',0);

		$pageNavs = array();
		foreach($this->sources as $source)
		{
			$limit = ($config->feedsperpage) ? ($config->feedsperpage) : $totals[$source->id]['cacheCount'];
			//here i get the limitstart from POST
			$limitstart = ($activeSource == $source->id) ? JRequest::getVar('limitstart',0,'default','int') : 0;
			$total = isset($totals[$source->id]) ? $totals[$source->id]['cacheCount'] : 0;
			$pageNavs[$source->id] = new JRSSFactoryPRO_Pagination($source->id,$total,$limitstart,$limit);
		}

		$this->paginations =& $pageNavs;
	}

	function &getPagination()
	{
		return $this->paginations;
	}

	function dragdivReOrder($rowsBySource)
	{
		$categoryId = JRequest::getVar('id',0,'default','int');
		//get the order for draggable divs from cookie
		$order = JRequest::getVar('rfpro_dragdiv_orderlist_'.$categoryId);
		$order = explode(',',$order);

		//first check if the cookie has the same number of source ids like the result from the db; the check if all the ids in the cookie are found in the db result
		$tests = true;
		if(count($order)==count($rowsBySource))
		{
			foreach($rowsBySource as $sourceId=>$val)
			{
				if(!in_array($sourceId,$order))
				{
					$tests = false;
					break;
				}
			}
		}
		else
		{
			$tests = false;
		}

		if($tests)
		{
			$reordered_sources = array();

			//reordering the sources
			foreach($order as $sourceId){
				$reordered_sources[$sourceId] = $rowsBySource[$sourceId];
			}
			return $reordered_sources;
		}
		return $rowsBySource;
	}

	function setStories($occurrence)
	{
		$database =& JFactory::getDBO();
		$cfg =& RFProHelper::getConfig();

		preg_match('/categoryId="([0-9,\,]*)"/',$occurrence,$aCatIds);
		if(isset($aCatIds[1])){
			$catids=trim($aCatIds[1],',');
			$catids=mysql_real_escape_string($catids);
		}
		else
			$catids=null;

		preg_match('/sourceId="([0-9,\,]*)"/',$occurrence,$aSourceIds);
		if(isset($aSourceIds[1])){
			$sourceids=trim($aSourceIds[1],',');
			$sourceids=mysql_real_escape_string($sourceids);
		}
		else
			$sourceids=null;

		preg_match('/searchTerm="(.*?)"/',$occurrence,$aSearchTerms);
		if(isset($aSearchTerms[1]))
			$searchterms=explode(',',mysql_real_escape_string($aSearchTerms[1]));
		else
			$searchterms=null;

		preg_match('/nrFeeds="([0-9]*)"/',$occurrence,$aNrFeeds);
		if(isset($aNrFeeds[1]))
			$nrfeeds=mysql_real_escape_string($aNrFeeds[1]);
		else
			$nrfeeds=10;

		preg_match('/outputStyle="(.*?)"/',$occurrence,$aOutputStyle);
		if(isset($aOutputStyle[1])){
			$outputstyle=mysql_real_escape_string($aOutputStyle[1]);
			if($outputstyle!='tooltip' && $outputstyle!='table' && $outputstyle!='modal' && $outputstyle!='diggstyle')
				$outputstyle='table';
		}
		else
			$outputstyle='table';
		$cfg->showfeeddescription = $outputstyle;

		preg_match('/suppressImg="(.*?)"/',$occurrence,$aSuppressImg);
		if(isset($aSuppressImg[1])){
			$suppressImg = mysql_real_escape_string($aSuppressImg[1]);
		}
		else{
			$suppressImg = 0;
		}
		$cfg->suppress_img = $suppressImg;

		preg_match('/suppressEmbedded="(.*?)"/',$occurrence,$aSuppressEmbedded);
		if(isset($aSuppressEmbedded[1])){
			$suppressEmbedded = mysql_real_escape_string($aSuppressEmbedded[1]);
		}
		else{
			$suppressEmbedded = 0;
		}
		$cfg->suppress_embedded = $suppressEmbedded;

		preg_match('/tableAlwaysOpen="([0,1]{1})"/',$occurrence,$aTableAlwaysOpen);
		if(isset($aTableAlwaysOpen[1])){
			$tablealwaysopen = $aTableAlwaysOpen[1];
		}
		else{
			$tablealwaysopen = 0;
		}
		$cfg->table_view_open = $tablealwaysopen;

		preg_match('/orderByDate="([0,1]{1})"/',$occurrence,$aOrderByDate);
		if(isset($aOrderByDate[1]))
			$orderByDate = $aOrderByDate[1];
		else
			$orderByDate = 0;

		preg_match('/displayAds="([0,1]{1})"/',$occurrence,$aDisplayAds);

		if(isset($aDisplayAds[1]))
			$displayAds = $aDisplayAds[1];
		else
			$displayAds = 0;

		$query = 'SELECT * FROM #__rssfactory_ads where published=1 ORDER BY RAND() LIMIT '.$cfg->nrads;
    	$database->setQuery( $query );
    	$ads = $database->loadObjectList();

        $query = 'DELETE FROM #__rssfactory_user WHERE UNIX_TIMESTAMP()-UNIX_TIMESTAMP(date) > 3600';
        $database->setQuery( $query );
        $database->query();
        $rows = array();

		$session =& JFactory::getSession();
		$sessionName = $session->getName();

		$cook = $_COOKIE[$sessionName];

		$query = "SELECT distinct r.id,r.title FROM #__rssfactory r LEFT JOIN #__rssfactory_cache cache ON r.id=cache.rssid WHERE r.published=1 ";
		$query .= $catids?' AND r.cat IN ('.$catids.') ':'';
		$query .= $sourceids?' AND r.id IN ('.$sourceids.') ':'';

		if(count($searchterms)){
			$i=0;
			$query .= ' AND ( ';
			foreach($searchterms as $searchterm){
				$query .= " cache.item_title LIKE '%$searchterm%' OR cache.item_description LIKE '%$searchterm%' ";
				$i++;

				if($i<count($searchterms))
					$query .= ' OR ';
			}
			$query .= ' ) ';
		}

		if($orderByDate){
			$query .= ' ORDER BY cache.item_date DESC,r.ordering,cache.id';
		}
		else{
			$query .= ' ORDER BY r.ordering,cache.id';
		}
		$database->setQuery($query);
		$sources = $database->loadObjectList('id');

        if (count($sources))
        {
			foreach($sources as $source){

				$query = "SELECT cache.*, r.encoding, 'prefix', 'isVisited'
				FROM #__rssfactory_cache cache LEFT JOIN  #__rssfactory r ON cache.rssid=r.id 
				WHERE r.id='".$source->id."' AND r.published = '1' AND `cache`.`archived`='0'  ";

				$query .= $catids ? ' AND r.cat IN ('.$catids.') ':'';
				$query .= $sourceids?' AND r.id IN ('.$sourceids.') ':'';

				if(count($searchterms)){
					$i=0;
					$query .= ' AND ( ';

					foreach($searchterms as $searchterm){
						$query .= " cache.item_title LIKE '%$searchterm%' OR cache.item_description LIKE '%$searchterm%' ";
						$i++;

						if($i<count($searchterms))
							$query .= ' OR ';
					}
					$query .= ' ) ';
				}
				if($orderByDate){
					$query .= ' ORDER BY cache.item_date,r.ordering,cache.id';
				}
				else{
					$query .= ' ORDER BY r.ordering,cache.id';
				}


				$database->setQuery($query,0,$nrfeeds);
				$feeds=$database->loadObjectList();

		        //Random positioning of ads
	        	$nrads = count($ads);
				if ($nrads==1){
	        		$rand_keys[$source->id] =array(array_rand($feeds, 1));
	        	}
				else if($nrads>1){
					$range_ads = range(1,$nrads);
					shuffle($range_ads);
	        		$rand_keys[$source->id] = $range_ads;
	        	}
	        	else{
	        		$rand_keys[$source->id] = array();
	        	}

				//get the title from XML
				if($cfg->showtruetitle){
					$database->setQuery("SELECT channel_title FROM #__rssfactory_cache WHERE rssid='".$source->id."' LIMIT 1");
					$trueTitle = $database->loadResult();
					if($trueTitle){
						$source->title = $trueTitle;
					}
				}
                if (count($feeds))
					foreach ($feeds as $k=>$feed){
		        		//showing the bullet
						$query = "SELECT * FROM #__rssfactory_user where sid='$cook' and newsid=$feed->id ";
	        			$database->setQuery( $query );
	        			if (!$database->loadResult()){
	        				$img[$feed->id]='exp0.gif';
	        			}
						else{
	        				$img[$feed->id]='exp1.gif';
	                    }

//        	                    unset($rows[$k]);
	                    $feeds[$k]=$feed;
	            	}

            	$rows[$source->id]['sourceTitle'] = $source->title;
            	$rows[$source->id]['stories'] = $feeds;
			}
		}

		$this->stories =& $rows;
	}
}
?>