<?php

if ( !function_exists('str_clean') ) {
	function str_clean( $string ) {
		$aToReplace = array(" ",",",".","/","_","&","�","�","�","!","$","%","@","?","#","(",")","+","*",":",";","'","\"");
		$aReplacements = array("-","-","-","-","-","and","");

		$str_buff = str_replace($aToReplace,$aReplacements,strtolower($string)	);
		return $str_buff;
	}
}

function rssfactory_proBuildRoute(&$query){

	$segments = array();

	if(empty($query['task']))
	{
		// get a menu item based on Itemid or currently active
		$menu = &JSite::getMenu();
		if (empty($query['Itemid'])) {
			$menuItem = &$menu->getActive();
		} else {
			$menuItem = &$menu->getItem($query['Itemid']);
		}
		$task = (empty($menuItem->query['task'])) ? 'categories' : $menuItem->query['task'] ;
		$id = (empty($menuItem->query['id'])) ? null : $menuItem->query['id'] ;
		$activeSource = (empty($menuItem->query['activeSource'])) ? null : $menuItem->query['activeSource'] ;
		$start = (empty($menuItem->query['start'])) ? null : $menuItem->query['start'] ;
		if(!empty($menuItem->query['forceliststyle']))
		{
			$query['forceliststyle'] = $menuItem->query['forceliststyle'];
		}
		if(!empty($menuItem->query['forcefeeddescription']))
		{
			$query['forcefeeddescription'] = $menuItem->query['forcefeeddescription'];
		}
	}
	else
	{
		$task = (empty($query['task'])) ? 'categories' : $query['task'] ;
		$id = (empty($query['id'])) ? null : $query['id'] ;
		$activeSource = (empty($query['activeSource'])) ? null : $query['activeSource'] ;
		$start = (empty($query['start'])) ? null : $query['start'] ;
	}

	$database = &JFactory::getDBO();

	switch($task)
	{
		case 'categories':
			$segments[] = 'categories';
			$database->setQuery("SELECT `name` FROM `#__rssfactory_nestedcategories` WHERE `id`='".$database->getEscaped($id)."'");
			$categoryTitle = $database->loadResult();
			$segments[] = JFilterOutput::stringURLSafe($categoryTitle);
			$segments[] = $id;
			unset($query['id']);
		break;
		case 'showcat':
			$segments[] = 'category';
			$database->setQuery("SELECT `name` FROM `#__rssfactory_nestedcategories` WHERE `id`='".$database->getEscaped($id)."'");
			$categoryTitle = $database->loadResult();
			$segments[] = JFilterOutput::stringURLSafe($categoryTitle);
			$segments[] = $id;

				if(isset($query['activeSource']))
				{
					$segments[] = 'source';
					$database->setQuery("SELECT `title` FROM `#__rssfactory` WHERE `id`='".$database->getEscaped($query['activeSource'])."'");
					$sourceTitle = $database->loadResult();
					$segments[] = $sourceTitle ? JFilterOutput::stringURLSafe($sourceTitle) : 'source';
					$segments[] = $query['activeSource'];

					if(isset($query['start']))
					{
						$segments[] = 'page';
						$segments[] = $query['start'];
						unset($query['start']);
					}
				}
				unset($query['activeSource']);

			unset($query['id']);
		break;
		case 'visit':
//			$segments[] = 'story';
//			$database->setQuery("SELECT `item_title` FROM `#__rssfactory_cache` WHERE `id`='".$database->getEscaped($id)."'");
//			$storyTitle = $database->loadResult();
//			$segments[] = JFilterOutput::stringURLSafe($storyTitle);
//			$segments[] = $id;
//			unset($query['id']);
			
			$segments[] = 'category';
			$database->setQuery("SELECT cat.id AS categoryId,cat.name AS categoryName, c.id AS storyId, c.item_title AS storyTitle
									FROM `#__rssfactory_nestedcategories` AS cat											
									LEFT JOIN `#__rssfactory` AS r
										ON cat.id=r.cat
									LEFT JOIN `#__rssfactory_cache` AS c
										ON r.id=c.rssid
									WHERE c.id='".$database->getEscaped($id)."'");
			$details = $database->loadObject();
			$segments[] = JFilterOutput::stringURLSafe($details->categoryName);
			$segments[] = $details->categoryId;
			$segments[] = JFilterOutput::stringURLSafe($details->storyTitle);
			$segments[] = $details->storyId;
			unset($query['id']);
		break;
		case 'getModalStory':
			$segments[] = 'modal';
			$database->setQuery("SELECT `item_title` FROM `#__rssfactory_cache` WHERE `id`='".$database->getEscaped($id)."'");
			$storyTitle = $database->loadResult();
			$segments[] = JFilterOutput::stringURLSafe($storyTitle);
			$segments[] = $id;
			unset($query['id']);
		break;
		case 'submitFeeds':
			$segments[] = 'submitFeeds';
		break;
	}
	unset($query['task']);
	unset($query['view']);
	unset($query['layout']);

	return $segments;
}

function rssfactory_proParseRoute($segments)
{
	$vars = array();

	switch($segments[0])
	{
		case 'categories':
			$vars['task'] = 'categories';
			$vars['id'] = (isset($segments[2])) ? $segments[2] : 0;
		break;
		case 'category':
			if(count($segments)==5){
				$vars['task'] = 'visit';
				$vars['id'] = $segments[4];
			}
			else{
				$vars['task'] = 'showcat';
				$vars['id'] = isset($segments[2]) ? $segments[2] : 0;
				if(isset($segments[3]) && $segments[3]=='source')
				{
					$vars['activeSource'] = $segments[5];
					if(isset($segments[7]) && $segments[6]=='page')
					{
						$vars['limitstart'] = $segments[7];
					}
				}
				$vars['forcecategory']=1;
			}
		break;
		case 'story':
			$vars['task'] = 'visit';
			$vars['id'] = $segments[2];
		break;
		case 'modal':
			$vars['task'] = 'getModalStory';
			$vars['id'] = $segments[2];
		break;
		case 'submitFeeds':
			$vars['task'] = 'submitFeeds';
		break;
	}
//echo '<pre>';var_dump($segments);var_dump($vars);exit('bitch');
	return $vars;
}
?>