<?php
defined('_JEXEC') or die('Restricted access.');

class RFProViewDisplayStoriesTiles extends RFPROView
{
	function display($layoutType,$tpl=null)
	{
		global $mainframe;

		$config =& RFProHelper::getConfig();
		$document =& JFactory::getDocument();

		$model =& $this->getModel('feedSourcesTiles');
		$category = $model->getParentCategory();

		//get stories from db
		$storiesBySource = $model->getStories();

		$modelPrepareOutput =& $this->getModel('prepareStoriesOutput');

		foreach($storiesBySource as $k=>$source)
		{
			$modelPrepareOutput->storiesPrepareOutput($source['stories']);
			$storiesBySource[$k] = 	$source;
		}

		$this->assignRef('storiesBySource',$storiesBySource);

		switch($layoutType)
		{
			case 'tiled':
				$document->addStyleSheet(RSS_FACTORY_COMPONENT_URI.'views/displaystoriestiles/tmpl/css/tiled.css');
			break;
			case 'tabbed':
				jimport('joomla.html.pane');
				$params = array();
				//if the page is changed in one tab, let's have it opened
				$pane = &JPane::getInstance('Tabs',$params);
				$this->assignRef('pane',$pane);
			break;
			case 'slider':
				jimport('joomla.html.pane');
				$params = array();
				$params['useCookies']=true;
				$params['allowAllClose'] = true;
				$params['startTransition'] = true;
				//if the page is changed in one slider, let's have it opened
				$pane = &JPane::getInstance('Sliders',$params);
				$this->assignRef('pane',$pane);

				$document->addStyleSheet(RSS_FACTORY_COMPONENT_URI.'views/displaystoriestiles/tmpl/css/slider.css');
			break;
			case 'dragdiv':
				JHTML::_('behavior.mootools');
				$sort_handles = array();

				$handles='[';
				foreach($storiesBySource as $sourceId=>$source)
				{
					//building the JS handlers array
					$handles.='$(\''.'rfpro_sort_handle_'.$sourceId.'\'),';
				}
				$handles=trim($handles,',');
				$handles.=']';

$js = <<<JS
window.addEvent('domready', function(){
				var rfpro_sortable_div_list = $('rfpro_dragdiv_list');

				new Sortables(rfpro_sortable_div_list,{handles:$handles,
								onComplete:rfpro_set_order,
								revert: true,
								revertOptions: {duration: 500}
});
			});

function rfpro_set_order(catid)
{
	var d = document.getElementById('rfpro_dragdiv_list');

	var order = '';
	for(var i=0;i<d.childNodes.length;i++){
		var id = d.childNodes[i].id;
		if(typeof(id)!='undefined'){
			var temp = id.split('_');
			if(temp[0]=='rfpro' && temp[1]=='dragdiv'){
				order = order + temp[2] + ',';
			}
		}
	}

	//trim the last komma
	order = order.replace(/\,*$/,'');

	setCookie('rfpro_dragdiv_orderlist_' + {$category->id},order,365);
}
JS;
				$document->addScriptDeclaration($js);
				$document->addScript(RSS_FACTORY_COMPONENT_URI.'views/displaystories/tmpl/js/default_dragdiv.js');

				echo '<input type="hidden" name="rfproCurrentCategory" id="rfproCurrentCategory" value="'.$category->id.'" />';
			break;
		}

		$config->showfeeddescription = JRequest::getVar('forcefeeddescription',$config->showfeeddescription,'default','string');
		switch($config->showfeeddescription)
		{
			case 'tooltip':
				$params = array('showDelay'=>1000,'hideDelay'=>1000,'fixed'=>false);
				JHTML::_('behavior.tooltip','.hasTip',$params);
			break;
			case 'modal':
				JHTML::_('behavior.modal','a.feedtablelink');
			break;
		}
		if('modal' == $config->output_iframe)
		{
			JHTML::_('behavior.modal','a.feedtablelink');
		}

		$storyTmpl = RSS_FACTORY_LAYOUTS_PATH.DS.'stories'.DS.strtolower($config->showfeeddescription).'.php';
		$adTmpl = RSS_FACTORY_LAYOUTS_PATH.DS.'ads'.DS.'ad.php';

		$this->assignRef('storyTmpl',$storyTmpl);
		$this->assignRef('adTmpl',$adTmpl);
		
		$this->addTemplatePath(RSS_FACTORY_COMPONENT_PATH.DS.'views'.DS.'_plugins'.DS.'replacecontent'.DS.'displaystoriestiles'.DS.'tmpl');
		$this->setLayout($layoutType);

		parent::display($tpl);
	}
}
?>