<?php
defined('_JEXEC') or die('Restricted access.');

class RFProViewDisplayStoriesTiles extends RFPROView
{
	function display($liststyle,$tpl=null)
	{
		global $mainframe;

		$document =& JFactory::getDocument();
		$config =& RFProHelper::getConfig();

		$model =& $this->getModel('feedsourcestiles');

		$storiesBySource =& $model->getStories();
		//prepare stories for output
		$modelPrepareOutput =& $this->getModel('prepareStoriesOutput');

		foreach($storiesBySource as $k=>$source)
		{
			$modelPrepareOutput->storiesPrepareOutput($source['stories']);
			$storiesBySource[$k] = 	$source;
		}

		$this->assignRef('storiesBySource',$storiesBySource);

		$this->assignRef('pageNavs',$model->getPagination());

		$category = $model->getParentCategory();
		if($category->id)
		{
			$document->setTitle($mainframe->getCfg('sitename') . ' - ' . $category->name);
			$document->setDescription($mainframe->getCfg('sitename'). ' - ' . $category->description);
		}
		

		switch($liststyle)
		{
			case 'tiled':
				$document->addStyleSheet(RSS_FACTORY_COMPONENT_URI.'views/displaystoriestiles/tmpl/css/tiled.css');
			break;
			case 'tabbed':
				jimport('joomla.html.pane');
				$params = array();
				//if the page is changed in one tab, let's have it opened
				$params['startOffset'] = RFProHelper::getOpenedPane($storiesBySource,'tab');
				$pane = &JPane::getInstance('Tabs',$params);
				$this->assignRef('pane',$pane);
			break;
			case 'slider':
				jimport('joomla.html.pane');
				$params = array();
				$params['useCookies']=true;
				$params['allowAllClose'] = true;
				$params['startTransition'] = true;
				//if the page is changed in one slider, let's have it opened
				$params['startOffset'] = RFProHelper::getOpenedPane($storiesBySource,'slider');
				$pane = &JPane::getInstance('Sliders',$params);
				$this->assignRef('pane',$pane);

				$document->addStyleSheet(RSS_FACTORY_COMPONENT_URI.'views/displaystoriestiles/tmpl/css/slider.css');
			break;
			case 'dragdiv':
				JHTML::_('behavior.mootools');
				$sort_handles = array();

				$handles='[';
				foreach($storiesBySource as $sourceId=>$source)
				{
					//building the JS handlers array
					$handles.='$(\''.'rfpro_sort_handle_'.$sourceId.'\'),';
				}
				$handles=trim($handles,',');
				$handles.=']';

$js = <<<JS

window.addEvent('domready', function(){
				var rfpro_sortable_div_list = $('rfpro_dragdiv_list');

				new Sortables(rfpro_sortable_div_list,{handles:$handles,
								onComplete:rfpro_set_order,
								revert: true,
								revertOptions: {duration: 500}
});
			});

function rfpro_set_order(catid)
{
	var d = document.getElementById('rfpro_dragdiv_list');

	var order = '';
	for(var i=0;i<d.childNodes.length;i++){
		var id = d.childNodes[i].id;
		if(typeof(id)!='undefined'){
			var temp = id.split('_');
			if(temp[0]=='rfpro' && temp[1]=='dragdiv'){
				order = order + temp[2] + ',';
			}
		}
	}

	//trim the last komma
	order = order.replace(/\,*$/,'');

	setCookie('rfpro_dragdiv_orderlist_' + '{$category->id}',order,365);
}
JS;
				$document->addScriptDeclaration($js);
				$document->addScript(RSS_FACTORY_COMPONENT_URI.'views/displaystoriestiles/tmpl/js/dragdiv.js');

				echo '<input type="hidden" name="rfproCurrentCategory" id="rfproCurrentCategory" value="'.$category->id.'" />';
			break;
		}

		$this->setLayout($liststyle);

		$config->showfeeddescription = JRequest::getVar('forcefeeddescription',$config->showfeeddescription,'default','string');
		switch($config->showfeeddescription)
		{
			case 'tooltip':
				$params = array('showDelay'=>500,'hideDelay'=>10,'fixed'=>false);
				JHTML::_('behavior.tooltip','.hasTip',$params);
			break;
			case 'modal':
				JHTML::_('behavior.modal','a.feedtablelink');
			break;
		}
		if('modal' == $config->output_iframe)
		{
			JHTML::_('behavior.modal','a.feedtablelink');
		}

		$storyTmpl = RSS_FACTORY_LAYOUTS_PATH.DS.'stories'.DS.strtolower($config->showfeeddescription).'.php';
		$adTmpl = RSS_FACTORY_LAYOUTS_PATH.DS.'ads'.DS.'ad.php';

		$this->assignRef('storyTmpl',$storyTmpl);
		$this->assignRef('adTmpl',$adTmpl);

		parent::display($tpl);
	}
}
?>