  <?php
/**
* @package rssFactory
* @version 1.5
* @copyright www.thefactory.ro
*/

function com_install() {
  	global $mainframe;
	$database = &JFactory::getDBO();

	$database->setQuery("SELECT COUNT(id) FROM #__components WHERE `option`='com_rssfactory'");
	$res = $database->loadResult();
	if($res){
		JError::raiseNotice('404','First uninstall the free version of Rss Factory before installing PRO!');
		$mainframe->redirect('index.php?option=com_installer');
		exit();
	}

	$configFile = JPATH_ROOT.DS.'administrator'.DS."components".DS."com_rssfactory_pro".DS.'config'.DS."config.php";
	if(file_exists($configFile))
	{
		require_once($configFile);
	}

	//install modules
	copyExtraExtension('module*rssfactory_pro',RSS_FACTORY_COMPONENT_NAME);
	$database->setQuery(
		"INSERT INTO `#__modules` VALUES ('', 'RSSFactory MODULE','',0, 'left',0,'0000-00-00 00:00:00',0, 'mod_rssfactory_pro',0,0,1,'
			moduleclass_sfx= \n
			sort_order=1\n
			nr_feeds=10\n
			nrchars=30\n
			show_Category=\n
			showfeeddescription=table\n
			table_view_open=0\n
			hide_icon=1\n
			hide_date=0\n
			hide_bullet=0\n
			adv_filter=1\n
			catid1=0\n
			show_Category1=\n
			catid2=0\n
			show_Category2=\n
			catid3=0\n
			show_Category3=\n
			catid4=0\n
			show_Category4=\n
			catid5=0\n
			show_Category5=\n
			catid6=0\n
			show_Category6=\n
			catid7=0\n
			show_Category7=\n
			catid8=0\n
			show_Category8=\n
			catid9=0\n
			show_Category9=\n
		',0,0,'')"
	);
	$database->query();
	
	copyExtraExtension('module*rfpro_cattree',RSS_FACTORY_COMPONENT_NAME);
	$database->setQuery("INSERT INTO `#__modules` VALUES ('', 'RSSFactory Category Tree','',0, 'left',0,'0000-00-00 00:00:00',0, 'mod_rfpro_cattree',0,0,1,'',0,0,'')");
	$database->query();
	//end install modules
	
	//install search plugin
	copyExtraExtension('plugin*search*rssfactory.searchbot',RSS_FACTORY_COMPONENT_NAME);

	$database->setQuery("
		INSERT INTO `#__plugins` VALUES ('', 'RSSfactory searchbot','rssfactory.searchbot',
		'search',0,0,0,0,0,0,'0000-00-00 00:00:00','')
		");
	$database->query();
	//end install plugin

	//install replace plugin
	copyExtraExtension('plugin*content*rssfactory_replacebot',RSS_FACTORY_COMPONENT_NAME);

	$database->setQuery("
		INSERT INTO `#__plugins` VALUES ('', 'rssFactory Content Replace Bot','rssfactory_replacebot',
		'content',0,0,0,0,0,0,'0000-00-00 00:00:00','')
		");
	$database->query();
	//end install plugin

	//display succesful installation
	$configFile = JPATH_ROOT.DS.'administrator'.DS."components".DS."com_rssfactory_pro".DS.'config'.DS."config.php";
	if(file_exists($configFile))
	{
		require_once($configFile);
	}
	require_once(JPATH_ADMINISTRATOR.DS."components".DS."com_rssfactory_pro".DS."version_info.php");
    $version = new component_version_info('com_'.RSS_FACTORY_COMPONENT_NAME);
		?>
		<table class="adminform">
			<tr>
				<td>
				<p>
				Thank you for using RSSFactory PRO.<br />
                <sub>this version is only for Joomla 1.5!</sub>
				<strong>Please set up your feeds and Ads in the admin panel. <br/>
					The RSS Factory module, the search plugin and repalce plugin are also installed.<br/>
					If you need them - Enable The Module and/or Plugins in your admin panel
				</strong></p>
				<br />
				<br />
				<p> Release Notes:<br />
				 <br />
                <?php echo $version->releasenotes;?>
				</p>
				<p><strong>RSSFactory PRO</strong> Component <em>for Joomla 1.5 CMS</em> <br />
				Visit us at <a target="_blank" href="http://www.thefactory.ro">thefactory.ro</a> to learn  about new versions
				and/or to give us feedback<br />
				(c) 2006-2008 The Factory
				</td>
			</tr>
		</table>
		<?php
}

function copyExtraExtension($extensionData,$componentName)
{
	$extensionSourcePath = JPATH_ROOT.DS.'components'.DS.'com_'.$componentName.DS;
	$extensionDestinationPath = JPATH_ROOT.DS;

	$data = explode('*',$extensionData);

	switch($data[0])
	{
		case 'module':
			$extensionSourcePath .= 'modules'.DS.'mod_'.$data[1];
			$extensionDestinationPath .= 'modules'.DS.'mod_'.$data[1];
			JFolder::move($extensionSourcePath,$extensionDestinationPath);
		break;
		case 'plugin':
			$extensionSourcePath .= 'plugins'.DS.$data[1];
			$extensionDestinationPath .= 'plugins'.DS.$data[1];
			foreach(JFolder::files($extensionSourcePath) as $file){
				JFile::copy($extensionSourcePath.DS.$file, $extensionDestinationPath.DS.$file);
			}
		break;
	}
}
?>